﻿-- ==========================================================================================================================================================================
-- Adattisztítás szabályok
-- ==========================================================================================================================================================================
SET IDENTITY_INSERT T_ADATTISZTITASINDIKATOR ON

INSERT INTO T_ADATTISZTITASINDIKATOR (ID, C_KOD, C_ADATKOR, C_MEZO, C_LEIRAS) VALUES 
  (1,  'A001', 'Alkalmazott', N'Neme', 'A mező tartalma üres.'),
  (2,  'A002', 'Alkalmazott', N'Családi név', 'A mező tartalma üres vagy 2 karakternél rövidebb.'),
  (3,  'A003', 'Alkalmazott', N'Utónév', 'A mező tartalma üres vagy 2 karakternél rövidebb.'),
  (4,  'A004', 'Alkalmazott', N'Születési családi név', 'A mező tartalma üres vagy 2 karakternél rövidebb.'),
  (5,  'A005', 'Alkalmazott', N'Születési utónév', 'A mező tartalma üres vagy 2 karakternél rövidebb.'),
  (6,  'A006', 'Alkalmazott', N'Anyja születési családi neve', 'A mező tartalma üres vagy 2 karakternél rövidebb.'),
  (7,  'A007', 'Alkalmazott', N'Anyja születési utóneve', 'A mező tartalma üres vagy 2 karakternél rövidebb.'),
  (8,  'A008', 'Alkalmazott', N'Születési hely', 'A mező tartalma üres.'),
  (9,  'A009', 'Alkalmazott', N'Születési idő', 'A mező tartalma üres vagy a születési dátum 1940 előtti vagy 2002 utáni.'),
  (10, 'A010', 'Alkalmazott', N'Igazolvány száma', 'Az Igazolvány típusa meg van adva, de az igazolvány száma nincs kitöltve.'),
  (11, 'A011', 'Alkalmazott', N'Adóazonosító jel', 'Az adóazonosító jel ki van töltve de nem felel meg a hivatalos generálási szabályoknak (CDV).'),
  (12, 'A012', 'Alkalmazott', N'Cím típusa', 'A mező tartalma üres vagy Na.'),
  (13, 'A013', 'Alkalmazott', N'Irányítószám', 'A mező tartalma üres.'),
  (14, 'A014', 'Alkalmazott', N'Irányítószám', 'Az irányítószám nem szerepel a postai nyílvántartásban.'),
  (15, 'A015', 'Alkalmazott', N'Irányítószám', 'Az irányítószám nem a megadott helységnévhez tartozik.'),
  (16, 'A016', 'Alkalmazott', N'Helység név', 'A mező tartalma üres.'),
  (17, 'A017', 'Alkalmazott', N'Helység név', 'A helységénv nem szerepel a postai nyílvántartásban.'),
  (18, 'A018', 'Alkalmazott', N'Közterület név', 'A mező tartalma üres.'),
  (19, 'A019', 'Alkalmazott', N'Közterület jellege', 'A mező tartalma üres vagy Na.'),
  (20, 'A020', 'Alkalmazott', N'Házszám', 'A mező tartalma üres.'),
  (21, 'A021', 'Alkalmazott', N'Telefonszám', 'A telefonszám hossza 10 számjegynél kevesebb („-„, „/”, stb. nélkül).'),
  (22, 'A022', 'Alkalmazott', N'Email cím', 'A mezőben lévő érték nem tartalmatartalmaz "@ és/vagy „.” karaktert.'),
  (23, 'A023', 'Alkalmazott', N'Email típus', 'Az Email cím nem üres, és az ellenőrzött mező tartalma Na vagy üres.'),
  (24, 'A024', 'Alkalmazott', N'Diákolimpiai jogosultság', 'A mező tartalma üres.'),
  (25, 'A025', 'Alkalmazott', N'Kezelheti a közösségi szolgálatokat', 'A mező tartalma üres.'),
  (26, 'A026', 'Alkalmazott', N'Munkakör', 'A mező tartalma üres vagy Na.'),
  (27, 'A027', 'Alkalmazott', N'Munkakör', 'A értéke nem a legördülő listában - a fenntartó által megjelölt - található értékkészletnek felel meg.'),
  (28, 'A028', 'Alkalmazott', N'Foglalkoztatási jogviszony', 'A mező tartalma üres vagy Na.'),
  (29, 'A029', 'Alkalmazott', N'Részmunkaidő százalék', 'A Foglalkoztatás típusa mező tartalma Részmunkaidős de a Részmunkaidő százalék értéke nem 1-99 % közötti.'),
  (30, 'A030', 'Alkalmazott', N'Alkalmazás kezdete', 'A mező tartalma üres.'),
  (31, 'A031', 'Alkalmazott', N'Alkalmazás kezdete', 'A Munkakör hittanoktató vagy az előtag tartalmazza a KA vagy BTA vagy KGK megnevezést és az Alkalmazás kezdete mező tartalma nem üres.'),
  (32, 'A032', 'Alkalmazott', N'Alkalmazás vége', 'A mező tartalma üres.'),
  (33, 'A033', 'Alkalmazott', N'Alkalmazás vége', 'A Munkakör hittanoktató vagy az előtag tartalmazza a KA vagy BTA vagy KGK megnevezést és az Alkalmazás vége mező tartalma nem üres.'),
  (34, 'A034', 'Alkalmazott', N'Tartósan távollévő', 'A mező tartalma üres.'),
  (35, 'A035', 'Alkalmazott', N'Betöltetlen álláshely', 'A jelölőnégyzet be van pipálva de az előtag nem tartalmazza BTA megnevezést. Vagy jelölőnégyzet nincs bepipálva de az előtag tartalmazza BTA megnevezést.'),
  (36, 'A036', 'Alkalmazott', N'Betöltetlen álláshely', 'A mező tartalma üres.'),
  (37, 'A037', 'Alkalmazott', N'Főállású', 'A mező tartalma üres.'),
  (38, 'A038', 'Alkalmazott', N'Nyugdíjas (továbbfoglalkoztatott)', 'A mező tartalma üres.'),
  (39, 'A039', 'Alkalmazott', N'Szakértői, vagy vizsgaelnöki tevékenységű', 'A mező tartalma üres.'),
  (40, 'A040', 'Alkalmazott', N'Szakértői, vagy vizsgaelnöki tevékenységű', 'A mező tartalma TRUE és a Pedagógus fokozat Na.'),
  (41, 'A041', 'Alkalmazott', N'Szakmai továbbképzés', 'A mező tartalma üres.'),
  (42, 'A042', 'Alkalmazott', N'Szakmai továbbképzés', 'A jelölőnégyzet be van pipálva de a Pedagógus fokozat Na.'),
  (43, 'A043', 'Alkalmazott', N'Szakvizsga', 'A mező tartalma üres.'),
  (44, 'A044', 'Alkalmazott', N'Szakvizsga', 'A jelölőnégyzet be van pipálva de a Pedagógus fokozat Na.'),
  (45, 'A045', 'Alkalmazott', N'Áttanító', 'A mező tartalma üres.'),
  (46, 'A046', 'Alkalmazott', N'Áttanító', 'A jelölőnégyzet be van pipálva de a Pedagógus fokozat nem Na.'),
  (47, 'A047', 'Alkalmazott', N'Áttanító más intézménynél', 'A mező tartalma üres.'),
  (48, 'A048', 'Alkalmazott', N'Áttanító más intézménynél', 'A jelölőnégyzet be van pipálva de a Pedagógus fokozat nem Na.'),
  (49, 'A049', 'Alkalmazott', N'SZTSZ számok', 'A mező tartalma üres.')

SET IDENTITY_INSERT T_ADATTISZTITASINDIKATOR OFF
GO

