﻿DROP FUNCTION IF EXISTS dbo.fnGetBankszamlaVezetoBank;  
GO

CREATE FUNCTION fnGetBankszamlaVezetoBank (@bankszamlaszam NVARCHAR(25))
RETURNS NVARCHAR(MAX)
BEGIN 
DECLARE @Nev NVARCHAR(MAX)
  SELECT @Nev =
    CASE SUBSTRING(@bankszamlaszam, 1, 3)
      WHEN '807' THEN 'Általános Közlekedési Hitelszövetkezet'
      WHEN '187' THEN 'Banco Primus Fióktelep, Magyarország'
      WHEN '175' THEN 'Bank of China (CEE) Zrt.'      
      WHEN '197' THEN 'Bank of China (CEE) Zrt.'      
      WHEN '179' THEN 'Bank Plus Bank Zrt.'
      WHEN '131' THEN 'BNP Paribas Hungária Bank Zrt.'
      WHEN '178' THEN 'BNP Paribas Magyarországi Fióktelepe'
      WHEN '183' THEN 'BNP Paribas Magyarországi Fióktelepe'
      WHEN '186' THEN 'BNP Paribas Securities Services'
      WHEN '194' THEN 'BORGUN hf.'
      WHEN '136' THEN 'CaLyon Bank Magyarország Zrt.'
      WHEN '185' THEN 'CaLyon S.A. Magyarország Bankfióktelep'
      WHEN '107' THEN 'CIB Bank Zrt. (CIB Közép-Európai Nemzetközi Bank Zrt.)'
      WHEN '111' THEN 'CIB Bank Zrt. (Inter-Európa Bank Zrt.)'
      WHEN '108' THEN 'Citibank (Citibank Europe)'
      WHEN '196' THEN 'CLS Bank International'
      WHEN '180' THEN 'Cofidis Magyarországi Fióktelep'
      WHEN '142' THEN 'Commerzbank Zrt.'
      WHEN '172' THEN 'Credigen Bank Zrt.'
      WHEN '163' THEN 'Deutsche Bank AG Zrt.'
      WHEN '177' THEN 'Dresdner Bank AG Magyarországi Fióktelepe'
      WHEN '586' THEN 'DUNA Takarék Bank Zrt.'
      WHEN '199' THEN 'eCOMM Merchant Solutions Ltd.'
      WHEN '125' THEN 'Erste Bank Zrt.'
      WHEN '119' THEN 'Erste Bank Zrt.'
      WHEN '116' THEN 'Erste Bank Zrt.'
      WHEN '193' THEN 'Euronet 360 Finance Limited'
      WHEN '148' THEN 'Eximbank Zrt.'
      WHEN '883' THEN 'Fundamenta Lakáskassza Lakástakarékpénztár Zrt.'
      WHEN '882' THEN 'Fundamenta Lakáskassza Lakástakarékpénztár Zrt.'
      WHEN '880' THEN 'Fundamenta Lakáskassza Lakástakarékpénztár Zrt.'
      WHEN '121' THEN 'Gránit Bank Zrt.'
      WHEN '147' THEN 'IC Bank Zrt.'
      WHEN '118' THEN 'iCard AD'
      WHEN '137' THEN 'ING Bank Magyarország Zrt.'
      WHEN '135' THEN 'KDB Bank Európa Zrt.'
      WHEN '888' THEN 'K&H Jelzálogbank Zrt.'
      WHEN '102' THEN 'K&H Bank Zrt. (Kereskedelmi és Hitelbank Zrt.)'
      WHEN '104' THEN 'K&H Bank Zrt. (Kereskedelmi és Hitelbank Zrt.)'
      WHEN '144' THEN 'KELER Zrt. (Központi Elszámolóház és Értéktár Zrt.)'
      WHEN '296' THEN 'Libra Internet Bank S.A.'
      WHEN '162' THEN 'MagNet Bank Zrt.'
      WHEN '146' THEN 'Magyar  Fejlesztési Bank Zrt.'
      WHEN '100' THEN 'Magyar Államkincstár'
      WHEN '167' THEN 'Magyar Cetelem Bank Zrt.'
      WHEN '190' THEN 'Magyar Nemzeti Bank'
      WHEN '115' THEN 'Magyar Takarékszövetkezeti Bank Zrt.'
      WHEN '500' THEN 'Magyar Takarékszövetkezeti Bank Zrt.'
      WHEN '128' THEN 'Merkantil Bank Zrt.'
      WHEN '101' THEN 'MKB Bank Nyrt. (Budapest Bank Zrt.)'
      WHEN '103' THEN 'MKB Bank Nyrt. (Magyar Külkereskedelmi Bank)'
      WHEN '114' THEN 'NHB Növekedési Hitel Bank Zrt.'
      WHEN '184' THEN 'Oberbank AG Magyarországi Fióktelepe'
      WHEN '222' THEN 'Országos Fizetési Szolgáltató Zrt.'
      WHEN '117' THEN 'OTP Bank Nyrt.'
      WHEN '170' THEN 'OTP Bank Nyrt.'
      WHEN '884' THEN 'OTP Jelzálogbank Zrt.'
      WHEN '881' THEN 'OTP Lakástakarékpénztár Zrt.'
      WHEN '200' THEN 'OTP Pénztárszolgáltató Zrt.'
      WHEN '151' THEN 'Paystrax UAB'
      WHEN '612' THEN 'Polgári Bank Zrt.'
      WHEN '160' THEN 'Porsche Bank Hungária Zrt.'
      WHEN '903' THEN 'Postai Elszámoló Központ'
      WHEN '120' THEN 'Raiffeisen Bank Zrt.'
      WHEN '506' THEN 'Siklós és Vidéke Takarékszövetkezet, Siklós'
      WHEN '527' THEN 'Soltvadkert és Vidéke Takarékszövetkezet, Soltvadkert'
      WHEN '176' THEN 'Sopron Bank Zrt.'
      WHEN '808' THEN 'Széchenyi István Hitelszövetkezet'
      WHEN '168' THEN 'Takarék Jelzálogbank Nyrt.'
      WHEN '501' THEN 'Takarékbank Zrt.'
      WHEN '504' THEN 'Takarékbank Zrt.'
      WHEN '507' THEN 'Takarékbank Zrt.'
      WHEN '508' THEN 'Takarékbank Zrt.'
      WHEN '510' THEN 'Takarékbank Zrt.'
      WHEN '511' THEN 'Takarékbank Zrt.'
      WHEN '512' THEN 'Takarékbank Zrt.'
      WHEN '514' THEN 'Takarékbank Zrt.'
      WHEN '515' THEN 'Takarékbank Zrt.'
      WHEN '517' THEN 'Takarékbank Zrt.'
      WHEN '519' THEN 'Takarékbank Zrt.'
      WHEN '520' THEN 'Takarékbank Zrt.'
      WHEN '523' THEN 'Takarékbank Zrt.'
      WHEN '525' THEN 'Takarékbank Zrt.'
      WHEN '526' THEN 'Takarékbank Zrt.'
      WHEN '528' THEN 'Takarékbank Zrt.'
      WHEN '531' THEN 'Takarékbank Zrt.'
      WHEN '532' THEN 'Takarékbank Zrt.'
      WHEN '533' THEN 'Takarékbank Zrt.'
      WHEN '535' THEN 'Takarékbank Zrt.'
      WHEN '536' THEN 'Takarékbank Zrt.'
      WHEN '537' THEN 'Takarékbank Zrt.'
      WHEN '540' THEN 'Takarékbank Zrt.'
      WHEN '542' THEN 'Takarékbank Zrt.'
      WHEN '543' THEN 'Takarékbank Zrt.'
      WHEN '545' THEN 'Takarékbank Zrt.'
      WHEN '546' THEN 'Takarékbank Zrt.'
      WHEN '551' THEN 'Takarékbank Zrt.'
      WHEN '554' THEN 'Takarékbank Zrt.'
      WHEN '556' THEN 'Takarékbank Zrt.'
      WHEN '558' THEN 'Takarékbank Zrt.'
      WHEN '568' THEN 'Takarékbank Zrt.'
      WHEN '569' THEN 'Takarékbank Zrt.'
      WHEN '571' THEN 'Takarékbank Zrt.'
      WHEN '574' THEN 'Takarékbank Zrt.'
      WHEN '576' THEN 'Takarékbank Zrt.'
      WHEN '577' THEN 'Takarékbank Zrt.'
      WHEN '578' THEN 'Takarékbank Zrt.'
      WHEN '581' THEN 'Takarékbank Zrt.'
      WHEN '589' THEN 'Takarékbank Zrt.'
      WHEN '590' THEN 'Takarékbank Zrt.'
      WHEN '591' THEN 'Takarékbank Zrt.'
      WHEN '592' THEN 'Takarékbank Zrt.'
      WHEN '593' THEN 'Takarékbank Zrt.'
      WHEN '595' THEN 'Takarékbank Zrt.'
      WHEN '596' THEN 'Takarékbank Zrt.'
      WHEN '598' THEN 'Takarékbank Zrt.'
      WHEN '599' THEN 'Takarékbank Zrt.'
      WHEN '606' THEN 'Takarékbank Zrt.'
      WHEN '614' THEN 'Takarékbank Zrt.'
      WHEN '616' THEN 'Takarékbank Zrt.'
      WHEN '620' THEN 'Takarékbank Zrt.'
      WHEN '621' THEN 'Takarékbank Zrt.'
      WHEN '623' THEN 'Takarékbank Zrt.'
      WHEN '626' THEN 'Takarékbank Zrt.'
      WHEN '627' THEN 'Takarékbank Zrt.'
      WHEN '628' THEN 'Takarékbank Zrt.'
      WHEN '629' THEN 'Takarékbank Zrt.'
      WHEN '632' THEN 'Takarékbank Zrt.'
      WHEN '633' THEN 'Takarékbank Zrt.'
      WHEN '636' THEN 'Takarékbank Zrt.'
      WHEN '638' THEN 'Takarékbank Zrt.'
      WHEN '640' THEN 'Takarékbank Zrt.'
      WHEN '647' THEN 'Takarékbank Zrt.'
      WHEN '648' THEN 'Takarékbank Zrt.'
      WHEN '651' THEN 'Takarékbank Zrt.'
      WHEN '660' THEN 'Takarékbank Zrt.'
      WHEN '669' THEN 'Takarékbank Zrt.'
      WHEN '670' THEN 'Takarékbank Zrt.'
      WHEN '676' THEN 'Takarékbank Zrt.'
      WHEN '678' THEN 'Takarékbank Zrt.'
      WHEN '679' THEN 'Takarékbank Zrt.'
      WHEN '680' THEN 'Takarékbank Zrt.'
      WHEN '682' THEN 'Takarékbank Zrt.'
      WHEN '685' THEN 'Takarékbank Zrt.'
      WHEN '687' THEN 'Takarékbank Zrt.'
      WHEN '688' THEN 'Takarékbank Zrt.'
      WHEN '693' THEN 'Takarékbank Zrt.'
      WHEN '694' THEN 'Takarékbank Zrt.'
      WHEN '695' THEN 'Takarékbank Zrt.'
      WHEN '698' THEN 'Takarékbank Zrt.'
      WHEN '701' THEN 'Takarékbank Zrt.'
      WHEN '703' THEN 'Takarékbank Zrt.'
      WHEN '704' THEN 'Takarékbank Zrt.'
      WHEN '705' THEN 'Takarékbank Zrt.'
      WHEN '706' THEN 'Takarékbank Zrt.'
      WHEN '709' THEN 'Takarékbank Zrt.'
      WHEN '718' THEN 'Takarékbank Zrt.'
      WHEN '719' THEN 'Takarékbank Zrt.'
      WHEN '721' THEN 'Takarékbank Zrt.'
      WHEN '726' THEN 'Takarékbank Zrt.'
      WHEN '727' THEN 'Takarékbank Zrt.'
      WHEN '728' THEN 'Takarékbank Zrt.'
      WHEN '729' THEN 'Takarékbank Zrt.'
      WHEN '732' THEN 'Takarékbank Zrt.'
      WHEN '736' THEN 'Takarékbank Zrt.'
      WHEN '739' THEN 'Takarékbank Zrt.'
      WHEN '740' THEN 'Takarékbank Zrt.'
      WHEN '745' THEN 'Takarékbank Zrt.'
      WHEN '750' THEN 'Takarékbank Zrt.'
      WHEN '755' THEN 'Takarékbank Zrt.'
      WHEN '757' THEN 'Takarékbank Zrt.'
      WHEN '806' THEN 'Takarékbank Zrt.'
      WHEN '181' THEN 'Takarékbank Zrt. (Allianz Bank Zrt.)'
      WHEN '644' THEN 'Takarékbank Zrt. (Alsónémedi és Vidéke Takarékszövetkezet)'
      WHEN '182' THEN 'Takarékbank Zrt. (FHB Kereskedelmi Bank Zrt.)'
      WHEN '619' THEN 'Takarékbank Zrt. (Füzesabony és Vidéke Takarékszövetkezet)'
      WHEN '603' THEN 'Takarékbank Zrt. (Hajdúdorog és Vidéke Takarékszövetkezet)'
      WHEN '503' THEN 'Takarékbank Zrt. (Mecsek-Vidéke Takarékszövetkezet)'
      WHEN '652' THEN 'Takarékbank Zrt. (Nagykáta és Vidéke Takarékszövetkezet)'
      WHEN '655' THEN 'Takarékbank Zrt. (Örkényi Takarékszövetkezet)'
      WHEN '657' THEN 'Takarékbank Zrt. (Pilisvörösvár és Vidéke Takarékszövetkezet)'
      WHEN '539' THEN 'Takarékbank Zrt. (Szarvas és Vidéke Takarékszövetkezet)'
      WHEN '572' THEN 'Takarékbank Zrt. (Szegvár és Vidéke Takarékszövetkezet)'
      WHEN '803' THEN 'Takarékbank Zrt. (Tiszántúli Első Hitelszövetkezet)'
      WHEN '659' THEN 'Takarékbank Zrt. (Turai Takarékszövetkezet)'
      WHEN '700' THEN 'Tiszaföldvár és Vidéke Takarékszövetkezet, Tiszaföldvár'
      WHEN '126' THEN 'TransferWise Europe SA'
      WHEN '109' THEN 'UniCredit Bank Hungary Zrt.'
      WHEN '171' THEN 'UniCredit Jelzálogbank Zrt.'
      WHEN '192' THEN 'WIRECARD Bank AG'
    END
RETURN @Nev  
END

GO