SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

IF OBJECT_ID('fnGetDokumentumOsztalyMegtartottOrakSzama') IS NOT NULL
BEGIN
  DROP FUNCTION fnGetDokumentumOsztalyMegtartottOrakSzama
END
GO

CREATE FUNCTION fnGetDokumentumOsztalyMegtartottOrakSzama (@tanevId INT, @osztalyId INT)
  RETURNS TABLE
RETURN (
  SELECT 
     naptariNap.C_NAPDATUMA AS Datum 
    ,Oraszam.Orakszama AS OrakSzama
  FROM T_NAPTARINAP_OSSZES naptariNap
  LEFT JOIN (
    SELECT  
       COUNT(DISTINCT C_ORAKEZDETE) AS Orakszama
      ,C_DATUM AS Datum
    FROM T_TANITASIORA_OSSZES 
    WHERE 
      C_OSZTALYCSOPORTID IN (SELECT ID FROM fnGetDokumentumKapcsolodoOsztalycsoportok(@osztalyId, @tanevId, DEFAULT, DEFAULT))
      AND TOROLT = 'F'
      AND C_MEGTARTOTT = 'T'
    GROUP BY C_DATUM
    ) AS Oraszam ON Oraszam.Datum = naptariNap.C_NAPDATUMA
  WHERE 
    C_TANEVID = @tanevId
    AND naptariNap.TOROLT = 'F'
)

GO
