﻿-- =============================================
-- Description:  <Ellenőrizzuk, hogy a megadott nebuló 4T alapján szerepel-e az adatbázisban>
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[sp_CheckNebulo4TValidation]
GO

CREATE PROCEDURE [dbo].[sp_CheckNebulo4TValidation]
  @pNebuloId AS INT = NULL,
  @pFelvetelStatuszaFelveve INT,
  @pVezeteknev NVARCHAR(255),
  @pUtonev NVARCHAR(255),
  @pAnyjaVezeteknev NVARCHAR(255),
  @pAnyjaUtonev NVARCHAR(255),
  @pSzuletesiHely NVARCHAR(50),
  @pSzuletesiDatum DATETIME
AS
BEGIN
  SET NOCOUNT ON;  
  
    IF 
    EXISTS  (SELECT 1
         FROM 
          T_NEBULO
         WHERE 
            TOROLT = 'F'
          AND (@pNebuloId IS NULL OR ID != @pNebuloId)
                    AND C_FELVETELSTATUSZA = @pFelvetelStatuszaFelveve
          AND C_TANULOCSALADINEVE = @pVezeteknev
                    AND C_TANULOUTONEVE = @pUtonev
                    AND C_EDESANYJASZULETESICSALADINEV = @pAnyjaVezeteknev
                    AND C_EDESANYJASZULETESIUTONEVE = @pAnyjaUtonev
                    AND C_SZULETESIHELY = @pSzuletesiHely
                    AND C_SZULETESIIDO = @pSzuletesiDatum
        )
        
        SELECT 1
    ELSE
        SELECT 0
      
END
GO
