DROP PROCEDURE IF EXISTS [dbo].[sp_GetESL_A03T02_1]
GO

CREATE PROCEDURE [dbo].[sp_GetESL_A03T02_1]
   @tanevId int
  ,@feladatEllatasiHelyId int
  ,@isFelevi int = 0
  ,@ESLTantargykategoriaTypeId int = 136
  ,@osztalyzatTipusTypeID int = 44
AS
BEGIN
  SET NOCOUNT ON;
  CREATE TABLE #TantargyiStat(
     Darabszam int
    ,OsszesLany int
    ,EslTgyKatId int
    ,Evfolyam int
    ,Sorrend int
  )

  CREATE TABLE #ErintettTanulok (
     Evfolyam int
    ,TanuloId int
    ,Neme int
    ,TanuloNev nvarchar(255)
    ,Oktatasiazonosito nvarchar(11)
    ,TanuloOsztalyNev nvarchar(255)
    ,IsKozepesMiatt int
    ,IsRontasMiatt int
    ,TanuloOsztalyId int
    ,INDEX IX_01 (TanuloId)
  )

  DECLARE @ertekelesTipus int = IIF(@isFelevi = 0,1520,1519)
  
  --1. érintett tanulók leválogatása
  INSERT INTO #ErintettTanulok (
     TanuloId
    ,Evfolyam
    ,Neme
    ,TanuloNev
    ,OktatasiAzonosito
    ,TanuloOsztalyNev
    ,TanuloOsztalyId
    ,IsKozepesMiatt
    ,IsRontasMiatt
  )
  SELECT * FROM fnGetLemorzsolodottTanulokByFelhely (@feladatEllatasiHelyId, @tanevId, @isFelevi, @osztalyzatTipusTypeID)
  
  INSERT INTO #TantargyiStat(
     Darabszam
    ,OsszesLany
    ,EslTgyKatId
    ,Evfolyam
    ,Sorrend
  )
  SELECT 
     COUNT(te.C_TANULOID) as Osszes
    ,SUM(IIF(fht.Neme=5,1,0)) as OsszesLany
    ,eslTgyKat.ID
    ,fht.Evfolyam
    ,eslTgyKat.C_ORDER
  FROM T_TANULOERTEKELES te
    INNER JOIN T_TANTARGY tgy ON tgy.ID=te.C_TANTARGYID AND (tgy.C_FOTARGYE = 'T' OR tgy.C_ALTANTARGYKENTNYOMTATVANYBAN='T') AND tgy.TOROLT='F'
    INNER JOIN #ErintettTanulok fht on fht.TANULOID=te.C_TANULOID
    INNER JOIN T_DICTIONARYITEMBASE eslTgyKat ON eslTgyKat.ID = tgy.C_ESLTANTARGYKATEGORIAID AND eslTgyKat.C_DICTIONARYTYPEID = @ESLTantargykategoriaTypeId
      AND eslTgykat.TOROLT='F' AND eslTgyKat.C_TANEVID = te.C_TANEVID
  WHERE te.C_ERTEKELESOSZTALYZATID = 1501 AND te.C_TIPUSID = @ertekelesTipus AND te.C_TANEVID = @tanevId AND te.TOROLT='F'
  GROUP BY eslTgyKat.ID,eslTgyKat.C_ORDER,fht.Evfolyam
  
  SELECT 
     SUM(Darabszam) as Osszes
    ,SUM(OsszesLany) as OsszesLany
    ,EslTgyKatId
  INTO #TantargyiStatSum
  FROM #TantargyiStat
  GROUP BY EslTgyKatId

  SELECT
     tgy.eslTgyKatId
    ,tgy.Evfolyam
    ,tgy.Darabszam
    ,s.Osszes
    ,s.OsszesLany
  FROM #TantargyiStat tgy
    INNER JOIN #TantargyiStatSum s ON s.eslTgyKatId = tgy.eslTgyKatId
  ORDER BY tgy.Sorrend,tgy.Evfolyam
  
END
GO
