DROP PROCEDURE IF EXISTS [dbo].[sp_GetFelhasznaloFoglalkozasokErtekelesekhez]
GO

-- =============================================
-- Description:  <Felhasznlhoz kthet foglalkozsok az rtkelsek szrshez>
-- =============================================

CREATE PROCEDURE [dbo].[sp_GetFelhasznaloFoglalkozasokErtekelesekhez]
   @pTanarId INT
  ,@pTanevId INT
AS
BEGIN

  SET NOCOUNT ON;

  SELECT
     foglalkozas.ID                   ID
    ,foglalkozas.C_OSZTALYCSOPORTID            OsztalyCsoportId
    ,tantargy.ID                     TantargyId
    ,tantargy.C_Nev                   TantargyNev
    ,osztalyCsoport.C_NEV + ' - ' + tantargy.C_Nev    Nev
    ,osztalyCsoport.C_EVFOLYAMTIPUSA          Evfolyam
    ,osztalyCsoport.C_NEV                OsztalyCsoportNev
    ,csoport.C_TIPUSA                  CsoportTipusId
  FROM
    T_FOGLALKOZAS_OSSZES foglalkozas
  LEFT JOIN
    T_OSZTALYCSOPORT_OSSZES osztalyCsoport ON
        osztalyCsoport.ID = foglalkozas.C_OSZTALYCSOPORTID
      AND osztalyCsoport.C_TANEVID = @pTanevId
      AND osztalyCsoport.TOROLT = 'F'
  LEFT JOIN
    T_CSOPORT_OSSZES csoport ON
        csoport.ID = foglalkozas.C_OSZTALYCSOPORTID
      AND csoport.C_ALTANEVID = @pTanevId
      AND csoport.TOROLT = 'F'
  LEFT JOIN
    T_TANTARGY_OSSZES tantargy ON
        tantargy.ID = foglalkozas.C_TANTARGYID
      AND tantargy.C_TANEVID = @pTanevId
      AND tantargy.TOROLT = 'F'
  LEFT JOIN
    T_FELHASZNALO_OSSZES felhasznalo ON
        felhasznalo.ID = foglalkozas.C_TANARID
      AND felhasznalo.C_TANEVID = @pTanevId
      AND felhasznalo.TOROLT = 'F'
  WHERE
      foglalkozas.C_TANEVID = @pTanevId
    AND  foglalkozas.C_TANARID = @pTanarId
    AND  foglalkozas.TOROLT = 'F'
  ORDER BY
     Evfolyam      ASC
    ,OsztalyCsoportNev  ASC
    ,TantargyNev    ASC

END

GO

