DROP PROCEDURE IF EXISTS [dbo].[sp_GetFeljegyzesElektronikusUzenetekListaNezetData]
GO

-- =============================================
-- Description:  <Előszedjük az osztály csoport tanulóinak feljegyzéseit az elektronikus üzenetek oldal lista nézet tab-jához>
-- =============================================
CREATE PROCEDURE [dbo].[sp_GetFeljegyzesElektronikusUzenetekListaNezetData]
   @pIntezmenyId INT
  ,@pTanevId INT
  ,@pOsztalyCsoportId INT
  ,@pTanarId INT
  ,@pEsemenyTipusElektronikusUzenetId INT

AS
BEGIN

  SET NOCOUNT ON;

  SELECT DISTINCT
     TanuloEsemeny.ID AS ID
    ,TanuloEsemeny.C_ESEMENYDATUMA AS EsemenyDatuma
    ,TanuloEsemeny.C_TARGY AS Targy
    ,TanuloEsemeny.C_TARTALOM AS Tartalom
    ,TanuloEsemeny.C_FALIUJSAGMEGJELENES AS IsFaliujsagMegjelenes
    ,Tanar.C_NYOMTATASINEV AS FeljegyzoNeve
    ,mua.C_SZERVEZETID AS FeljegyzoSzervezetId
  FROM T_TANULOESEMENY_OSSZES TanuloEsemeny
    LEFT JOIN T_FELHASZNALO_OSSZES Tanar ON Tanar.ID = TanuloEsemeny.C_FELJEGYZOID
      AND Tanar.TOROLT = 'F'
    LEFt JOIN T_MUNKAUGYIADATOK_OSSZES mua ON mua.C_ALKALMAZOTTID = Tanar.ID
      AND mua.TOROLT = 'F'
    LEFT JOIN T_OSZTALYCSOPORT_TANULOESEMENY OsztalyCsoportTanuloEsemeny ON OsztalyCsoportTanuloEsemeny.C_TANULOESEMENYID = TanuloEsemeny.ID
    LEFT JOIN T_OSZTALYCSOPORT_OSSZES OsztalyCsoport ON OsztalyCsoport.ID = OsztalyCsoportTanuloEsemeny.C_OSZTALYCSOPORTID
      AND OsztalyCsoport.TOROLT = 'F'
  WHERE TanuloEsemeny.C_TIPUS = @pEsemenyTipusElektronikusUzenetId
    AND TanuloEsemeny.C_INTEZMENYID = @pIntezmenyId
    AND TanuloEsemeny.C_TANEVID = @pTanevId
    AND TanuloEsemeny.C_FELJEGYZOID = @pTanarId
    AND TanuloEsemeny.TOROLT = 'F'
    AND OsztalyCsoport.ID = @pOsztalyCsoportId

END

GO

