DROP PROCEDURE IF EXISTS [dbo].[sp_GetFeljegyzesElektronikusUzenetekModifyPopupData]
GO

-- =============================================
-- Description:  <Előszedjük az osztály csoport tanulóit elektronikus üzenetek oldal modosító popup-jához>
-- =============================================
CREATE PROCEDURE [dbo].[sp_GetFeljegyzesElektronikusUzenetekModifyPopupData]
   @pOsztalyCsoportId          INT

AS
BEGIN

  SET NOCOUNT ON;

  SELECT DISTINCT
     Tanulo.ID              ID
    ,Tanulo.ID              TanuloId
    ,Tanulo.C_NYOMTATASINEV        TanuloNev
    ,Tanulo.C_ANYJANEVE          AnyjaNeve
    ,Tanulo.C_SZULETESIDATUM      SzuletesiIdo
    ,OsztalyCsoport.C_NEV        OsztalyNev
  FROM 
    T_FELHASZNALO Tanulo
  LEFT JOIN 
    T_TANULOCSOPORT TanuloCsoport ON 
        TanuloCsoport.C_TANULOID = Tanulo.ID 
      AND TanuloCsoport.TOROLT = 'F'
  LEFT JOIN 
    T_OSZTALYCSOPORT OsztalyCsoport ON
        OsztalyCsoport.ID = TanuloCsoport.C_OSZTALYCSOPORTID 
      AND OsztalyCsoport.TOROLT = 'F'
  WHERE 
      Tanulo.TOROLT = 'F'
    AND OsztalyCsoport.ID = @pOsztalyCsoportId
  ORDER BY 
    Tanulo.C_NYOMTATASINEV

END

GO

