-- =============================================
-- Description:  <Előszedjük az informatikai adatszolgáltatáshoz szükséges adatokat>
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[sp_GetInformatikaiAdatszolgaltatasGrid] 
GO

CREATE PROCEDURE [dbo].[sp_GetInformatikaiAdatszolgaltatasGrid]
  @pIntezmenyId INT,
  @pTanevId INT
AS
BEGIN
  SET NOCOUNT ON;

  SELECT
    MukodesiHely.ID                    ID,
    MukodesiHely.C_NEV                  MukodesiHelyNeve,
    MukodesiHelyAdatszolgaltatas.C_INTSZOLGALTATO    InternetszolgaltatoNeve,
    MukodesiHelyAdatszolgaltatas.C_INTLETOLTESSAV    InternetLetoltesiSavszelessege,
    MukodesiHelyAdatszolgaltatas.C_INTFELTOLTESSAV    InternetFeltoltesiSavszelessege,
    MukodesiHelyAdatszolgaltatas.C_INTHAVIDIJ      InternetszolgaltatasHaviNettoDija,
    MukodesiHelyAdatszolgaltatas.C_INFORMATIKAOKTATAS  InformatikaOktatasVanNincs
  FROM
    T_MUKODESIHELY_OSSZES MukodesiHely
  LEFT JOIN
    T_MUKODESIHELYADATSZOLGALTATAS MukodesiHelyAdatszolgaltatas ON
        MukodesiHelyAdatszolgaltatas.C_MUKODESIHELYID = MukodesiHely.ID
      AND MukodesiHelyAdatszolgaltatas.C_INTEZMENYID = @pIntezmenyId
      AND MukodesiHelyAdatszolgaltatas.C_TANEVID = @pTanevId
      AND MukodesiHelyAdatszolgaltatas.TOROLT = 'F'
  
  WHERE
    MukodesiHely.C_INTEZMENYID = @pIntezmenyId AND
    MukodesiHely.C_TANEVID = @pTanevId AND
    MukodesiHely.TOROLT = 'F'
END

GO

