DROP PROCEDURE IF EXISTS [dbo].[sp_GetNebuloErtesito]
GO

CREATE PROCEDURE [dbo].[sp_GetNebuloErtesito]
   @intezmenyId  INT
  ,@tanevId    INT
  ,@nebulo    INT
AS  
BEGIN

  SET NOCOUNT ON;

  SELECT 
     nebulo.ID                                            NebuloId
    ,ISNULL(C_ELOTAG + ' ', '') + C_SZULETESICSALADINEVE + ' ' + C_SZULETESIUTONEVE          NebuloSzuletesiNeve
    ,ISNULL(C_ELOTAG + ' ', '') + C_TANULOCSALADINEVE + ' ' + C_TANULOUTONEVE            NebuloNeve
    ,ISNULL(intezmenyAdatok.C_NEV, '')                                IntezmenyNeve
    ,ISNULL(tagozat.C_NAME, '')                                    Tagozat
    ,ISNULL(C_EDESANYJASZULETESICSALADINEV, '') + ' ' + ISNULL(C_EDESANYJASZULETESIUTONEVE, '')    AnyjaSzuletesiNeve
    ,ISNULL(neme.C_NAME, '')                                    TanuloNeme
    ,ISNULL(C_SZULETESIHELY, '')                                  SzulHely
    ,FORMAT(C_SZULETESIIDO, 'yyyy.MM.dd.')                              SzulIdo
    ,ISNULL(anyanyelv.C_NAME, '')                                  AnyaNyelv
    ,ISNULL(allampolgarsag1.C_NAME, '')                                AllamPolgarsag1
    ,ISNULL(allampolgarsag2.C_NAME, '')                                AllamPolgarsag2
    ,CONVERT(NVARCHAR(MAX), nebulo.C_IRANYITOSZAM) + ', ' + 
      C_HELYSEGNEV +
      ISNULL(', ' + nebulo.C_KOZTERULETNEV, '') + ' ' + 
      nebulo.C_KOZTERULETJELLEGENEV + 
      ISNULL(' ' + nebulo.C_HAZSZAM + ', ', '') + 
      ISNULL(nebulo.C_EMELET + ' emelet', '') + ' ' + 
      ISNULL(nebulo.C_AJTO + ' ajtó', '')                            NebuloAllandoCim
    ,CONVERT(NVARCHAR(MAX), nebulo.C_THIRANYITOSZAM) + 
      ISNULL(', ' + C_THHELYSEGNEV, '') + 
      ISNULL(', ' + nebulo.C_THKOZTERULETNEV, '') + ' ' + 
      nebulo.C_KOZTERULETJELLEGENEV + 
      ISNULL(' ' + nebulo.C_THHAZSZAM + ', ', '') + 
      ISNULL(nebulo.C_THEMELET + ' emelet', '') + 
      ISNULL(' ' + nebulo.C_THAJTO + ' ajtó', '')                        NebuloCimTh
    ,ISNULL(C_OKTATASIAZONOSITOSZAMA, '')                              OktAzon
    ,ISNULL(C_ETIKAHITERKOLCSTAN, '')                                EtikaHitErkolcsTan
    ,C_TKNEVE                                            TorvGondNeve1
    ,tk1Foka.C_NAME                                          TorvRokFoka1
    ,C_TKTELEFON                                          TorvGondTel1
    ,C_TKEMAILCIM                                          TorvGondEmail1
    ,CONVERT(NVARCHAR(MAX), nebulo.C_TKIRANYITOSZAM) + 
      ISNULL(', ' + C_TKHELYSEGNEV, '') + 
      ISNULL(', ' + nebulo.C_TKKOZTERULETNEV, '') + ' ' + 
      ISNULL(nebulo.C_TKKOZTERULETJELLEGENEV, '') + 
      ISNULL(nebulo.C_TKHAZSZAM + ', ', '') + 
      ISNULL(nebulo.C_TKEMELET + ' emelet', '') + 
      ISNULL(' ' + nebulo.C_TKAJTO + ' ajtó', '')                        TorvGond1Cim  
    ,C_TKNEVE2                                            TorvGondNeve2
    ,tk2Foka.C_NAME                                          TorvRokFoka2
    ,C_TKTELEFON2                                          TorvGondTel2
    ,C_TKEMAILCIM2                                          TorvGondEmail2
    ,CONVERT(NVARCHAR(MAX), nebulo.C_TKIRANYITOSZAM2) + 
      ISNULL(', ' + C_TKHELYSEGNEV2, '') + 
      ISNULL(', ' + nebulo.C_TKKOZTERULETNEV2, '') + ' ' + 
      ISNULL(nebulo.C_TKKOZTERULETJELLEGENEV2, '') + 
      ISNULL(', ' + nebulo.C_TKHAZSZAM2 + ', ', '') + 
      ISNULL(nebulo.C_TKEMELET2 + ' emelet', '') + 
      ISNULL(' ' + nebulo.C_TKAJTO2 + ' ajtó', '')                         TorvGond2Cim
    ,intezmenyAdatok.C_IGAZGATONEVE                                  IntezmenyVezetoNeve
    ,intezmenyAdatok.C_NEV                                      IntezmenyNeve
    ,CONVERT(NVARCHAR(MAX),intezmenyAdatok.C_IRANYITOSZAM) + 
      ISNULL(', ' + intezmenyAdatok.C_VAROS, '') + 
      ISNULL(', ' + intezmenyAdatok.C_KOZTERULETNEV, '') + ' ' + 
      ISNULL(intezmenyAdatok.C_KOZTERULETJELLEGENEV, '') + 
      ISNULL(intezmenyAdatok.C_HAZSZAM + ', ', '') + 
      ISNULL(intezmenyAdatok.C_EMELET + ' emelet', '') + 
      ISNULL(intezmenyAdatok.C_AJTO + ' ajtó', '')                        IntezmenyCim
    ,intezmenyAdatok.C_EMAILCIM                                    IntezmenyEmail
    ,intezmenyAdatok.C_TELEFONSZAM                                  IntezmenyTelefon
    ,intezmenyAdatok.C_DOKUMENTUMFEJLEC                                Fejlec
    ,intezmenyAdatok.C_DOKUMENTUMLABLEC                                Lablec
  FROM T_NEBULO_OSSZES nebulo
  LEFT JOIN
    T_INTEZMENYADATOK_OSSZES intezmenyAdatok ON 
      intezmenyAdatok.C_INTEZMENYID = nebulo.C_INTEZMENYID AND nebulo.C_TANEVID = intezmenyAdatok.C_TANEVID
  LEFT JOIN 
    T_DICTIONARYITEMBASE_OSSZES tagozat ON 
      tagozat.ID = nebulo.C_TAGOZAT AND tagozat.C_TANEVID = nebulo.C_TANEVID AND tagozat.C_INTEZMENYID = nebulo.C_INTEZMENYID
  LEFT JOIN 
    T_DICTIONARYITEMBASE_OSSZES neme ON 
      neme.ID = nebulo.C_NEME AND neme.C_TANEVID = nebulo.C_TANEVID AND neme.C_INTEZMENYID = nebulo.C_INTEZMENYID
  LEFT JOIN 
    T_DICTIONARYITEMBASE_OSSZES anyanyelv ON 
      anyanyelv.ID = nebulo.C_ANYANYELVE AND anyanyelv.C_TANEVID = nebulo.C_TANEVID AND anyanyelv.C_INTEZMENYID = nebulo.C_INTEZMENYID
  LEFT JOIN 
    T_DICTIONARYITEMBASE_OSSZES allampolgarsag1 ON 
      allampolgarsag1.ID = nebulo.C_ALLAMPOLGARSAGA AND allampolgarsag1.C_TANEVID = nebulo.C_TANEVID AND allampolgarsag1.C_INTEZMENYID = nebulo.C_INTEZMENYID
  LEFT JOIN 
    T_DICTIONARYITEMBASE_OSSZES allampolgarsag2 ON 
      allampolgarsag2.ID = nebulo.C_ALLAMPOLGARSAGA2 AND allampolgarsag2.C_TANEVID = nebulo.C_TANEVID AND allampolgarsag2.C_INTEZMENYID = nebulo.C_INTEZMENYID
  LEFT JOIN  
    T_DICTIONARYITEMBASE_OSSZES tk1Foka ON 
      tk1Foka.ID = nebulo.C_TKROKONSAGIFOKA AND tk1Foka.C_TANEVID = nebulo.C_TANEVID AND tk1Foka.C_INTEZMENYID = nebulo.C_INTEZMENYID
  LEFT JOIN 
    T_DICTIONARYITEMBASE_OSSZES tk2Foka ON 
      tk2Foka.ID = nebulo.C_TKROKONSAGIFOKA2 AND tk2Foka.C_TANEVID = nebulo.C_TANEVID AND tk2Foka.C_INTEZMENYID = nebulo.C_INTEZMENYID
  WHERE 
      nebulo.TOROLT = 'F'
    AND nebulo.C_TANEVID = @tanevId
    AND nebulo.C_INTEZMENYID = @intezmenyId
    AND nebulo.ID = @nebulo --5401 FELVETT, 5402 NEM FELVÉVE 

END

GO

