DROP PROCEDURE IF EXISTS [dbo].[sp_GetOsztalyCsoportokForFeljegyzesek]
GO

CREATE PROCEDURE [dbo].[sp_GetOsztalyCsoportokForFeljegyzesek]
  @felhasznaloId  int
AS
BEGIN
  SET NOCOUNT ON;
  DECLARE @tmp TABLE (ID int)
  INSERT INTO @tmp (ID)
    exec sp_GetTanarKapcsolodoOsztalyai @felhasznaloId
  
  DECLARE  @tipus int = 1;
  IF (SELECT C_MUNKAKORTIPUSA FROM T_MUNKAUGYIADATOK WHERE C_ALKALMAZOTTID = @felhasznaloId) IN (1762, 1763, 3027, 3028) SET @tipus = 3;
  
  SELECT 
    ocs.ID AS ID,
    ocs.C_NEV AS Nev,
    CAST(@tipus AS nvarchar(1)) AS Tipus,
    ocs.C_EVFOLYAMTIPUSA AS Evfolyam,
    CASE WHEN ocs.C_EVFOLYAMTIPUSA IS NULL THEN 0 ELSE dic.C_ORDER END AS C_ORDER
  FROM @tmp t
    INNER JOIN T_OSZTALYCSOPORT ocs ON ocs.ID = t.ID and ocs.TOROLT = 'F'
    LEFT JOIN T_DICTIONARYITEMBASE dic ON dic.ID = ocs.C_EVFOLYAMTIPUSA and dic.TOROLT = 'F'
  ORDER BY
      Tipus DESC, C_ORDER ASC, Nev ASC

END
GO