DROP PROCEDURE IF EXISTS [dbo].[sp_GetTantargyakElmaradtOraszama]
GO
-- =============================================
-- Author:    <Kelemen Attila>
-- Create date: <2016.01.06.>
-- Description:  <Tantárgyak elmaradt órái adott tanévben, osztályonként>
-- =============================================
CREATE PROCEDURE [dbo].[sp_GetTantargyakElmaradtOraszama]
  @tanevID int
AS
BEGIN
  SET NOCOUNT ON;

  select T_TANTARGY_OSSZES.C_NEV Tantargy,
    T_OSZTALYCSOPORT_OSSZES.C_NEV OsztalyNev,
    COUNT(T_TANITASIORA_OSSZES.ID) MegtartottOrak

    FROM T_TANTARGY_OSSZES
    INNER JOIN T_TANITASIORA_OSSZES on T_TANTARGY_OSSZES.ID = T_TANITASIORA_OSSZES.C_TANTARGYID
    INNER JOIN T_FOGLALKOZAS_OSSZES ON T_TANTARGY_OSSZES.ID = T_FOGLALKOZAS_OSSZES.C_TANTARGYID
    INNER JOIN T_OSZTALYCSOPORT_OSSZES ON T_FOGLALKOZAS_OSSZES.C_OSZTALYCSOPORTID = T_OSZTALYCSOPORT_OSSZES.ID
    INNER JOIN T_OSZTALY_OSSZES ON T_OSZTALYCSOPORT_OSSZES.ID = T_OSZTALY_OSSZES.ID

    WHERE
      T_TANTARGY_OSSZES.TOROLT='F'
    AND T_TANITASIORA_OSSZES.TOROLT='F'
    AND T_FOGLALKOZAS_OSSZES.TOROLT='F'
    AND T_OSZTALYCSOPORT_OSSZES.TOROLT='F'
    AND T_OSZTALY_OSSZES.TOROLT='F'

    AND T_TANITASIORA_OSSZES.C_MEGTARTOTT='F'

    AND T_TANTARGY_OSSZES.C_TANEVID = @tanevID

    GROUP BY T_TANTARGY_OSSZES.C_NEV, T_OSZTALYCSOPORT_OSSZES.C_NEV
  
  END 
  GO