-- =============================================
-- Author:    Dőrr Tamás
-- Create date: 2016.02.16.
-- Description:  Napirend ütközés lekérdezése.
-- =============================================
DROP PROCEDURE IF EXISTS [sp_GetUtkozes]
GO

CREATE PROCEDURE [sp_GetUtkozes]
  @IntezmenyId int,
  @TanevId int,
  @OraKezdete datetime,
  @OraVege datetime,
  @TanarId int,
  @OsztalyCsoportId int
AS
BEGIN
  SET NOCOUNT ON;
  
  SELECT OrarendiOraId, TanitasiOraId, NULL AS OsztalyCsoportId, NemKotottMunkaido
  FROM dbo.fnGetUtkozesByTanar (@OraKezdete, @OraVege, @TanarId, @IntezmenyId, @TanevId)
  
  UNION
  
  SELECT OrarendiOraId, TanitasiOraId, OsztalyCsoportId, NemKotottMunkaido
  FROM dbo.fnGetUtkozesByOsztalycsoport (@OraKezdete, @OraVege, @OsztalyCsoportId, @IntezmenyId, @TanevId)
  
END
GO

