﻿DROP PROCEDURE IF EXISTS [dbo].[sp_Nyomtatvany_Excel_IdoszakiOsztalyokCsoportokTantargyiStatisztika]
GO

CREATE PROCEDURE [dbo].[sp_Nyomtatvany_Excel_IdoszakiOsztalyokCsoportokTantargyiStatisztika]
   @pTanevId int
  ,@pErtekelestipusaId int
  ,@pTanevrendjeTanevKezdeteNaptipusId int = 1394 --Tanévrendje első nap típus
  ,@pLezaroNaptipusId int
  ,@pAtsoroltTanuloAdatok int = 1
  ,@pOktNevKategoria int
  ,@pOsztalyzatTipusTypeID int = 44
  ,@pMagatartasErtekelesTipusTypeID int = 50
  ,@pSzorgalomErtekelesTipusTypeID int = 51
AS
  BEGIN 
    SET NOCOUNT ON;
DECLARE @ElsoFelveVege INT = 1400
DECLARE @IneVege INT = 1403
DECLARE @IIIneVege INT = 1404
DECLARE @UtolsoTanitasiNap INT = 1395
DECLARE @VegzosUtolsoTanitasiNap INT = 1402

DECLARE @osztalyok TABLE(OSZTALYID INT, NEV NVARCHAR(MAX), EVFOLYAM INT, SORREND INT);
DECLARE @tantargyak TABLE(TANTARGYID INT, TANTARGY_NEV NVARCHAR(MAX), C_FOTARGYE CHAR(1), C_ALTANTARGYKENTNYOMTATVANYBAN CHAR(1)
    ,RENDEZ0 int
    ,RENDEZ1 int
    ,RENDEZ2 nvarchar(255) COLLATE DATABASE_DEFAULT
    ,RENDEZ3 int
    ,RENDEZ4 int
    ,RENDEZ5 nvarchar(255) COLLATE DATABASE_DEFAULT
);
DECLARE @osztalyokCsoportokErtekeles TABLE (TECHNIKAIID NVARCHAR(MAX), OSZTALYCSOPORTID INT, OSZTALYCSOPORTNEV NVARCHAR(MAX), SORREND INT, TANTARGYID INT, TANTARGYNEV NVARCHAR(MAX), AKTUALISLETSZAM INT, ATLAG FLOAT);
DECLARE @osztalyTanulok TABLE (TANULOID INT, BELEPESDATUM DATE, KILEPESDATUM DATE);

INSERT INTO @tantargyak (TANTARGYID, TANTARGY_NEV, C_FOTARGYE, C_ALTANTARGYKENTNYOMTATVANYBAN, RENDEZ0, RENDEZ1, RENDEZ2, RENDEZ3, RENDEZ4, RENDEZ5)
SELECT TANTARGYAK.ID AS TANTARGYID, COALESCE(TANTARGYAK.C_NEVNYOMTATVANYBAN, TANTARGYAK.C_NEV) AS TANTARGY_NEV, TANTARGYAK.C_FOTARGYE, TANTARGYAK.C_ALTANTARGYKENTNYOMTATVANYBAN
    ,TANTARGYAK.C_SORSZAM as RENDEZ0
    ,CASE WHEN TANTARGYAK.C_FOTARGYID IS NULL THEN ISNULL(TargyKategoriaDictionary.C_ORDER, 10000) ELSE ISNULL(FotargyKategoriaDictionary.C_ORDER, 10000) END as RENDEZ1
    ,COALESCE(FotargyTable.C_NEVNYOMTATVANYBAN, FotargyTable.C_NEV, TANTARGYAK.C_NEV) as RENDEZ2
    ,ISNULL(TANTARGYAK.C_FOTARGYID, TANTARGYAK.ID) as RENDEZ3
    ,TANTARGYAK.C_FOTARGYID as RENDEZ4
    ,ISNULL(TANTARGYAK.C_NEVNYOMTATVANYBAN, TANTARGYAK.C_NEV) as RENDEZ5
FROM T_TANTARGY_OSSZES AS TANTARGYAK
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES TargyKategoriaDictionary ON TargyKategoriaDictionary.Id = TANTARGYAK.C_TARGYKATEGORIA
      AND TargyKategoriaDictionary.TOROLT = 'F'
      AND TargyKategoriaDictionary.C_TANEVID = @pTanevId
    LEFT JOIN T_TANTARGY_OSSZES FotargyTable ON TANTARGYAK.C_FOTARGYID = FotargyTable.ID
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES FotargyKategoriaDictionary ON FotargyKategoriaDictionary.ID = FotargyTable.C_TARGYKATEGORIA
      AND FotargyKategoriaDictionary.TOROLT = 'F'
      AND FotargyKategoriaDictionary.C_TANEVID = FotargyTable.C_TANEVID
WHERE TANTARGYAK.TOROLT = 'F' AND TANTARGYAK.C_TANEVID = @pTanevId;

SELECT CAST(OSZTALYCSOPORT.ID AS nvarchar(MAX)) + '_' + CAST(OSZTALYCSOPORT.ID AS nvarchar(MAX)) AS TECHNIKAIID, OSZTALYCSOPORT.ID AS OSZTALYID, OSZTALYCSOPORT.C_NEV AS NEV, 
  OSZTALYCSOPORT.C_EVFOLYAMTIPUSA AS EVFOLYAM, EVFOLYAM.C_ORDER AS SORREND, (SELECT COUNT(TanuloId) FROM fnGetDokumentumOsztalyokCsoportokTanuloi(@pTanevId, OSZTALYCSOPORT.ID, 0)) AS AKTUALISLETSZAM, 
  C_KERESZTFELEVES AS KERESZTFELEVES, C_VEGZOSEVFOLYAM AS VEGZOSEVFOLYAM, 
  ROW_NUMBER() OVER(ORDER BY EVFOLYAM.C_ORDER ASC, OSZTALYCSOPORT.C_NEV ASC) AS Row#
  ,@pTanevId          TanevId
  ,OSZTALY.C_OSZTALYFONOKID OsztalyfonokId
  ,OSZTALYCSOPORT.C_FELADATELLATASIHELYID FeladatEllatasiHelyId
  ,OSZTALY.C_TANTERVID      TantervId
  ,OSZTALYCSOPORT.C_KEPZESIFORMA    KepzesiForma
  ,OSZTALY.C_AGAZAT        Agazat
  ,OSZTALY.C_SZAKMACSOPORT    SzakmaCsoport
  ,OSZTALY.C_SZAKKEPESITES    Szakkepesites
  ,OSZTALY.C_RESZSZAKKEPESITES  Reszszakkepesites
  ,OSZTALY.C_AGAZATUJSZKTTIPUSID AS UjSzktAgazat
  ,OSZTALY.C_SZAKMATIPUSID AS UjSzktSzakma
  ,OSZTALY.C_SZAKMAIRANYTIPUSID AS UjSzktSzakmairany
  ,OSZTALY.C_TANULMANYITERULETNKTTIPUSID AS NktTanulmanyiTerulet
  ,OSZTALY.C_SZAKKEPESITESNKTTIPUSID AS NktSzakkepesites
  ,OSZTALY.C_SZAKIRANYNKTTIPUSID AS NktSzakirany
  ,OSZTALYCSOPORT.C_KERESZTFELEVES  OJCSJKeresztfeleves
  ,OSZTALYCSOPORT.C_VEGZOSEVFOLYAM  CSJVegzosEvfolyamu
  ,OSZTALYCSOPORT.C_ISTECHNIKAI  OJTechnikaiOsztaly
  ,OSZTALY.C_NEMZETISEGI    OJNemzetisegi
  ,OSZTALY.C_KETTANNYELVU    OJKettannyelvu
  ,OSZTALY.C_NYELVIELOKESZITO  OJNyelviElokeszito
  ,OSZTALYCSOPORT.C_ISGYOGYPEDAGOGIAILOGOPEDIAI      OJIsGyogypedagogiaiLogopediai
  ,OSZTALY.C_SPORT        OJSportOsztaly
  ,OSZTALY.C_AJPROGRAM      OJAranyJanosProgram
INTO #tempOsztalyok
FROM T_OSZTALY_OSSZES AS OSZTALY
JOIN T_OSZTALYCSOPORT_OSSZES AS OSZTALYCSOPORT ON OSZTALY.ID = OSZTALYCSOPORT.ID AND (OSZTALYCSOPORT.C_FELADATKATEGORIAID = @pOktNevKategoria OR @pOktNevKategoria = 0)
JOIN T_DICTIONARYITEMBASE_OSSZES AS EVFOLYAM ON EVFOLYAM.ID = OSZTALYCSOPORT.C_EVFOLYAMTIPUSA AND EVFOLYAM.TOROLT = 'F' AND EVFOLYAM.C_TANEVID = OSZTALY.C_ALTANEVID
WHERE OSZTALYCSOPORT.TOROLT = 'F' AND OSZTALY.C_ALTANEVID = @pTanevId
ORDER BY Row#;

DECLARE @pOsztalyId INT = 0;
DECLARE @sorrend INT = 0;
DECLARE @keresztFeleves BIT = 0;
DECLARE @vegzosEvfolyamu BIT = 0;
WHILE (1 = 1) 
BEGIN
  SELECT TOP 1 @pOsztalyId = OSZTALYID, @sorrend = Row#, @keresztFeleves = IIF(KERESZTFELEVES = 'T', 1, 0), @vegzosEvfolyamu = IIF(VEGZOSEVFOLYAM = 'T', 1, 0)
    FROM #tempOsztalyok
    WHERE @sorrend < Row#
    ORDER BY Row#;
    IF @@ROWCOUNT = 0 
    BEGIN
      BREAK;
    END

  --Osztalyjellemzok alapjan a nyito/lezaro naptipus csereje
    DECLARE @pKezdeteOsztalyNaptipusId INT = (
    IIF(@keresztFeleves = 0, @pTanevrendjeTanevKezdeteNaptipusId, 
      CASE 
        WHEN @pLezaroNaptipusId = @ElsoFelveVege THEN @ElsoFelveVege 
        WHEN @pLezaroNaptipusId = @UtolsoTanitasiNap THEN @pTanevrendjeTanevKezdeteNaptipusId 
        WHEN @pLezaroNaptipusId = @IneVege THEN @ElsoFelveVege
        WHEN @pLezaroNaptipusId = @IIIneVege THEN @pTanevrendjeTanevKezdeteNaptipusId 
      END)
    )

    DECLARE @pLezaroOsztalyNaptipusId INT = (
    IIF(@keresztFeleves = 0, IIF(@vegzosEvfolyamu = 1 AND @pLezaroNaptipusId = @UtolsoTanitasiNap, @VegzosUtolsoTanitasiNap, @pLezaroNaptipusId), 
      CASE 
        WHEN @pLezaroNaptipusId = @ElsoFelveVege THEN @UtolsoTanitasiNap 
        WHEN @pLezaroNaptipusId = @UtolsoTanitasiNap THEN @ElsoFelveVege 
        WHEN @pLezaroNaptipusId = @IneVege THEN @IIIneVege 
        WHEN @pLezaroNaptipusId = @IIIneVege THEN @IneVege 
      END)
    )

    DECLARE @idoszakEleje DATE = (
    SELECT ISNULL(
      (SELECT TOP 1 C_DATUM
        FROM T_TANEVRENDJE_OSSZES 
        LEFT JOIN T_OSZTALYCSOPORT_TANEVRENDJE ON T_TANEVRENDJE_OSSZES.ID = T_OSZTALYCSOPORT_TANEVRENDJE.C_TANEVRENDJEID
        WHERE C_TANEVID = @pTanevId AND C_NAPTIPUSA = @pKezdeteOsztalyNaptipusId AND TOROLT = 'F' AND (C_OSZTALYCSOPORTID IS NULL OR C_OSZTALYCSOPORTID = @pOsztalyId)
        ORDER BY C_OSZTALYCSOPORTID DESC),
      (SELECT TOP 1 C_KEZDONAP FROM T_TANEV_OSSZES WHERE ID = @pTanevId))
    );

    DECLARE @idoszakVege DATE = (
    SELECT ISNULL(
      (SELECT TOP 1 C_DATUM
        FROM T_TANEVRENDJE_OSSZES 
        LEFT JOIN T_OSZTALYCSOPORT_TANEVRENDJE ON T_TANEVRENDJE_OSSZES.ID = T_OSZTALYCSOPORT_TANEVRENDJE.C_TANEVRENDJEID
        WHERE C_TANEVID = @pTanevId AND C_NAPTIPUSA = @pLezaroOsztalyNaptipusId AND TOROLT = 'F' AND (C_OSZTALYCSOPORTID IS NULL OR C_OSZTALYCSOPORTID = @pOsztalyId)
        ORDER BY C_OSZTALYCSOPORTID DESC),
      GETDATE())
    )

  INSERT INTO @osztalyTanulok (TANULOID, BELEPESDATUM, KILEPESDATUM) (
  SELECT T_FELHASZNALO_OSSZES.ID AS TANULOID, C_BELEPESDATUM, C_KILEPESDATUM 
  FROM T_FELHASZNALO_OSSZES 
  INNER JOIN (
    SELECT tcs.C_TANULOID, tcs.C_OSZTALYCSOPORTID, tcs.C_BELEPESDATUM, tcs.C_KILEPESDATUM
    FROM T_TANULOCSOPORT_OSSZES tcs
      INNER JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.ID=tcs.C_OSZTALYCSOPORTID AND (ocs.C_FELADATKATEGORIAID = @pOktNevKategoria OR @pOktNevKategoria = 0) AND ocs.TOROLT='F'
    WHERE tcs.TOROLT = 'F'  AND tcs.C_BELEPESDATUM < @idoszakVege
        AND (tcs.C_KILEPESDATUM IS NULL OR tcs.C_KILEPESDATUM >= @idoszakEleje)
  ) AS TANCSOPORT ON TANCSOPORT.C_TANULOID = T_FELHASZNALO_OSSZES.ID 
  WHERE T_FELHASZNALO_OSSZES.TOROLT = 'F' AND TANCSOPORT.C_OSZTALYCSOPORTID = @pOsztalyId AND T_FELHASZNALO_OSSZES.C_TANEVID = @pTanevId
  );

  INSERT INTO @osztalyokCsoportokErtekeles(TECHNIKAIID, OSZTALYCSOPORTID, OSZTALYCSOPORTNEV, SORREND, TANTARGYID, TANTARGYNEV, AKTUALISLETSZAM, ATLAG)
  SELECT CAST(@pOsztalyId AS nvarchar(MAX)) + '_' + CAST(OsztalyCsoportId AS nvarchar(MAX)) AS TechnikaiId, OsztalyCsoportId, OSZTALYCSOPORT.C_NEV + (IIF(CSOPORT.ID IS NOT NULL, ' (' + (SELECT C_NEV FROM T_OSZTALYCSOPORT_OSSZES WHERE ID = @pOsztalyId) + ')', '')) AS OsztalyCsoportNev, @sorrend,
    TantargyId, TantargyNev, 
    (SELECT COUNT(TanuloId)  FROM (
        SELECT TanuloId  FROM fnGetDokumentumOsztalyokCsoportokTanuloi(@pTanevId, OsztalyCsoportId, 0)
      INTERSECT
        SELECT TanuloId  FROM fnGetDokumentumOsztalyokCsoportokTanuloi(@pTanevId, @pOsztalyId, 0)) AS T) AS Aktualisletszam,
    AVG(CAST (ErtekelesOsztalyzatValue AS float)) AS Atlag
  FROM fnGetDokumentumErtekelesekOsztalyonkent(@pTanevId, @pOsztalyId, @pErtekelestipusaId, DEFAULT, DEFAULT, 1, DEFAULT, @pOsztalyzatTipusTypeID, @pMagatartasErtekelesTipusTypeID, @pSzorgalomErtekelesTipusTypeID) AS ERTEKELESEK
  INNER JOIN @osztalyTanulok AS OSZTALYTANULOK ON OSZTALYTANULOK.TANULOID = ERTEKELESEK.TanuloId
  INNER JOIN T_OSZTALYCSOPORT_OSSZES AS OSZTALYCSOPORT ON OSZTALYCSOPORT.ID = OsztalyCsoportId AND (OSZTALYCSOPORT.C_FELADATKATEGORIAID = @pOktNevKategoria OR @pOktNevKategoria = 0)
  LEFT JOIN T_CSOPORT_OSSZES AS CSOPORT ON CSOPORT.ID = OSZTALYCSOPORT.ID
  WHERE IsMagatartasSzorgalom = 'F'
  GROUP BY OsztalyCsoportId, OSZTALYCSOPORT.C_NEV, TantargyId, TantargyNev, CSOPORT.ID
END

SELECT *
FROM (
  SELECT DISTINCT TECHNIKAIID, OSZTALYCSOPORTID, OSZTALYCSOPORTNEV, AKTUALISLETSZAM, SORREND
  FROM @osztalyokCsoportokErtekeles
  UNION 
  SELECT TECHNIKAIID, OSZTALYID AS OSZTALYCSOPORTID, NEV AS OSZTALYCSOPORTNEV, AKTUALISLETSZAM, Row# AS SORREND
  FROM #tempOsztalyok
) AS OSZTALYOKCSOPORTOK
ORDER BY SORREND, OSZTALYCSOPORTNEV;

SELECT DISTINCT TANTARGYID, TANTARGY_NEV, RENDEZ0, RENDEZ1, RENDEZ2, RENDEZ3, RENDEZ4, RENDEZ5
FROM @tantargyak
ORDER BY RENDEZ0, RENDEZ1, RENDEZ2, RENDEZ3, RENDEZ4, RENDEZ5, TANTARGY_NEV;

SELECT * 
FROM @osztalyokCsoportokErtekeles;

 select OSZTALYID AS OsztalyId
  ,EVFOLYAM AS EvfolyamTipusa
  ,FeladatEllatasiHelyId
  ,KepzesiForma
  ,OsztalyfonokId
  ,TantervId
  ,OJAranyJanosProgram
  ,OJCSJKeresztfeleves
  ,OJKettannyelvu
  ,OJIsGyogypedagogiaiLogopediai
  ,OJNemzetisegi
  ,OJNyelviElokeszito
  ,OJSportOsztaly
  ,OJTechnikaiOsztaly
  ,SzakmaCsoport
  ,Agazat
  ,Szakkepesites
  ,Reszszakkepesites
  ,UjSzktAgazat
  ,UjSzktSzakma
  ,UjSzktSzakmairany
  ,NktTanulmanyiTerulet
  ,NktSzakkepesites
  ,NktSzakirany
 from #tempOsztalyok;
 
  select cs.ID CsoportId
    ,cs.C_CSOPORTVEZETOID as Csoportvezeto
    ,cs.C_TIPUSA as CsoportTipus
    ,ocs.C_KERESZTFELEVES as OJCSJKeresztfeleves
    ,ocs.C_VEGZOSEVFOLYAM as CSJVegzosEvfolyamu
  from T_CSOPORT_OSSZES cs 
  inner join @osztalyokCsoportokErtekeles ocse on ocse.OSZTALYCSOPORTID = cs.iD
  inner join T_OSZTALYCSOPORT_OSSZES ocs on ocs.ID = cs.ID;

IF OBJECT_ID('tempdb..#tempOsztalyok') IS NOT NULL DROP TABLE #tempOsztalyok
IF OBJECT_ID('tempdb..#tempErtekeles') IS NOT NULL DROP TABLE #tempErtekeles

END
GO
