DROP PROCEDURE IF EXISTS [dbo].[sp_Nyomtatvany_Excel_IdoszakiOsztalyokTantargyiStatisztika]
GO

CREATE PROCEDURE [dbo].[sp_Nyomtatvany_Excel_IdoszakiOsztalyokTantargyiStatisztika]
   @pTanevId int
  ,@pIntezmenyId int
  ,@pErtekelestipusaId int
  ,@pLezaroNaptipusId int
  ,@pTanoraiCsoportTipusIds int = 1034
  ,@pMulasztasTipusIdKeses int = 1499
  ,@pMulasztasTipusIdHianyzas int = 1500
  ,@pNemMulasztaIgazolasTipusIds int = 1532 -- Iskola érdekű távollét
  ,@pTanevrendjeTanevKezdeteNaptipusId int = 1394 --Tanévrendje első nap típus
  ,@pAtsoroltTanuloAdatok int = 1
  ,@pElmeletgyakorlat bit = 0
  ,@pOktNevKategoria int
  ,@pOsztalyzatTipusTypeID int = 44
  ,@pMagatartasErtekelesTipusTypeID int = 50
  ,@pSzorgalomErtekelesTipusTypeID int = 51
AS
  BEGIN
  SET NOCOUNT ON;
  --Const
  DECLARE 
     @ElsoFelveVege int = 1400
    ,@IneVege int = 1403
    ,@IIIneVege int = 1404
    ,@UtolsoTanitasiNap int = 1395
    ,@VegzosUtolsoTanitasiNap int = 1402
    ,@iskolaErdekuSzamit bit = dbo.fnGetRendszerbeallitasEnumBool(1683, @pIntezmenyId, @pTanevId)

  CREATE TABLE #tantargyak (
     TantargyId int
    ,TantargyNev nvarchar(255)
    ,RENDEZ0 int
    ,RENDEZ1 int
    ,RENDEZ2 nvarchar(255) COLLATE DATABASE_DEFAULT
    ,RENDEZ3 int
    ,RENDEZ4 int
    ,RENDEZ5 nvarchar(255) COLLATE DATABASE_DEFAULT
  )

  CREATE TABLE #osztalyokTanulokszama (
     OsztalyId int
    ,TanulokSzama int
  )
  CREATE TABLE #osztalyokErtekeles (
     OsztalyId int
    ,TantargyId int
    ,Atlag float
  )
  CREATE TABLE #osztalyokMagszorg (
     OsztalyId int
    ,MagAtlag float
    ,SzorgAtlag float
  )
  CREATE TABLE #osztalyokMulasztas (
     OsztalyId int
    ,TIPUS_CHAR  char(1)
    ,C_TIPUS int
    ,C_IGAZOLT char(1)
    ,MulasztasokSzama int
    ,C_GYAKORLATI char(1)
    ,DESCR char(3)
  )
  CREATE TABLE #szurtMulasztas (
     TIPUS_CHAR char(1)
    ,C_TIPUS int
    ,C_IGAZOLT char(1)
    ,C_TANULOID int
    ,C_GYAKORLATI char(1)
    ,KESESPERC int
    ,MulasztasokSzama int
  )
 CREATE TABLE #tempMulasztas (
     TIPUS int
    ,IGAZOLT char(1)
    ,GYAKORLATI char(1)
    ,KESESPERC int
    ,MulasztasokSzama int
    ,OsztalyId int
  )
  CREATE TABLE #csopTip (
    ID int PRIMARY KEY CLUSTERED
  )
  CREATE TABLE #OsztalyokTanulok(
     OsztalyId int
    ,TanuloId int 
    ,BelepesDatum datetime
    ,KilepesDatum datetime
    INDEX IX_OT CLUSTERED (TanuloId)
  )
  CREATE TABLE #tempOsztalyok(
     OsztalyId int 
    ,OsztalyNev nvarchar(255)
    ,Sorrend int
    ,KereszFeleves char(1)
    ,VegzosEVfolyam char(1)
    ,Letszam int
    ,IdoszakKezdeteNaptipusId int
    ,IdoszakVegeNaptipusId int
    ,IdoszakKezdete datetime
    ,IdoszakVege datetime
    INDEX IX_tmpO CLUSTERED(OsztalyId)
  )
  CREATE TABLE #tempOsztalyErtekelesek(
     TantargyId int
    ,Osztalyzat int
    ,TanuloId int
    ,OsztalyId int
    ,MagatartasOsztalyzat int
    ,SzorgalomOsztalyzat int
    INDEX IX_tmpO_tgy CLUSTERED(TantargyId)
  )

  -- TANTÁRGYAK
  INSERT INTO #tantargyak (
     TantargyId
    ,TantargyNev
    ,RENDEZ0
    ,RENDEZ1
    ,RENDEZ2
    ,RENDEZ3
    ,RENDEZ4
    ,RENDEZ5
  )
  SELECT 
     tgy.ID AS TantargyId
    ,COALESCE(tgy.C_NEVNYOMTATVANYBAN, tgy.C_NEV) AS TantargyNev 
    ,tgy.C_SORSZAM as RENDEZ0
    ,CASE WHEN tgy.C_FOTARGYID IS NULL THEN ISNULL(TargyKategoriaDictionary.C_ORDER, 10000) ELSE ISNULL(FotargyKategoriaDictionary.C_ORDER, 10000) END as RENDEZ1
    ,COALESCE(FotargyTable.C_NEVNYOMTATVANYBAN, FotargyTable.C_NEV, tgy.C_NEV) as RENDEZ2
    ,ISNULL(tgy.C_FOTARGYID, tgy.ID) as RENDEZ3
    ,tgy.C_FOTARGYID as RENDEZ4
    ,ISNULL(tgy.C_NEVNYOMTATVANYBAN, tgy.C_NEV) as RENDEZ5
  FROM T_TANTARGY_OSSZES tgy
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES TargyKategoriaDictionary ON TargyKategoriaDictionary.Id = tgy.C_TARGYKATEGORIA
      AND TargyKategoriaDictionary.TOROLT = 'F'
      AND TargyKategoriaDictionary.C_TANEVID = @pTanevId
    LEFT JOIN T_TANTARGY_OSSZES FotargyTable ON tgy.C_FOTARGYID = FotargyTable.ID
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES FotargyKategoriaDictionary ON FotargyKategoriaDictionary.ID = FotargyTable.C_TARGYKATEGORIA
      AND FotargyKategoriaDictionary.TOROLT = 'F'
      AND FotargyKategoriaDictionary.C_TANEVID = FotargyTable.C_TANEVID
  WHERE tgy.TOROLT = 'F' AND tgy.C_TANEVID = @pTanevId  

  INSERT INTO #tantargyak(
     TantargyId
    ,TantargyNev
    ,RENDEZ0
    ,RENDEZ1
    ,RENDEZ2
    ,RENDEZ3
    ,RENDEZ4
    ,RENDEZ5
  )
  VALUES(-1, 'Magatartás', 0, 0, '', 0, 0, ''),(-2, 'Szorgalom', 0, 1, '', 0, 0, '')

  -- OSZTÁLYOK
  INSERT INTO #tempOsztalyok(
     OsztalyId 
    ,OsztalyNev 
    ,Sorrend 
    ,KereszFeleves 
    ,VegzosEVfolyam
    ,Letszam 
    ,IdoszakKezdeteNaptipusId 
    ,IdoszakVegeNaptipusId
  )
  SELECT 
     ocs.ID AS OsztalyId
    ,ocs.C_NEV AS OsztalyNev
    ,dibEvf.C_ORDER AS Sorrend
    ,ocs.C_KERESZTFELEVES AS KereszFeleves
    ,ocs.C_VEGZOSEVFOLYAM AS VegzosEVfolyam
    ,0 Letszam
    ,IIF(ocs.C_KERESZTFELEVES = 'F', @pTanevrendjeTanevKezdeteNaptipusId,
      CASE
        WHEN @pLezaroNaptipusId = @ElsoFelveVege THEN @ElsoFelveVege
        WHEN @pLezaroNaptipusId = @UtolsoTanitasiNap THEN @pTanevrendjeTanevKezdeteNaptipusId
        WHEN @pLezaroNaptipusId = @IneVege THEN @ElsoFelveVege
        WHEN @pLezaroNaptipusId = @IIIneVege THEN @pTanevrendjeTanevKezdeteNaptipusId
      END) IdoszakKezdeteNaptipusId
    ,IIF(ocs.C_KERESZTFELEVES = 'F', IIF(ocs.C_VEGZOSEVFOLYAM = 'T' AND @pLezaroNaptipusId = @UtolsoTanitasiNap, @VegzosUtolsoTanitasiNap, @pLezaroNaptipusId),
      CASE
        WHEN @pLezaroNaptipusId = @ElsoFelveVege THEN @UtolsoTanitasiNap
        WHEN @pLezaroNaptipusId = @UtolsoTanitasiNap THEN @ElsoFelveVege
        WHEN @pLezaroNaptipusId = @IneVege THEN @IIIneVege
        WHEN @pLezaroNaptipusId = @IIIneVege THEN @IneVege
      END) IdoszakVegeNaptipusId
  FROM T_OSZTALYCSOPORT_OSSZES ocs
    INNER JOIN T_OSZTALY_OSSZES o ON o.ID = ocs.ID
    INNER JOIN T_DICTIONARYITEMBASE_OSSZES AS dibEvf ON dibEvf.ID = ocs.C_EVFOLYAMTIPUSA AND dibEvf.TOROLT = 'F' 
      AND dibEvf.C_TANEVID = ocs.C_TANEVID
  WHERE ocs.TOROLT = 'F'
    AND ocs.C_TANEVID = @pTanevId
    AND (ocs.C_FELADATKATEGORIAID = @pOktNevKategoria OR @pOktNevKategoria = 0)

  UPDATE #tempOsztalyok SET 
     IdoszakKezdete = ISNULL(
      (SELECT TOP 1 C_DATUM
        FROM T_TANEVRENDJE_OSSZES tr
          LEFT JOIN T_OSZTALYCSOPORT_TANEVRENDJE ocstr ON tr.ID = ocstr.C_TANEVRENDJEID
        WHERE tr.C_TANEVID = @pTanevId AND tr.C_NAPTIPUSA = IdoszakKezdeteNaptipusId AND tr.TOROLT = 'F' AND (C_OSZTALYCSOPORTID IS NULL OR C_OSZTALYCSOPORTID = OsztalyId)
        ORDER BY C_OSZTALYCSOPORTID DESC),
      (SELECT TOP 1 C_KEZDONAP FROM T_TANEV_OSSZES WHERE ID = @pTanevId))
    ,IdoszakVege = ISNULL(
      (SELECT TOP 1 C_DATUM
        FROM T_TANEVRENDJE_OSSZES tr
          LEFT JOIN T_OSZTALYCSOPORT_TANEVRENDJE ocstr ON tr.ID = ocstr.C_TANEVRENDJEID
        WHERE tr.C_TANEVID = @pTanevId AND tr.C_NAPTIPUSA = IdoszakVegeNaptipusId AND TOROLT = 'F' AND (C_OSZTALYCSOPORTID IS NULL OR C_OSZTALYCSOPORTID = OsztalyId)
        ORDER BY C_OSZTALYCSOPORTID DESC),
      GETDATE())

  UPDATE #tempOsztalyok SET Letszam = DB FROM (
    SELECT
       COUNT(*) db
      ,o.OsztalyId
    FROM #tempOsztalyok o
      INNER JOIN T_TANULOCSOPORT_OSSZES tcso ON tcso.C_OSZTALYCSOPORTID = o.OsztalyId
        AND tcso.TOROLT='F'
        AND o.IdoszakVege BETWEEN tcso.C_BELEPESDATUM AND ISNULL(tcso.C_KILEPESDATUM,'22000101')
    GROUP BY o.OsztalyId) x
  WHERE x.OsztalyId = #tempOsztalyok.OsztalyId

  INSERT INTO #OsztalyokTanulok(
     OsztalyId
    ,TanuloId
    ,BelepesDatum
    ,KilepesDatum
  )
  SELECT DISTINCT
     o.OsztalyId
    ,tcso.C_TANULOID
    ,tcso.C_BELEPESDATUM
    ,tcso.C_KILEPESDATUM 
  FROM T_TANULOCSOPORT_OSSZES tcso
    INNER JOIN #tempOsztalyok o ON o.OsztalyId = tcso.C_OSZTALYCSOPORTID
  WHERE tcso.TOROLT='F' AND tcso.C_TANEVID = @pTanevId
    AND o.IdoszakVege BETWEEN tcso.C_BELEPESDATUM AND ISNULL(tcso.C_KILEPESDATUM,'22000101')

  INSERT INTO #csopTip(ID)
  SELECT Id FROM fnGetDokumentumOsztalyVagyTanoraiCsoport  (@pTanevId)

  INSERT INTO #tempMulasztas(
     TIPUS
    ,IGAZOLT
    ,GYAKORLATI
    ,KESESPERC
    ,MulasztasokSzama
    ,OsztalyId
  )
  SELECT  
     tm.C_TIPUS -- 1500 hiányzás, 1499 késés
    ,tm.C_IGAZOLT
    ,tgy.C_GYAKORLATI
    ,SUM(tm.C_KESESPERCBEN)
    ,COUNT(tm.ID) AS MulasztasokSzama
    ,o.OsztalyId
  FROM T_TANULOMULASZTAS_OSSZES tm
    INNER JOIN T_TANITASIORA_OSSZES tao ON tao.ID = tm.C_TANITASIORAKID 
      AND tao.TOROLT = 'F' 
      AND tao.C_MEGTARTOTT = 'T'
      AND tao.C_TANEVID = @pTanevId
    INNER JOIN #OsztalyokTanulok ot ON ot.TanuloId = tm.C_ORATANULOIID 
    INNER JOIN #tempOsztalyok o ON o.OsztalyId = ot.OsztalyId
      AND tao.C_DATUM <= o.IdoszakVege
    INNER JOIN T_TANTARGY_OSSZES tgy ON tgy.ID = tao.C_TANTARGYID AND tgy.TOROLT='F'
    INNER JOIN #csopTip csop ON csop.ID=tao.C_OSZTALYCSOPORTID
  WHERE tm.C_TIPUS BETWEEN 1499 AND 1500
    AND ot.BelepesDatum <= tao.C_DATUM AND (ot.KilepesDatum IS NULL OR ot.KilepesDatum >= tao.C_DATUM) 
    AND (@iskolaErdekuSzamit = 1 OR ISNULL(C_IGAZOLASTIPUSA,0)<>1533)
    AND tm.TOROLT = 'F' AND tm.C_IGAZOLT IS NOT NULL
    AND tm.C_TANEVID = @pTanevId
  GROUP BY C_TIPUS, C_IGAZOLT, C_GYAKORLATI, o.OsztalyId

  --ÉRTÉKELÉS LISTA
  INSERT INTO #tempOsztalyErtekelesek(
     TantargyId
    ,Osztalyzat
    ,TanuloId
    ,OsztalyId
    ,MagatartasOsztalyzat
    ,SzorgalomOsztalyzat
  )
  SELECT 
     te.C_TANTARGYID as TantargyId
    ,ertekelesOsztalyzat.C_VALUE Osztalyzat
    ,te.C_TANULOID TanuloId
    ,o.OsztalyId OsztalyId
    ,ISNULL(magatartasOsztalyzat.C_VALUE,magatartasErtek.C_VALUE + 1) MagatartasOsztalyzat
    ,ISNULL(szorgalomOsztalyzat.C_VALUE,szorgalomErtek.C_VALUE+1) SzorgalomOsztalyzat
  FROM T_TANULOERTEKELES_OSSZES te
    INNER JOIN #OsztalyokTanulok t ON t.TanuloId = te.C_TANULOID
    INNER JOIN #tempOsztalyok o ON o.OsztalyId = t.OsztalyId 
    INNER JOIN #csopTip tanorai ON tanorai.ID = te.C_OSZTALYCSOPORTID
    LEFT JOIN T_TANTARGY_OSSZES tgy ON tgy.ID= te.C_TANTARGYID AND tgy.TOROLT='F'
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES ertekelesOsztalyzat ON ertekelesOsztalyzat.ID = te.C_ERTEKELESOSZTALYZATID
      AND ertekelesOsztalyzat.C_TANEVID = @pTanevId
      AND ertekelesOsztalyzat.C_DICTIONARYTYPEID = @pOsztalyzatTipusTypeID
      AND ertekelesOsztalyzat.TOROLT='F'
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES magatartasOsztalyzat ON magatartasOsztalyzat.ID = te.C_MAGATARTASOSZTALYZATID
      AND magatartasOsztalyzat.C_TANEVID = @pTanevId
      AND magatartasOsztalyzat.C_DICTIONARYTYPEID = @pOsztalyzatTipusTypeID
      AND magatartasOsztalyzat.TOROLT='F'
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES szorgalomOsztalyzat ON szorgalomOsztalyzat.ID = te.C_SZORGALOMOSZTALYZATID
      AND szorgalomOsztalyzat.C_TANEVID = @pTanevId
      AND szorgalomOsztalyzat.C_DICTIONARYTYPEID = @pOsztalyzatTipusTypeID
      AND szorgalomOsztalyzat.TOROLT='F'
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES magatartasErtek ON magatartasErtek.ID = te.C_MAGATARTASERTEKID
      AND magatartasErtek.C_TANEVID = @pTanevId
      AND magatartasErtek.C_DICTIONARYTYPEID = @pMagatartasErtekelesTipusTypeID
      AND magatartasErtek.TOROLT='F'
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES szorgalomErtek ON szorgalomErtek.ID = te.C_SZORGALOMERTEKID
      AND szorgalomErtek.C_TANEVID = @pTanevId
      AND szorgalomErtek.C_DICTIONARYTYPEID = @pSzorgalomErtekelesTipusTypeID
      AND szorgalomErtek.TOROLT='F'
  WHERE te.C_TANEVID = @pTanevId
    AND te.TOROLT = 'F'
    AND C_TIPUSID = @pErtekelestipusaId
    AND ISNULL(tgy.C_TARGYKATEGORIA,0) <> 1248
    
  INSERT INTO #osztalyokErtekeles (
     OSZTALYID
    ,TANTARGYID
    ,ATLAG
  )
  SELECT 
     OsztalyId
    ,TantargyId
    ,ROUND(AVG(CAST(Osztalyzat AS float)), 2) AS ATLAG
  FROM #tempOsztalyErtekelesek AS ERTEKELESEK
  WHERE TantargyId IS NOT NULL 
    AND Osztalyzat IS NOT NULL
  GROUP BY OsztalyId,TantargyId

  --MAGATARTAS-SZORGALOM LISTA
  INSERT INTO #osztalyokMagszorg (
     OSZTALYID
    ,MAGATLAG
    ,SZORGATLAG
  )
  SELECT 
     OsztalyId
    ,ROUND(AVG(CAST(MagatartasOsztalyzat AS float)), 2) AS MAGATLAG
    ,ROUND(AVG(CAST(SzorgalomOsztalyzat AS float)), 2) AS SZORGATLAG
  FROM #tempOsztalyErtekelesek AS ERTEKELESEK
  WHERE TantargyId IS NULL 
    AND SzorgalomOsztalyzat IS NOT NULL 
    AND MagatartasOsztalyzat IS NOT NULL
  GROUP BY OsztalyId

  CREATE TABLE #OsztalyHozottMulasztas (
     OsztalyID int
    ,Gyakorlati char(1)
    ,HozottIgazolt int
    ,HozottIgazolatlan int
  )

  INSERT INTO #OsztalyHozottMulasztas (
     OsztalyID
    ,HozottIgazolt
    ,HozottIgazolatlan
  )
  SELECT
     o.OsztalyId
    ,SUM(IIF(tcs.C_BELEPESDATUM < IdoszaKVege,ISNULL(tta.C_HOZOTTIGAZOLTHIANYZAS,0),0))
    ,SUM(IIF(tcs.C_BELEPESDATUM < IdoszaKVege,ISNULL(tta.C_HOZOTTIGAZOLATLANHIANYZAS,0),0))
  FROM #tempOsztalyok o
    INNER JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.ID = o.OsztalyId AND ocs.TOROLT = 'F'
    INNER JOIN T_TANULOCSOPORT_OSSZES tcs ON tcs.C_OSZTALYCSOPORTID = ocs.ID AND ocs.C_TANEVID = @pTanevId AND tcs.TOROLT = 'F'
    INNER JOIN T_TANULOTANUGYIADATOK tta ON tta.C_TANULOCSOPORTID = tcs.ID AND tta.C_TANEVID = @pTanevId AND tta.TOROLT = 'F'
  GROUP BY o.OsztalyId

  UPDATE mul 
    SET MulasztasokSzama += hmul.HozottIgazolt
  FROM #OsztalyHozottMulasztas hmul
    INNER JOIN #tempMulasztas mul on hmul.OsztalyID = mul.OsztalyId
  WHERE mul.Gyakorlati = 'F' AND mul.IGAZOLT = 'T' AND mul.TIPUS = 1500

  UPDATE mul 
    SET MulasztasokSzama += hmul.HozottIgazolatlan
  FROM #OsztalyHozottMulasztas hmul
    INNER JOIN #tempMulasztas mul on hmul.OsztalyID = mul.OsztalyId
  WHERE mul.Gyakorlati = 'F' AND mul.IGAZOLT = 'F' AND mul.TIPUS = 1500

  UPDATE #tempMulasztas SET
    MulasztasokSzama = NULL
  WHERE KESESPERC IS NOT NULL

  SELECT
     OsztalyId
    ,OsztalyNev
    ,Letszam
  FROM #tempOsztalyok
  ORDER BY Sorrend,OsztalyNev

  SELECT 
     TantargyId
    ,TantargyNev
  FROM #tantargyak
  ORDER BY RENDEZ0, RENDEZ1, RENDEZ2, RENDEZ3, RENDEZ4, RENDEZ5,TantargyNev

  SELECT
     tgy.TantargyId
    ,o.Osztalyid
    ,o.OsztalyNev
    ,tgy.TantargyNev
    ,ert.Atlag
  FROM #tantargyak tgy
    INNER JOIN #osztalyokErtekeles ert ON ert.TantargyId = tgy.TantargyId
    INNER JOIN #tempOsztalyok o ON o.OsztalyId = ert.OsztalyId
  UNION
  SELECT
     tgy.TantargyId
    ,o.Osztalyid
    ,o.OsztalyNev
    ,tgy.TantargyNev
    ,mag.MagAtlag
  FROM #tantargyak tgy
    INNER JOIN #osztalyokMagszorg mag ON tgy.TantargyId = -1
    INNER JOIN #tempOsztalyok o ON o.OsztalyId = mag.OsztalyId
  UNION
  SELECT
     tgy.TantargyId
    ,o.Osztalyid
    ,o.OsztalyNev
    ,tgy.TantargyNev
    ,szorg.SzorgAtlag
  FROM #tantargyak tgy
    INNER JOIN #osztalyokMagszorg szorg ON tgy.TantargyId = -2
    INNER JOIN #tempOsztalyok o ON o.OsztalyId = szorg.OsztalyId

  IF @pElmeletgyakorlat = 0
  BEGIN
    SELECT
       OsztalyId
      ,Tipus
      ,Igazolt
      ,SUM(KESESPERC)/45 as Késés
      ,SUM(MulasztasokSzama) as Mulasztás
    FROM #tempMulasztas
    GROUP BY OsztalyId,Tipus,Igazolt
  END
  ELSE 
  BEGIN
    SELECT
       OsztalyId
      ,Tipus
      ,Igazolt
      ,Gyakorlati
      ,SUM(KESESPERC)/45 as Késés
      ,SUM(MulasztasokSzama) as Mulasztás
    FROM #tempMulasztas
    GROUP BY OsztalyId,Tipus,Igazolt,Gyakorlati
  END

  -- iktatási adatok (ez maradjon az utolsó tábla)
  SELECT
     tempo.OsztalyId
    ,ocs.C_EVFOLYAMTIPUSA AS EvfolyamTipusa
    ,ocs.C_FELADATELLATASIHELYID AS FeladatEllatasiHelyId
    ,ocs.C_KEPZESIFORMA AS KepzesiForma
    ,o.C_OSZTALYFONOKID AS OsztalyfonokId
    ,o.C_TANTERVID AS TantervId
    ,o.C_AJPROGRAM AS OJAranyJanosProgram
    ,ocs.C_KERESZTFELEVES AS OJCSJKeresztfeleves
    ,o.C_KETTANNYELVU AS OJKettannyelvu
    ,ocs.C_ISGYOGYPEDAGOGIAILOGOPEDIAI AS OJIsGyogypedagogiaiLogopediai
    ,o.C_NEMZETISEGI AS OJNemzetisegi
    ,o.C_NYELVIELOKESZITO AS OJNyelviElokeszito
    ,o.C_SPORT AS OJSportOsztaly
    ,ocs.C_ISTECHNIKAI AS OJTechnikaiOsztaly
    ,o.C_SZAKMACSOPORT AS SzakmaCsoport
    ,o.C_AGAZAT AS Agazat
    ,o.C_SZAKKEPESITES AS Szakkepesites
    ,o.C_RESZSZAKKEPESITES AS Reszszakkepesites 
    ,o.C_AGAZATUJSZKTTIPUSID AS UjSzktAgazat
    ,o.C_SZAKMATIPUSID AS UjSzktSzakma
    ,o.C_SZAKMAIRANYTIPUSID AS UjSzktSzakmairany
    ,o.C_TANULMANYITERULETNKTTIPUSID AS NktTanulmanyiTerulet
    ,o.C_SZAKKEPESITESNKTTIPUSID AS NktSzakkepesites
    ,o.C_SZAKIRANYNKTTIPUSID AS NktSzakirany
  FROM #tempOsztalyok tempo
    INNER JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.ID = tempo.OsztalyId
      AND ocs.TOROLT = 'F'
    INNER JOIN T_OSZTALY_OSSZES o ON o.ID = ocs.ID
      AND o.TOROLT ='F'
  -- iktatási adatok vége
END
GO
