﻿DROP PROCEDURE IF EXISTS [dbo].[sp_Nyomtatvany_Excel_OsztalyTanuloinakGyakorlatiOraMulasztasiSzazalekStatisztika]
GO

CREATE PROCEDURE [dbo].[sp_Nyomtatvany_Excel_OsztalyTanuloinakGyakorlatiOraMulasztasiSzazalekStatisztika]
  @pTanevId INT,
  @pOsztalyId INT,
  @pMulasztasTipusIdKeses INT = 1499,
  @pMulasztasTipusIdHianyzas INT = 1500,
  @pTanevrendjeTanevKezdeteNaptipusId INT = 1394, --Tanévrendje első nap típus
  @pMegtartottVagyMegtarthato INT = 1,
  @pAtsoroltTanuloAdatok INT = 1,
  @tanitasiHetekSzamaVegzos INT,
  @tanitasiHetekSzamaNemVegzos INT,
  @isAltantargyBeszamitasa BIT
AS
  BEGIN 
  SET NOCOUNT ON;

DECLARE @iskolaErdekuParam INT = 1683;
DECLARE @iskolaErdekuSzamit BIT = dbo.fnGetRendszerbeallitasEnumBool(@iskolaErdekuParam, (SELECT C_INTEZMENYID FROM T_TANEV_OSSZES WHERE ID = @pTanevId), @pTanevId);
DECLARE @idoszakEleje DATE = (
SELECT ISNULL(
  (SELECT TOP 1 C_DATUM
    FROM T_TANEVRENDJE_OSSZES
    LEFT JOIN T_OSZTALYCSOPORT_TANEVRENDJE ON T_TANEVRENDJE_OSSZES.ID = T_OSZTALYCSOPORT_TANEVRENDJE.C_TANEVRENDJEID
    WHERE C_TANEVID = @pTanevId AND C_NAPTIPUSA = @pTanevrendjeTanevKezdeteNaptipusId AND TOROLT = 'F' AND (C_OSZTALYCSOPORTID IS NULL OR C_OSZTALYCSOPORTID = @pOsztalyId)
    ORDER BY C_OSZTALYCSOPORTID DESC),
  (SELECT TOP 1 C_KEZDONAP FROM T_TANEV_OSSZES WHERE ID = @pTanevId))
);
DECLARE @idoszakVege DATE = GETDATE();
DECLARE @osztalyTanulok TABLE (TANULOID INT PRIMARY KEY, TANULONEV NVARCHAR(MAX), BELEPESDATUM DATE, KILEPESDATUM DATE, OKTATASIAZONOSITO NVARCHAR(20));
DECLARE @tantargyak TABLE(TANTARGYID INT, TANTARGY_NEV NVARCHAR(MAX), TARGYKATEGORIA_NEV NVARCHAR(MAX), TARGYKATEGORIA_SORSZAM INT, C_FOTARGYE CHAR(1), C_ALTANTARGYKENTNYOMTATVANYBAN CHAR(1));
INSERT INTO @osztalyTanulok (TANULOID, TANULONEV, BELEPESDATUM, KILEPESDATUM, OKTATASIAZONOSITO)
SELECT FELHASZNALO.ID AS TANULOID, C_NYOMTATASINEV, C_BELEPESDATUM, C_KILEPESDATUM, C_OKTATASIAZONOSITO
FROM T_FELHASZNALO_OSSZES AS FELHASZNALO
INNER JOIN (
  SELECT C_TANULOID, C_OSZTALYCSOPORTID, C_BELEPESDATUM, C_KILEPESDATUM
  FROM T_TANULOCSOPORT_OSSZES AS TANULOCSOPORT
  WHERE TANULOCSOPORT.TOROLT = 'F' AND TANULOCSOPORT.C_OSZTALYCSOPORTID = @pOsztalyId AND TANULOCSOPORT.C_BELEPESDATUM < @idoszakVege
  AND (TANULOCSOPORT.C_KILEPESDATUM IS NULL OR TANULOCSOPORT.C_KILEPESDATUM >= @idoszakVege)
) AS TANCSOPORT ON TANCSOPORT.C_TANULOID = FELHASZNALO.ID
WHERE FELHASZNALO.TOROLT = 'F' AND TANCSOPORT.C_OSZTALYCSOPORTID = @pOsztalyId AND FELHASZNALO.C_TANEVID = @pTanevId;

DECLARE @aktualisOsztalyCsoportok TABLE (OSZTALYCSOPORTID INT);
IF @pAtsoroltTanuloAdatok = 0
BEGIN
  INSERT INTO @aktualisOsztalyCsoportok (OSZTALYCSOPORTID)
  SELECT ID
  FROM fnGetDokumentumKapcsolodoOsztalycsoportok(@pOsztalyId, @pTanevId, DEFAULT, DEFAULT)
END
ELSE IF @pAtsoroltTanuloAdatok = 1
BEGIN
  INSERT INTO @aktualisOsztalyCsoportok (OSZTALYCSOPORTID)
  SELECT ID
  FROM fnGetDokumentumKapcsolodoOsztalycsoportok(@pOsztalyId, @pTanevId, DEFAULT, DEFAULT)
END
ELSE
BEGIN
  INSERT INTO @aktualisOsztalyCsoportok (OSZTALYCSOPORTID)
  SELECT ID
  FROM fnGetKapcsolodoOsztalycsoportokByDate(@pOsztalyId, @idoszakEleje, @idoszakVege)
  WHERE (ID IN (SELECT ID FROM T_OSZTALY_OSSZES) OR ID IN (SELECT ID FROM T_CSOPORT_OSSZES WHERE C_TIPUSA IN (SELECT ID FROM fnGetTanoraiCeluCsoportTipusok(@pTanevId))));
END

INSERT INTO @tantargyak (TANTARGYID, TANTARGY_NEV, TARGYKATEGORIA_NEV, TARGYKATEGORIA_SORSZAM, C_FOTARGYE, C_ALTANTARGYKENTNYOMTATVANYBAN)
SELECT DISTINCT TANTARGYAK.ID AS TANTARGYID, TANTARGY_NEV, TARGYKATEGORIA_NEV, TARGYKATEGORIA_SORSZAM, C_FOTARGYE, C_ALTANTARGYKENTNYOMTATVANYBAN
FROM (
  SELECT DISTINCT C_TANTARGYID AS ID, COALESCE(TANTARGY.C_NEVNYOMTATVANYBAN, TANTARGY.C_NEV) AS TANTARGY_NEV, TARGYKATEG.C_NAME AS TARGYKATEGORIA_NEV, TARGYKATEG.C_VALUE AS TARGYKATEGORIA_SORSZAM, C_FOTARGYE, C_ALTANTARGYKENTNYOMTATVANYBAN
  FROM T_FOGLALKOZAS_OSSZES
  INNER JOIN @aktualisOsztalyCsoportok AS OSZTALYCSOPORT ON OSZTALYCSOPORT.OSZTALYCSOPORTID = T_FOGLALKOZAS_OSSZES.C_OSZTALYCSOPORTID
  INNER JOIN T_TANTARGY_OSSZES AS TANTARGY ON TANTARGY.ID = T_FOGLALKOZAS_OSSZES.C_TANTARGYID AND TANTARGY.C_TANEVID = T_FOGLALKOZAS_OSSZES.C_TANEVID
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES AS TARGYKATEG ON TARGYKATEG.ID = TANTARGY.C_TARGYKATEGORIA AND TARGYKATEG.C_TANEVID = @pTanevId
  WHERE T_FOGLALKOZAS_OSSZES.TOROLT = 'F' AND TANTARGY.C_GYAKORLATI = 'T'
  UNION
  SELECT DISTINCT C_TANTARGYID AS ID, COALESCE(TANTARGY.C_NEVNYOMTATVANYBAN, TANTARGY.C_NEV) AS TANTARGY_NEV, TARGYKATEG.C_NAME AS TARGYKATEGORIA_NEV, TARGYKATEG.C_VALUE AS TARGYKATEGORIA_SORSZAM, C_FOTARGYE, C_ALTANTARGYKENTNYOMTATVANYBAN
  FROM T_TANITASIORA_OSSZES
  INNER JOIN T_TANTARGY_OSSZES AS TANTARGY ON TANTARGY.ID = T_TANITASIORA_OSSZES.C_TANTARGYID AND TANTARGY.C_TANEVID = T_TANITASIORA_OSSZES.C_TANEVID
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES AS TARGYKATEG ON TARGYKATEG.ID = TANTARGY.C_TARGYKATEGORIA AND TARGYKATEG.C_TANEVID = @pTanevId
  WHERE T_TANITASIORA_OSSZES.TOROLT = 'F' AND C_OSZTALYCSOPORTID IN (SELECT OSZTALYCSOPORTID FROM @aktualisOsztalyCsoportok) AND TANTARGY.C_GYAKORLATI = 'T'
) AS TANTARGYAK
ORDER BY TARGYKATEGORIA_SORSZAM, TANTARGY_NEV;

SELECT DISTINCT
   TANULOID
  ,TANULONEV
  ,OKTATASIAZONOSITO
FROM @osztalyTanulok
ORDER BY TANULONEV

SELECT DISTINCT
   TANTARGYID
  ,TANTARGY_NEV
FROM @tantargyak

SELECT
  *
INTO #tempMulasztas
FROM fnGetDokumentumMulasztasokOsztalyonkentReszletes (@pTanevId, @pOsztalyId, @iskolaErdekuSzamit, DEFAULT, @pAtsoroltTanuloAdatok, DEFAULT, DEFAULT, DEFAULT) WHERE Tipusa IN (@pMulasztasTipusIdKeses, @pMulasztasTipusIdHianyzas)
CREATE TABLE #tempTanorak (Orakszama INT, TanuloId INT, TantargyId INT, TantargyNev NVARCHAR(MAX) COLLATE Hungarian_CI_AI, Fotargye CHAR(1) COLLATE Hungarian_CI_AI, Altargye CHAR(1) COLLATE Hungarian_CI_AI, Gyakorlati CHAR(1) COLLATE Hungarian_CI_AI)

IF @pMegtartottVagyMegtarthato = 1
BEGIN
  INSERT INTO #tempTanorak
  SELECT
     Orakszama
    ,TanuloId
    ,TantargyId
    ,TantargyNev
    ,Fotargye
    ,Altargye
    ,Gyakorlati
  FROM fnGetDokumentumOsztalyTanuloinakMegtarthatoOrakTantargyankent (@pTanevId, @pOsztalyId, @pAtsoroltTanuloAdatok, @tanitasiHetekSzamaVegzos, @tanitasiHetekSzamaNemVegzos, @isAltantargyBeszamitasa)
END
ELSE
BEGIN
  INSERT INTO #tempTanorak
  SELECT
     Orakszama
    ,TanuloId
    ,TantargyId
    ,TantargyNev
    ,Fotargye
    ,Altargye
    ,Gyakorlati
  FROM fnGetDokumentumOsztalyTanuloinakMegtartottOrakTantargyankent (@pTanevId, @pOsztalyId)
END
SELECT
   MegtartottOrak.TanuloId
  ,MegtartottOrak.TantargyId
  ,MegtartottOrak.Gyakorlati
  ,ISNULL(1.0 * Mulasztasokszam / NULLIF(Orakszama, 0), 0) AS MulasztasArany
  ,ISNULL(100.0 * Mulasztasokszam / NULLIF(Orakszama, 0), 0) AS MulasztasSzazalek
  ,CAST(Mulasztasokszam AS NVARCHAR) + '/' + CAST(Orakszama AS NVARCHAR) AS Info
FROM (
  SELECT SUM(CAST(IIF(Tipusa = @pMulasztasTipusIdHianyzas, 1, IIF(Tipusa = @pMulasztasTipusIdKeses,CAST(KesesPercben AS FLOAT) / 45, 0)) AS FLOAT)) AS Mulasztasokszam, TanuloId, TantargyId, Gyakorlati
  FROM #tempMulasztas
  WHERE Gyakorlati = 'T'
  GROUP BY TanuloId, TantargyId, Gyakorlati
) AS Mulasztasok
INNER JOIN (
  SELECT Orakszama, Tanuloid, TantargyId, Gyakorlati, TantargyNev
  FROM #tempTanorak
  WHERE Gyakorlati = 'T'
) AS MegtartottOrak
 ON MegtartottOrak.TantargyId = Mulasztasok.TantargyId
AND MegtartottOrak.TanuloId = Mulasztasok.TanuloId
AND MegtartottOrak.Gyakorlati = Mulasztasok.Gyakorlati
ORDER BY TanuloId, TantargyId
SELECT
   MegtartottOrak.TanuloId
  ,MegtartottOrak.Gyakorlati
  ,ISNULL(1.0 * Mulasztasokszam / NULLIF(Orakszama, 0), 0) AS MulasztasArany
  ,ISNULL(100.0 * Mulasztasokszam / NULLIF(Orakszama, 0), 0) AS MulasztasSzazalek
  ,CAST(Mulasztasokszam AS NVARCHAR) + '/' + CAST(Orakszama AS NVARCHAR) AS Info
FROM (
  SELECT SUM(CAST(IIF(Tipusa = @pMulasztasTipusIdHianyzas, 1, IIF(Tipusa = @pMulasztasTipusIdKeses,CAST(KesesPercben AS FLOAT) / 45, 0)) AS FLOAT)) AS Mulasztasokszam, TanuloId, Gyakorlati
  FROM #tempMulasztas
  WHERE Gyakorlati = 'T'
  GROUP BY TanuloId, Gyakorlati
) AS Mulasztasok
INNER JOIN (
  SELECT Tanuloid, Gyakorlati, SUM(Orakszama) as Orakszama
  FROM #tempTanorak
  WHERE Gyakorlati = 'T'
  GROUP BY Tanuloid, Gyakorlati
) AS MegtartottOrak
 ON
 MegtartottOrak.TanuloId = Mulasztasok.TanuloId
AND MegtartottOrak.Gyakorlati = Mulasztasok.Gyakorlati
ORDER BY TanuloId
IF OBJECT_ID('tempdb..#tempTanorak') IS NOT NULL DROP TABLE #tempTanorak
IF OBJECT_ID('tempdb..#tempMulasztas') IS NOT NULL DROP TABLE #tempMulasztas

    -- Osztály adatok az iktatáshoz
  SELECT
     f.C_NYOMTATASINEV    Osztalyfonok
    ,f.ID          OsztalyfonokId
    ,ocs.C_NEV        Osztalynev
    ,@pOsztalyId        OsztalyId
    ,ocs.C_EVFOLYAMTIPUSA    EvfolyamTipusa
    ,ocs.C_FELADATELLATASIHELYID FeladatEllatasiHelyId
    ,o.C_TANTERVID      TantervId
    ,ocs.C_KEPZESIFORMA    KepzesiForma
    ,o.C_AGAZAT        Agazat
    ,o.C_SZAKMACSOPORT    SzakmaCsoport
    ,o.C_SZAKKEPESITES    Szakkepesites
    ,o.C_RESZSZAKKEPESITES  Reszszakkepesites
    ,o.C_AGAZATUJSZKTTIPUSID AS UjSzktAgazat
    ,o.C_SZAKMATIPUSID AS UjSzktSzakma
    ,o.C_SZAKMAIRANYTIPUSID AS UjSzktSzakmairany
    ,o.C_TANULMANYITERULETNKTTIPUSID AS NktTanulmanyiTerulet
    ,o.C_SZAKKEPESITESNKTTIPUSID AS NktSzakkepesites
    ,o.C_SZAKIRANYNKTTIPUSID AS NktSzakirany
    ,ocs.C_KERESZTFELEVES  OJCSJKeresztfeleves
    ,ocs.C_VEGZOSEVFOLYAM  CSJVegzosEvfolyamu
    ,ocs.C_ISTECHNIKAI  OJTechnikaiOsztaly
    ,o.C_NEMZETISEGI    OJNemzetisegi
    ,o.C_KETTANNYELVU    OJKettannyelvu
    ,o.C_NYELVIELOKESZITO  OJNyelviElokeszito
    ,ocs.C_ISGYOGYPEDAGOGIAILOGOPEDIAI      OJIsGyogypedagogiaiLogopediai
    ,o.C_SPORT        OJSportOsztaly
    ,o.C_AJPROGRAM      OJAranyJanosProgram
  FROM T_OSZTALYCSOPORT_OSSZES ocs
    INNER JOIN T_OSZTALY_OSSZES o ON o.ID = ocs.id
    LEFT JOIN T_FELHASZNALO_OSSZES f ON f.ID = o.C_OSZTALYFONOKID
  WHERE
    ocs.ID = @pOsztalyId AND ocs.C_TANEVID = @pTanevId AND ocs.TOROLT = 'F';
END;

GO