-- =============================================
-- Description:  <Ellenőrizzuk, hogy a tanulóknak van-e már egyszer adható tanuló értékelése, ha nincs akkor true, ha van akkor false>
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[uspCheckTanuloListEgyszerAdhatoTanuloErtekelesValidation]
GO

CREATE PROCEDURE [dbo].[uspCheckTanuloListEgyszerAdhatoTanuloErtekelesValidation]
   @pTanuloErtekelesList  XML
  ,@pTipusId        INT
  ,@pTantargyId      INT    = NULL
  ,@pDatum        DATE  = NULL
  ,@pFeladatKategoriaId  INT
  ,@pAmiKategoriaId    INT
AS
BEGIN
  SET NOCOUNT ON;
  
  IF @pDatum IS NULL
    SET @pDatum = CONVERT(DATE, GETDATE())

  DECLARE @TempTanuloErtekelesList TABLE (C_TANULOID INT, ID INT)

  INSERT INTO @TempTanuloErtekelesList
  SELECT DISTINCT 
     C_TANULOID = tanuloErtekeles.value('(./tanuloId)[1]', 'INT')
    ,ID      = tanuloErtekeles.value('(./id)[1]', 'INT')
  FROM @pTanuloErtekelesList.nodes('tanuloErtekelesList') AS tanuloErtekelesList(tanuloErtekeles)

  IF EXISTS (  
    SELECT 1
    FROM 
      T_TANULOERTEKELES_OSSZES TanuloErtekeles
    INNER JOIN 
      T_OSZTALYCSOPORT_OSSZES Osztaly ON
          Osztaly.ID            = TanuloErtekeles.C_ROGZITESKORITANULOOSZTALYID
        AND  Osztaly.TOROLT          = 'F'
        AND Osztaly.C_TANEVID        = TanuloErtekeles.C_TANEVID
        AND Osztaly.C_FELADATKATEGORIAID  = @pFeladatKategoriaId
        AND Osztaly.C_EVFOLYAMTIPUSA    = IIF(@pFeladatKategoriaId = @pAmiKategoriaId, NULL, (SELECT EvfolyamTipusId FROM dbo.fnGetTanuloOsztaly(TanuloErtekeles.C_TANULOID, @pDatum, @pFeladatKategoriaId, 1, DEFAULT)))
    LEFT JOIN 
      @TempTanuloErtekelesList TanuloErtekelesToEdit ON
        TanuloErtekeles.C_TANULOID      = TanuloErtekelesToEdit.C_TANULOID
    WHERE 
        TanuloErtekeles.TOROLT        = 'F'
      AND TanuloErtekeles.C_TIPUSID      = @pTipusId
      AND TanuloErtekeles.C_TANULOID      = TanuloErtekelesToEdit.C_TANULOID
      AND (TanuloErtekelesToEdit.ID IS NULL OR
         TanuloErtekeles.ID          != TanuloErtekelesToEdit.ID)
      AND (@pTantargyId IS NOT NULL AND @pTantargyId = TanuloErtekeles.C_TANTARGYID OR
         @pTantargyId IS NULL AND TanuloErtekeles.C_TANTARGYID IS NULL)
      AND TanuloErtekeles.C_ROGZITESKORITANULOOSZTALYID IS NOT NULL

    UNION ALL

    SELECT 1
    FROM 
      T_TANULOERTEKELES_OSSZES TanuloErtekeles
    INNER JOIN T_OSZTALYCSOPORT_OSSZES Osztaly ON 
        Osztaly.ID              = TanuloErtekeles.C_OSZTALYCSOPORTID
      AND  Osztaly.TOROLT            = 'F' 
      AND Osztaly.C_TANEVID          = TanuloErtekeles.C_TANEVID
      AND Osztaly.C_FELADATKATEGORIAID    = @pFeladatKategoriaId
    LEFT JOIN 
      @TempTanuloErtekelesList TanuloErtekelesToEdit ON
        TanuloErtekeles.C_TANULOID      = TanuloErtekelesToEdit.C_TANULOID
    WHERE  
        TanuloErtekeles.TOROLT        = 'F'
      AND TanuloErtekeles.C_TIPUSID      = @pTipusId
      AND TanuloErtekeles.C_TANULOID      = TanuloErtekelesToEdit.C_TANULOID
      AND (TanuloErtekelesToEdit.ID IS NULL OR
         TanuloErtekeles.ID          != TanuloErtekelesToEdit.ID)
      AND (@pTantargyId IS NOT NULL AND @pTantargyId = TanuloErtekeles.C_TANTARGYID OR
         @pTantargyId IS NULL AND TanuloErtekeles.C_TANTARGYID IS NULL)
      AND @pFeladatKategoriaId = @pAmiKategoriaId
  )
        SELECT 1
    ELSE
        SELECT 0

END
GO