DROP PROCEDURE  IF EXISTS uspGetAlkalmazottakEugyintezesByKretaAzonosito
GO

CREATE PROCEDURE uspGetAlkalmazottakEugyintezesByKretaAzonosito 
   @pTanevKretaAzonosito INT
AS
BEGIN
  SET NOCOUNT ON;

  SELECT Alkalmazott.ID AS KretaAzonosito
    ,Felhasznalo.C_NYOMTATASINEV AS Nev
    ,MunkaugyiAdatok.C_VEZETOIORASZAMOK AS Titulus
    ,Felhasznalo.C_EGYEDIAZONOSITO AS EgyediAzonosito
    ,Felhasznalo.C_IDPEGYEDIAZONOSITO AS IdpEgyediAzonosito
  FROM T_ALKALMAZOTT_OSSZES AS Alkalmazott
  INNER JOIN T_FELHASZNALO_OSSZES AS Felhasznalo ON Alkalmazott.ID = Felhasznalo.ID AND Felhasznalo.TOROLT = 'F'
  INNER JOIN T_MUNKAUGYIADATOK_OSSZES MunkaugyiAdatok ON MunkaugyiAdatok.C_ALKALMAZOTTID = Alkalmazott.ID AND MunkaugyiAdatok.TOROLT = 'F'
  WHERE Alkalmazott.C_ALTANEVID = @pTanevKretaAzonosito
  AND Alkalmazott.TOROLT = 'F'
  ORDER BY Felhasznalo.C_NYOMTATASINEV
END
GO


