DROP PROCEDURE IF EXISTS uspGetAlkalmazottakSapAzonositoi
GO
  CREATE PROCEDURE uspGetAlkalmazottakSapAzonositoi
     @pAlkalmazottId INT
    ,@pTanevId INT
    ,@pIntezmenyId INT
  AS
  BEGIN
    SET NOCOUNT ON;

    SELECT a.ID AS 'AlkalmazottId'
      ,a.ELOZOTANEVIREKORDID AS 'ElozoTaneviAlkalmazottId'
      ,a.C_SZTSZKOD AS 'SzTSzKod'
      ,ISNULL(mh.C_FUNKCIOTERULET, ia.C_SAPAZONOSITO) AS 'IntezmenySAPKod'
      ,a.C_KOTELEZOEVESSZABADSAGKERET AS 'SzabadsagKeret'
    FROM T_ALKALMAZOTT_OSSZES a
    INNER JOIN T_INTEZMENY_OSSZES i ON i.ID = a.C_ALINTEZMENYID
    INNER JOIN T_INTEZMENYADATOK_OSSZES ia ON ia.C_INTEZMENYID = i.ID   AND ia.TOROLT = 'F'
    INNER JOIN T_MUNKAUGYIADATOK_OSSZES ma ON ma.C_ALKALMAZOTTID = a.ID
      AND ma.TOROLT = 'F'
    INNER JOIN T_FELADATELLATASIHELY_OSSZES fh ON fh.ID = ma.C_FELADATELLATASIHELYID
      AND fh.TOROLT = 'F'
    INNER JOIN T_MUKODESIHELY_OSSZES mh ON mh.ID = fh.C_MUKODESIHELYID
      AND mh.TOROLT = 'F' WHERE a.TOROLT = 'F'
      AND (
        a.ID = @pAlkalmazottId
        OR @pAlkalmazottId IS NULL
        )
      AND a.C_ALINTEZMENYID = @pIntezmenyId
      AND a.C_ALTANEVID = @pTanevId
      AND i.TOROLT = 'F'
      AND a.TOROLT = 'F'
  END
GO


