﻿DROP PROCEDURE IF EXISTS uspGetExportAdatokForOrarendekTorlese
GO

CREATE PROCEDURE uspGetExportAdatokForOrarendekTorlese
   @pTanevId int
  ,@pIntervallumKezdete datetime
  ,@pIntervallumVege datetime
  ,@pNezetTipus int
  ,@pFeladatellatasiHelyJson nvarchar(max) = NULL
  ,@pOsztalyJson nvarchar(max) = NULL
  ,@pCsoportJson nvarchar(max) = NULL
AS
BEGIN
  SET NOCOUNT ON

  CREATE TABLE #OrarendiOrak (Id int, ErvenyessegKezdete datetime, ErvenyessegVege datetime, Oraszam int)

  INSERT INTO #OrarendiOrak
  EXEC uspGetOrarendiOrakForOrarendekTorlese @pTanevId, @pIntervallumKezdete, @pIntervallumVege, @pNezetTipus, @pFeladatellatasiHelyJson, @pOsztalyJson, @pCsoportJson

  -- Jelmagyarázat:
  -- D1: Intervallum kezdete
  -- D2: Intervallum vége
  -- ÉK: Órarend érvényességének kezdete 
  -- ÉV: Órarend érvényességének vége

  SELECT
     Id
    ,CASE
      -- Ha az óra érvényessége teljesen a D1 és D2 között van (D1 <= ÉK <= ÉV <= D2), akkor a teljes elemet ki kell tenni az exportba.
      WHEN @pIntervallumKezdete <= ErvenyessegKezdete AND ErvenyessegVege <= @pIntervallumVege THEN ErvenyessegKezdete

      -- Ha ÉK < D1 <= ÉV <= D2, akkor D1-től ÉV-ig érvényességű elem kell az exportba.
      WHEN ErvenyessegKezdete < @pIntervallumKezdete AND @pIntervallumKezdete <= ErvenyessegVege AND ErvenyessegVege <= @pIntervallumVege THEN @pIntervallumKezdete

      -- Ha D1 <= ÉK <= D2 < ÉV, akkor ÉK-től D2+1-ig érvényességű elem kell az exportba.
      WHEN @pIntervallumKezdete <= ErvenyessegKezdete AND ErvenyessegKezdete <= @pIntervallumVege AND @pIntervallumVege <= ErvenyessegVege THEN ErvenyessegKezdete

      -- Ha ÉK < D1 <= D2 < ÉV, akkor egy D1-től D2+1-ig érvényességű elem kell az exportba.
      WHEN ErvenyessegKezdete < @pIntervallumKezdete AND @pIntervallumVege < ErvenyessegVege THEN @pIntervallumKezdete
     END AS ErvenyessegKezdete
    ,CASE
      -- Ha az óra érvényessége teljesen a D1 és D2 között van (D1 <= ÉK <= ÉV <= D2), akkor a teljes elemet ki kell tenni az exportba.
      WHEN @pIntervallumKezdete <= ErvenyessegKezdete AND ErvenyessegVege <= @pIntervallumVege THEN ErvenyessegVege

      -- Ha ÉK < D1 <= ÉV <= D2, akkor D1-től ÉV-ig érvényességű elem kell az exportba.
      WHEN ErvenyessegKezdete < @pIntervallumKezdete AND @pIntervallumKezdete <= ErvenyessegVege AND ErvenyessegVege <= @pIntervallumVege THEN ErvenyessegVege

      -- Ha D1 <= ÉK <= D2 < ÉV, akkor ÉK-től D2+1-ig érvényességű elem kell az exportba.
      WHEN @pIntervallumKezdete <= ErvenyessegKezdete AND ErvenyessegKezdete <= @pIntervallumVege AND @pIntervallumVege <= ErvenyessegVege THEN DATEADD(day, 1, @pIntervallumVege)

      -- Ha ÉK < D1 <= D2 < ÉV, akkor egy D1-től D2+1-ig érvényességű elem kell az exportba.
      WHEN ErvenyessegKezdete < @pIntervallumKezdete AND @pIntervallumVege < ErvenyessegVege THEN DATEADD(day, 1, @pIntervallumVege) 
     END AS ErvenyessegVege
    ,CONVERT(bit, IIF(Oraszam IS NULL, 1, 0)) AS IsNapirend
  FROM #OrarendiOrak

END
GO