﻿DROP PROCEDURE  IF EXISTS uspGetNemAllamiGrid 
GO

CREATE PROCEDURE uspGetNemAllamiGrid
  @pTanevId INT
AS
BEGIN
  SET NOCOUNT ON;
  SELECT
     fh.Id AS ID
    ,C_MUKODESIHELYAZONOSITO AS MukodesiHelyAzonosito
    ,C_NEV AS MukodesihelyNeve
    ,C_IRANYITOSZAM + ' ' + C_VAROS  
      + ISNULL( ', ' + C_KOZTERULETNEV + ' ', '') 
      + ISNULL(C_KOZTERULETJELLEGENEV + ' ','') 
      + ISNULL(C_HAZSZAM, '')  
      + ISNULL(', ' + C_EMELET + '. emelet', '') 
      + ISNULL(', ' + C_AJTO + '. ajtó', '') AS MukodesihelyCime
    ,dic.C_NAME AS EllatottFeladat
    ,ISNULL(C_AAOSZLOP + C_ACOSZLOP + C_AHOSZLOP + C_GOSZLOP, 0) AS BevetelOsszesen
    ,ISNULL(C_SOSZLOP + C_UOSZLOP + C_TOSZLOP + C_VOSZLOP + C_WOSZLOP + C_HOSZLOP + C_LOSZLOP + C_POSZLOP + C_ROSZLOP, 0) AS KiadasOsszesen
    ,ISNULL(C_HOSZLOP + C_LOSZLOP + C_POSZLOP + C_ROSZLOP, 0) AS SzemelyiJelleguKifizetesek 
  FROM T_MUKODESIHELY_OSSZES mh
    INNER JOIN T_FELADATELLATASIHELY_OSSZES fh ON fh.C_MUKODESIHELYID = mh.ID AND fh.TOROLT = 'F'
    INNER JOIN T_DICTIONARYITEMBASE_OSSZES dic ON dic.ID = fh.C_OKTATASINEVELESIFELADATTIPUS AND dic.TOROLT = 'F' AND dic.C_TANEVID = mh.C_TANEVID
    LEFT JOIN T_SZIRSTATNEMALLAMIOKTKOLTS_OSSZES sz ON fh.ID = sz.C_FELADATELLATASIHELYID AND sz.TOROLT = 'F'
  WHERE 
    mh.C_TANEVID = @pTanevId
    AND mh.TOROLT = 'F'
END
GO