﻿DROP PROCEDURE IF EXISTS [dbo].[uspGetSzakkepzesiJuttatasokTanulokDashboardAdatok]
GO

CREATE PROCEDURE [dbo].[uspGetSzakkepzesiJuttatasokTanulokDashboardAdatok]
  @pTanevId int
AS BEGIN
  SET NOCOUNT ON;

  DECLARE @DefaultFeladatKategoriaId int = 7553 /*OktNevelesiKategoriaEnum.Alapkepzes*/

  SELECT
     f.C_NYOMTATASINEV AS TanuloNeve
    ,f.C_ANYJANEVE AS AnyjaNeve
    ,f.C_SZULETESIHELY AS SzuletesiHely
    ,f.C_SZULETESIDATUM AS SzuletesiIdo
    ,f.C_OKTATASIAZONOSITO AS OktatasiAzonosito
    ,ocs.C_NEV AS Osztaly
    ,IIF(ocs.C_EVFOLYAMTIPUSA = 7366, tta.C_TANULOEVFOLYAMTIPUSID, ocs.C_EVFOLYAMTIPUSA) AS Evfolyam
    ,t.C_BANKSZAMLASZAM AS Bankszamlaszam
    ,t.C_BANKSZAMLATULAJDONOSTIPUSID AS BankszamlaTulajdonosa
    ,t.C_BANKSZAMLATULAJNEVE AS BankszamlaTulajdonosNeve
    ,f.C_TAJSZAM AS TajSzam
    ,j.C_OSSZEG AS OsztondijOsszege
    ,j.C_ISJOGOSULT AS IsJogosult
  FROM T_TANULO_OSSZES t
    INNER JOIN T_FELHASZNALO_OSSZES f ON f.ID = t.ID AND f.TOROLT = 'F'
    INNER JOIN T_TANULOCSOPORT_OSSZES tcs ON tcs.C_TANULOID = t.ID AND tcs.TOROLT = 'F'
    INNER JOIN T_OSZTALY_OSSZES o ON o.ID = tcs.C_OSZTALYCSOPORTID AND o.TOROLT = 'F'
    INNER JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.ID = o.ID AND ocs.TOROLT = 'F' AND C_FELADATKATEGORIAID = @DefaultFeladatKategoriaId
    LEFT JOIN T_TANULOTANUGYIADATOK_OSSZES tta ON tta.C_TANULOCSOPORTID = tcs.ID AND tta.TOROLT = 'F'
    LEFT JOIN T_JUTTATAS_OSSZES j ON j.C_TANULOID = t.ID AND j.TOROLT = 'F' AND j.C_ISAKTIV = 'T' AND j.C_JUTTATASTIPUSID = 7888
  WHERE
     t.C_ALTANEVID = @pTanevId
     AND t.TOROLT = 'F'

END