DROP PROCEDURE IF EXISTS uspInsertTanuloHazifeladatStatusz
GO

CREATE PROCEDURE uspInsertTanuloHazifeladatStatusz
  @pIntezmenyId int
  ,@pTanevId int
  ,@pHazifeladatId int
  ,@pOsztalyCsoportId int
  ,@pUserId int
  ,@pDatum datetime
AS BEGIN
  SET NOCOUNT ON
  
  INSERT INTO T_TANULOHAZIFELADATSTATUSZ (
    C_ISMEGOLDVA
    ,C_MEGOLDASIDEJE
    ,C_TANULOID
    ,C_HAZIFELADATOKID
    ,C_INTEZMENYID, C_TANEVID, TOROLT, SERIAL, LASTCHANGED, CREATED, MODIFIER, CREATOR
  )
  SELECT
    'F'
    ,NULL
    ,tcs.C_TANULOID
    ,@pHazifeladatId
    ,@pIntezmenyId, @pTanevId, 'F', 0, GETDATE(), GETDATE(), NULL, @pUserId
  FROM T_TANULOCSOPORT tcs
    JOIN T_OSZTALYCSOPORT ocs ON ocs.ID = tcs.C_OSZTALYCSOPORTID and ocs.TOROLT = 'F'
  WHERE
    tcs.C_OSZTALYCSOPORTID = @pOsztalyCsoportId AND tcs.C_INTEZMENYID = @pIntezmenyId AND tcs.C_TANEVID = @pTanevId
    AND tcs.C_BELEPESDATUM <= ISNULL(@pDatum, CONVERT(date, GETDATE()))
    AND (tcs.C_KILEPESDATUM IS NULL OR tcs.C_KILEPESDATUM > ISNULL(@pDatum, CONVERT(date, GETDATE())))

END
GO