﻿-- ===================================================================================================
-- KIRSTAT - Felhasználó - Tanorán kívüli csoportok
-- ===================================================================================================
-- 5. MUNKALAP – ALSÓ – A02T15 - A SZERVEZETT TANÓRÁN KÍVÜLI FOGLALKOZÁSOK NYITÓADATAI                      

DROP PROCEDURE IF EXISTS uspKIRstat_FelhasznaloTanoranKivuliCsoport
GO

CREATE PROCEDURE uspKIRstat_FelhasznaloTanoranKivuliCsoport
   @pFeladatEllatasiHelyId int
  ,@pTanevid int
  ,@pIsKirstat bit = 1
AS
BEGIN
  SET NOCOUNT ON;
  DECLARE 
     @statDatum datetime

  SET @statDatum = (SELECT LEFT(C_NEV, 4) FROM T_TANEV WHERE ID = @pTanevId) + IIF(@pIsKirstat = 1, '1001', '1008')

  SELECT 
     ocs.C_NEV
    ,CASE cs.C_TIPUSA 
       WHEN 1035 THEN 'Napközi'
       WHEN 1041 THEN 'Művészeti csoport'
       WHEN 1039 THEN 'Önképzőkör'
       WHEN 1042 THEN 'Iskolai sportkör'
       WHEN 1040 THEN 'Énekkar'
       WHEN 1037 THEN 'Szakkör, érdeklődési kör'
       WHEN 1038 THEN 'Szakkör, érdeklődési kör'
       ELSE 'Délutáni egyéb foglalkozás'
     END AS Besorolas
    ,d.C_NAME AS CsoportTipus
    ,tcs.TanulokSzama AS TanulokSzama
    ,f.HetiOraszam AS PedagogusOraszam
  FROM T_OSZTALYCSOPORT_OSSZES ocs
    INNER JOIN T_CSOPORT_OSSZES cs ON cs.ID = ocs.ID AND cs.TOROLT = 'F'
    INNER JOIN T_CSOPORTTIPUS_OSSZES cst ON cst.ID = cs.C_TIPUSA 
      AND cst.C_ALTANEVID = cs.C_ALTANEVID 
      AND cst.C_ISTANORAICELU = 'F' 
      AND cst.TOROLT = 'F'
    INNER JOIN T_DICTIONARYITEMBASE_OSSZES d ON d.ID = cst.ID 
      AND d.C_TANEVID = cst.C_ALTANEVID 
      AND d.TOROLT = 'F'
    CROSS APPLY (
      SELECT SUM(f.C_ORASZAM) AS HetiOraszam 
      FROM T_FOGLALKOZAS_OSSZES f 
      WHERE f.C_OSZTALYCSOPORTID = ocs.ID 
        AND f.TOROLT = 'F'
    ) f
    CROSS APPLY (
      SELECT COUNT(1) AS TanulokSzama 
      FROM T_TANULOCSOPORT_OSSZES tcs 
      WHERE tcs.C_OSZTALYCSOPORTID = ocs.ID 
        AND tcs.C_BELEPESDATUM <= @statDatum AND (tcs.C_KILEPESDATUM > @statDatum OR tcs.C_KILEPESDATUM IS NULL) 
        AND tcs.TOROLT = 'F'
        AND EXISTS (
          SELECT 1 
          FROM T_TANULOCSOPORT_OSSZES tcs2 
            INNER JOIN T_OSZTALY_OSSZES o ON o.ID = tcs2.C_OSZTALYCSOPORTID  AND o.TOROLT = 'F'
            INNER JOIN T_OSZTALYCSOPORT ocs2 ON ocs2.ID = tcs2.C_OSZTALYCSOPORTID 
              AND ocs2.C_FELADATELLATASIHELYID = @pFeladatEllatasiHelyId 
              AND ocs2.TOROLT = 'F'
          WHERE tcs2.C_TANULOID = tcs.C_TANULOID
            AND tcs2.TOROLT = 'F'
            AND ocs2.C_KEPZESIFORMA = 1096 /*nappali*/
            AND tcs2.C_BELEPESDATUM <= @statDatum 
            AND (tcs2.C_KILEPESDATUM > @statDatum OR tcs2.C_KILEPESDATUM IS NULL)
        )
    ) tcs
  WHERE ocs.TOROLT = 'F'
    AND ocs.C_TANEVID = @pTanevId
    AND ocs.C_FELADATELLATASIHELYID = @pFeladatEllatasiHelyId
END
GO
