DROP PROCEDURE IF EXISTS [dbo].[uspUpdateNaplosorszamListGroup]
GO

CREATE PROCEDURE [dbo].[uspUpdateNaplosorszamListGroup]
   @pOsztalyIdList XML
AS
BEGIN

  SET NOCOUNT ON;

  SELECT 
    ID = osztalyId.value('number((.)[1])', 'INT')
  INTO 
    #TempOsztalyIdList
  FROM 
    @pOsztalyIdList.nodes('osztalyIdList/osztalyId') AS osztalyIdList(osztalyId)
  
    DECLARE @osztalyId    INT
  DECLARE osztalyCursor  CURSOR FOR
    SELECT ID FROM #TempOsztalyIdList
    OPEN osztalyCursor
    FETCH NEXT FROM osztalyCursor INTO @osztalyId
    WHILE @@FETCH_STATUS =  0 
  BEGIN

    ;WITH TanuloTanugyiAdatok_CTE AS (
      SELECT
         TanuloTanugyiAdatok.C_NAPLOSORSZAM                    NaploSorszam
        ,ROW_NUMBER() OVER (                          
          ORDER BY                              
             TanuloCsoport.C_BELEPESDATUM ASC                
            ,IIF(Felhasznalo.C_NEVSORREND = 'T',              
              Felhasznalo.C_UTONEV + ' ' + Felhasznalo.C_VEZETEKNEV,    
              Felhasznalo.C_VEZETEKNEV + ' ' + Felhasznalo.C_UTONEV) ASC)  Sorszam
      FROM 
        T_TANULOCSOPORT_OSSZES TanuloCsoport
      INNER JOIN 
        T_TANULOTANUGYIADATOK_OSSZES TanuloTanugyiAdatok ON
            TanuloTanugyiAdatok.TOROLT              = 'F'
          AND TanuloTanugyiAdatok.C_TANULOCSOPORTID   = TanuloCsoport.ID 
      INNER JOIN 
        T_FELHASZNALO_OSSZES Felhasznalo ON
            Felhasznalo.TOROLT                      = 'F'
          AND Felhasznalo.ID                          = TanuloCsoport.C_TANULOID
      WHERE
          TanuloCsoport.TOROLT                        = 'F'
        AND TanuloCsoport.C_OSZTALYCSOPORTID            = @osztalyId
    )
    UPDATE
      TanuloTanugyiAdatok_CTE
    SET 
      NaploSorszam = Sorszam

    FETCH NEXT FROM osztalyCursor INTO @osztalyId
  END
    CLOSE osztalyCursor
    DEALLOCATE osztalyCursor

  DROP TABLE #TempOsztalyIdList

END

GO

