﻿/*============================================================================*/
/* Table : T_TANULASIEGYSEG                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULASIEGYSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_SORSZAM                         int                              NOT NULL,
    C_SZAKMAIRANYTIPUSID              int                              NULL,
    C_SZAKMATIPUSID                   int                              NOT NULL,
    C_SZOVEG                          nvarchar(2000)                   NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanulasiEgyseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_NYUGDIJTIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NYUGDIJTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NyugdijTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZAKMUNKASZERZODES                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKMUNKASZERZODES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KEZDETE                         datetime                         NOT NULL,
    C_VEGE                            datetime                         NOT NULL,
    C_SZERVEZETID                     int                              NULL,
    C_TANULOTANUGYIADATOKID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakmunkaSzerzodes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_APACZAIKGRJOGOSULT                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_APACZAIKGRJOGOSULT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_OSSZEG                          int                              NULL,
    C_STATUSZID                       int                              NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ApaczaiKgrJogosult PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZIRSTATNEMALLAMIOKTKOLTS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZIRSTATNEMALLAMIOKTKOLTS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AAOSZLOP                        numeric(19,3)                    NOT NULL,
    C_ABOSZLOP                        numeric(19,3)                    NOT NULL,
    C_ACOSZLOP                        numeric(19,3)                    NOT NULL,
    C_ADOSZLOP                        numeric(19,3)                    NOT NULL,
    C_AEOSZLOP                        numeric(19,3)                    NOT NULL,
    C_AFOSZLOP                        numeric(19,3)                    NOT NULL,
    C_AGOSZLOP                        numeric(19,3)                    NOT NULL,
    C_AHOSZLOP                        numeric(19,3)                    NOT NULL,
    C_GOSZLOP                         numeric(19,3)                    NOT NULL,
    C_HOSZLOP                         numeric(19,3)                    NOT NULL,
    C_IOSZLOP                         numeric(19,3)                    NOT NULL,
    C_JOSZLOP                         numeric(19,3)                    NOT NULL,
    C_KOSZLOP                         numeric(19,3)                    NOT NULL,
    C_LOSZLOP                         numeric(19,3)                    NOT NULL,
    C_MOSZLOP                         numeric(19,3)                    NOT NULL,
    C_NOSZLOP                         numeric(19,3)                    NOT NULL,
    C_OOSZLOP                         numeric(19,3)                    NOT NULL,
    C_POSZLOP                         numeric(19,3)                    NOT NULL,
    C_QOSZLOP                         numeric(19,3)                    NOT NULL,
    C_ROSZLOP                         numeric(19,3)                    NOT NULL,
    C_SOSZLOP                         numeric(19,3)                    NOT NULL,
    C_TOSZLOP                         numeric(19,3)                    NOT NULL,
    C_UOSZLOP                         numeric(19,3)                    NOT NULL,
    C_VOSZLOP                         numeric(19,3)                    NOT NULL,
    C_WOSZLOP                         numeric(19,3)                    NOT NULL,
    C_XOSZLOP                         numeric(19,3)                    NOT NULL,
    C_YOSZLOP                         numeric(19,3)                    NOT NULL,
    C_ZOSZLOP                         numeric(19,3)                    NOT NULL,
    C_FELADATELLATASIHELYID           int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzirStatNemAllamiOktKolts PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DUALISHELYSZINTIPUS                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DUALISHELYSZINTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DualisHelyszinTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_UJSZKTRESZSZAKMAOSSZERENDELE                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_UJSZKTRESZSZAKMAOSSZERENDELE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AGAZATRESZSZAKMATIPUSID         int                              NOT NULL,
    C_OKTATASINEVELESIFELADATID       int                              NOT NULL,
    C_RESZSZAKMATIPUSID               int                              NULL,
    C_SZAKMARESZSZAKMATIPUSID         int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_UjSzktReszszakmaOsszerendeles PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_REGISZKTOSSZERENDELES                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_REGISZKTOSSZERENDELES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AGAZATTIPUSID                   int                              NULL,
    C_OKTATASINEVELESIFELADATID       int                              NOT NULL,
    C_SZAKKEPESITESTIPUSID            int                              NULL,
    C_SZAKMACSOPORTTIPUSID            int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_RegiSzktOsszerendeles PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_NKTOSSZERENDELES                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NKTOSSZERENDELES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_OKTATASINEVELESIFELADATID       int                              NOT NULL,
    C_SZAKIRANYNKTTIPUSID             int                              NULL,
    C_SZAKKEPESITESNKTTIPUSID         int                              NULL,
    C_TANULMANYITERULETNKTTIPUSID     int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NktOsszerendeles PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_UJSZKTSZAKMAJEGYZEKOSSZEREND                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_UJSZKTSZAKMAJEGYZEKOSSZEREND (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AGAZATUJSZKTTIPUSID             int                              NOT NULL,
    C_OKTATASINEVELESIFELADATID       int                              NOT NULL,
    C_SZAKMAIRANYTIPUSID              int                              NULL,
    C_SZAKMATIPUSID                   int                              NULL,
    C_EGYEBESZKOZALLOMANYINFORMACI    nvarchar(500)                    NULL,
    C_ESZKOZALLOMANYAVULTSAGA         nvarchar(500)                    NULL,
    C_ESZKOZOKDARABSZAMA              nvarchar(500)                    NULL,
    C_KEPZESREFOGADHATOTANULOKSZAM    int                              DEFAULT 0 NOT NULL,
    C_TANMUHELYEKSZAMA                nvarchar(2000)                   NULL,
    C_FILEID                          int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_UjSzktSzakmajegyzekOsszerendeles PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZERVEZET                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZERVEZET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AZONOSITO                       nvarchar(20)                     NOT NULL,
    C_ISNAVSZINKRONIZALT              char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZINKRONIZALT                 char(1)                          DEFAULT 'F' NOT NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_TIPUS                           int                              NOT NULL,
    C_SZERVEZETCIM                    nvarchar(500)                    NULL,
    C_DUALISHELYSZINTIPUSID           int                              NOT NULL,
    C_PARENTSZERVEZETID               int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Szervezet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTEKELESTANTARGYINYELV                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTEKELESTANTARGYINYELV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NYELVID                         int                              NOT NULL,
    C_SZOVEG                          nvarchar(max)                    NULL,
    C_SZOVEGFORMAZOTT                 nvarchar(max)                    NULL,
    C_SZOVEGROVIDNEV                  nvarchar(3)                      NULL,
    C_TEMA                            nvarchar(2000)                   NULL,
    C_ERTEKELESTANTARGYIID            int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtekelesTantargyiNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTEKELESMAGSZOR                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTEKELESMAGSZOR (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATUM                           datetime                         NOT NULL,
    C_ERTEKELESTIPUSID                int                              NOT NULL,
    C_ISERTESITESELKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_ISFROMMOBIL                     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISMAGATARTAS                    AS (CAST(IIF(C_MAGATARTASOSZTALYZATTIPUSID IS NULL AND C_MAGATARTASSZOVEG IS NULL AND C_MAGATARTASERTEKELESTIPUSID IS NULL, 'F', 'T') AS CHAR(1))) PERSISTED,
    C_ISSZORGALOM                     AS (CAST(IIF(C_SZORGALOMOSZTALYZATTIPUSID IS NULL AND C_SZORGALOMSZOVEG IS NULL AND C_SZORGALOMERTEKELESTIPUSID IS NULL, 'F', 'T') AS CHAR(1))) PERSISTED,
    C_MAGATARTASERTEKELESTIPUSID      int                              NULL,
    C_MAGATARTASOSZTALYZATTIPUSID     int                              NULL,
    C_MAGATARTASSZOVEG                nvarchar(max)                    NULL,
    C_MAGATARTASSZOVEGFORMAZOTT       nvarchar(max)                    NULL,
    C_MAGATARTASSZOVEGROVIDNEV        nvarchar(3)                      NULL,
    C_ROGZITESDATUM                   datetime                         NOT NULL,
    C_ROGZITESKORIEVFOLYAMTIPUSID     int                              NULL,
    C_SZORGALOMERTEKELESTIPUSID       int                              NULL,
    C_SZORGALOMOSZTALYZATTIPUSID      int                              NULL,
    C_SZORGALOMSZOVEG                 nvarchar(max)                    NULL,
    C_SZORGALOMSZOVEGFORMAZOTT        nvarchar(max)                    NULL,
    C_SZORGALOMSZOVEGROVIDNEV         nvarchar(3)                      NULL,
    C_TANULOID                        int                              NOT NULL,
    C_ROGZITOALKALMAZOTTID            int                              NOT NULL,
    C_ROGZITESKORIOSZTALYID           int                              NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtekelesMagSzor PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTEKELESMAGSZORNYELV                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTEKELESMAGSZORNYELV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MAGATARTASSZOVEG                nvarchar(max)                    NULL,
    C_MAGATARTASSZOVEGFORMAZOTT       nvarchar(max)                    NULL,
    C_MAGATARTASSZOVEGROVIDNEV        nvarchar(3)                      NULL,
    C_NYELVID                         int                              NOT NULL,
    C_SZORGALOMSZOVEG                 nvarchar(max)                    NULL,
    C_SZORGALOMSZOVEGFORMAZOTT        nvarchar(max)                    NULL,
    C_SZORGALOMSZOVEGROVIDNEV         nvarchar(3)                      NULL,
    C_ERTEKELESMAGSZORID              int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtekelesMagSzorNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTEKELESTANTARGYI                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTEKELESTANTARGYI (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATUM                           datetime                         NOT NULL,
    C_ERTEKELESMODID                  int                              NULL,
    C_ERTEKELESTIPUSID                int                              NOT NULL,
    C_ISERTESITESELKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_ISFROMMOBIL                     char(1)                          DEFAULT 'F' NOT NULL,
    C_OSZTALYZATTIPUSID               int                              NULL,
    C_ROGZITESKORIEVFOLYAMTIPUSID     int                              NULL,
    C_ROGZITESDATUM                   datetime                         NOT NULL,
    C_SZAZALEK                        int                              NULL,
    C_SZOVEG                          nvarchar(max)                    NULL,
    C_SZOVEGFORMAZOTT                 nvarchar(max)                    NULL,
    C_SZOVEGROVIDNEV                  nvarchar(3)                      NULL,
    C_TEMA                            nvarchar(2000)                   NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_ROGZITESKORIOSZTALYID           int                              NULL,
    C_TANULOID                        int                              NOT NULL,
    C_OSSZEFUGGOSZAKGYAKID            int                              NULL,
    C_ROGZITOALKALMAZOTTID            int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtekelesTantargyi PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_AGAZATALAPVIZSGAEREDTIPUS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AGAZATALAPVIZSGAEREDTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AgazatAlapVizsgaEredTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_JOGVKELETKEZESEJOGCIMTIPUS                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JOGVKELETKEZESEJOGCIMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_JogvKeletkezeseJogcimTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_AGAZATALAPOKTMEGNEVTIPUS                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AGAZATALAPOKTMEGNEVTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AgazatAlapOktMegnevTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TBJOGVISZONY                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TBJOGVISZONY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISAKTIV                         char(1)                          DEFAULT 'T' NOT NULL,
    C_JOGVKELETKEZESEJOGCIMTIPUSID    int                              NULL,
    C_JOGVMEGSZUNESEJOGCIMTIPUSID     int                              NULL,
    C_KEZDETE                         datetime                         DEFAULT GETDATE() NULL,
    C_MEGJEGYZES                      nvarchar(150)                    NULL,
    C_TBJOGVISZONYTIPUSID             int                              NULL,
    C_VEGE                            datetime                         NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TbJogviszony PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TBJOGVISZONYTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TBJOGVISZONYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TbJogviszonyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_JOGVMEGSZUNESEJOGCIMTIPUS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JOGVMEGSZUNESEJOGCIMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_JogvMegszuneseJogcimTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ESZKOZIGENYLESSTATUSZ                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESZKOZIGENYLESSTATUSZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EszkozIgenylesStatusz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MUNKASZERZODES                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUNKASZERZODES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ADATSZOLGCEGNEVE                nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYAJ             nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYEM             nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYEP             nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYHG             nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYIR             nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYJEL            nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYKT             nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYLH             nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYOR             nvarchar(240)                    NULL,
    C_ADATSZOLGSZEKHELYSZ             nvarchar(240)                    NULL,
    C_ADATSZOLGTERMCSNEV              nvarchar(240)                    NULL,
    C_ADATSZOLGTERMUNEV               nvarchar(240)                    NULL,
    C_ADOZOADOAZON                    nvarchar(240)                    NULL,
    C_ADOZOADOSZAM                    nvarchar(240)                    NULL,
    C_AKTBARKOD                       nvarchar(240)                    NULL,
    C_ALKMIN08                        nvarchar(240)                    NULL,
    C_ALKMIN0902                      nvarchar(240)                    NULL,
    C_ALKMINNYUGD08                   nvarchar(240)                    NULL,
    C_ALKMINNYUGD0902                 nvarchar(240)                    NULL,
    C_ARSZOLGIDO                      nvarchar(240)                    NULL,
    C_BEERKEZESDAT                    datetime                         NULL,
    C_BEVKEZD                         datetime                         NULL,
    C_BEVVEG                          datetime                         NULL,
    C_BIZTIDOTARTIG08                 datetime                         NULL,
    C_BIZTIDOTARTIG0902               datetime                         NULL,
    C_BIZTIDOTARTTOL08                datetime                         NULL,
    C_BIZTIDOTARTTOL0902              datetime                         NULL,
    C_BIZTSZUNIDOIG01                 datetime                         NULL,
    C_BIZTSZUNIDOKOD01                nvarchar(240)                    NULL,
    C_BIZTSZUNIDOTOL01                datetime                         NULL,
    C_FEORSZAM01                      nvarchar(240)                    NULL,
    C_FUNKCIOKOD                      nvarchar(240)                    NULL,
    C_GYEDMELLETTIMVEGZESIG           datetime                         NULL,
    C_GYEDMELLETTIMVEGZESTOL          datetime                         NULL,
    C_GYESMELLETTIMVEGZESIG           datetime                         NULL,
    C_GYESMELLETTIMVEGZESTOL          datetime                         NULL,
    C_KULFCIM                         nvarchar(240)                    NULL,
    C_LAPSORSZAM08                    nvarchar(240)                    NULL,
    C_LAPSORSZAM0902                  nvarchar(240)                    NULL,
    C_LEVTBJAROSSZBIZT0902            nvarchar(240)                    NULL,
    C_LEVTBJAROSSZTERM0902            nvarchar(240)                    NULL,
    C_OROKBEFOGMELLETTIMVEGZESIG      datetime                         NULL,
    C_OROKBEFOGMELLETTIMVEGZESTOL     datetime                         NULL,
    C_TAJSZAM                         nvarchar(240)                    NULL,
    C_TBJARALAPBIZT0902               nvarchar(240)                    NULL,
    C_TBJARALAPTERM0902               nvarchar(240)                    NULL,
    C_TBJARJUTOSSZBIZT0902            nvarchar(240)                    NULL,
    C_TBJARJUTOSSZTERM0902            nvarchar(240)                    NULL,
    C_TERMALLPOL                      nvarchar(240)                    NULL,
    C_TERMANCSNEV                     nvarchar(240)                    NULL,
    C_TERMANUNEV                      nvarchar(240)                    NULL,
    C_TERMAZON                        nvarchar(240)                    NULL,
    C_TERMCSNEV                       nvarchar(240)                    NULL,
    C_TERMELCSNEV                     nvarchar(240)                    NULL,
    C_TERMELUNEV                      nvarchar(240)                    NULL,
    C_TERMNEME                        nvarchar(240)                    NULL,
    C_TERMSZULCSNEV                   nvarchar(240)                    NULL,
    C_TERMSZULHELY                    nvarchar(240)                    NULL,
    C_TERMSZULIDO                     datetime                         NULL,
    C_TERMSZULUNEV                    nvarchar(240)                    NULL,
    C_TERMUNEV                        nvarchar(240)                    NULL,
    C_TITULUS                         nvarchar(240)                    NULL,
    C_TORLOTETEL                      nvarchar(240)                    NULL,
    C_ALKALMAZOTTID                   int                              NULL,
    C_TANULOTANUGYIADATOKID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MunkaSzerzodes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_RESZSZAKMATIPUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_RESZSZAKMATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ReszSzakmaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_AGAZATRESZSZAKMATIPUS                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AGAZATRESZSZAKMATIPUS (
    ID                                int                              NOT NULL,
    C_OKTATASINEVELESIFELADATID       int                              NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AgazatReszSzakmaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZAKMARESZSZAKMATIPUS                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKMARESZSZAKMATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakmaReszSzakmaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ESZKOZIGENYLES                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESZKOZIGENYLES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ASZFELFOGADASIDEJE              datetime                         NULL,
    C_ISELFOGADOTTASZF                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISESZKOZKIOSZTVA                char(1)                          DEFAULT 'F' NOT NULL,
    C_ESZKOZIGENYLESSTATUSZID         int                              NULL,
    C_GONDVISELOID                    int                              NULL,
    C_TANULOID                        int                              NULL,
    C_ALKALMAZOTTID                   int                              NULL,
    C_FELADATELLATASIHELYID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EszkozIgenyles PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZIRSTATKONYVTARKATEGORIA                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZIRSTATKONYVTARKATEGORIA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NEV                             nvarchar(80)                     NOT NULL,
    C_FOKATEGORIAID                   int                              NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzirStatKonyvtarKategoria PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZIRSTATKONYVTAR                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZIRSTATKONYVTAR (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_FORGALOM                        int                              NULL,
    C_GYARAPODAS                      int                              NULL,
    C_NYITOADAT                       int                              NULL,
    C_NYITOADATNEMZETISEGI            int                              NULL,
    C_SZIRSTATKONYVTARKATEGORIAID     int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzirStatKonyvtar PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_OGORAREND                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OGORAREND (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_OGGUID                          uniqueidentifier                 NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OgOrarend PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FOGYATEKOSSAGTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGYATEKOSSAGTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FogyatekossagTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZIRSTATFELADATELLATASIHELY                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZIRSTATFELADATELLATASIHELY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ASZTALIGEPEKSZAMA               int                              DEFAULT 0 NOT NULL,
    C_NOTEBOOKOKSZAMA                 int                              DEFAULT 0 NOT NULL,
    C_OKOSTELEFONOKSZAMA              int                              DEFAULT 0 NOT NULL,
    C_TABLETEKSZAMA                   int                              DEFAULT 0 NOT NULL,
    C_FELADATELLATASIHELYID           int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzirStatFeladatellatasiHely PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZIRSTATTANULO                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZIRSTATTANULO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISSIKERESERETTSEGI              char(1)                          NULL,
    C_ISSIKERESTANULMANYOK            char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSIKERESSZAKMAIVISZGASZAK1     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSIKERESSZAKMAIVISZGASZAK2     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSIKERESSZAKMAIVISZGASZAK3     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSIKERESSZAKMAIVIZSGA          char(1)                          NULL,
    C_ISSIKERESAGAZATIALAPVIZSGA      char(1)                          DEFAULT 'F' NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_FELADATELLATASIHELYID           int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzirStatTanulo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KEPESITESTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KEPESITESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KepesitesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TARTJOGOKMANYTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TARTJOGOKMANYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TartJogOkmanyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TARTOZKODASJOGCIMTIPUS                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TARTOZKODASJOGCIMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TartozkodasJogcimTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TKJOGALAPTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TKJOGALAPTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TKJogalapTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FELEKEZETTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FELEKEZETTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FelekezetTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_NEMZETISEGTIPUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NEMZETISEGTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NemzetisegTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANSZAKTIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANSZAKTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanszakTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MUFAJTIPUS                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUFAJTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MufajTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DUALISSZERZODESFILE                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DUALISSZERZODESFILE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISALKALMAZOTTALTALTOROLT        char(1)                          DEFAULT 'F' NOT NULL,
    C_FILEID                          int                              NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DualisSzerzodesFile PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_EPJTANULOIADAT                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_EPJTANULOIADAT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERDEMJEGY                       numeric(10,2)                    NULL,
    C_ISAKTIV                         char(1)                          DEFAULT 'F' NOT NULL,
    C_ISJAVITOVIZSGA                  char(1)                          DEFAULT 'F' NOT NULL,
    C_ISPOTVIZSGA                     char(1)                          DEFAULT 'F' NOT NULL,
    C_KIFIZETESDATUMA                 datetime                         NULL,
    C_SZAKKEPESITESAZONOSITO          nvarchar(15)                     NULL,
    C_SZAKKEPESITESMEGNEVEZES         nvarchar(250)                    NULL,
    C_VIZSGADATUM                     datetime                         NULL,
    C_BIZONYITVANYSZAMA               varchar(100)                     NULL,
    C_OKTATASIAZONOSITO               varchar(40)                      NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EpjTanuloiAdat PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_INTEZMENYCONFIG                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_INTEZMENYCONFIG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERTEK                           nvarchar(255)                    NULL,
    C_CONFIGTIPUSID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IntezmenyConfig PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_IKTATOTTDOKUMENTUMCSATOLMANY                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IKTATOTTDOKUMENTUMCSATOLMANY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELEKTRONIKUSPELDANYID           int                              NULL,
    C_FAILEDJOBID                     int                              NULL,
    C_ISATTACHED                      char(1)                          DEFAULT 'F' NOT NULL,
    C_FAJLNEV                         nvarchar(1000)                   NULL,
    C_IKTATOTTDOKUMENTUMID            int                              NOT NULL,
    C_FILEID                          int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IktatottDokumentumCsatolmany PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_CONFIGTIPUS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CONFIGTIPUS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_CONFIG                          varchar(80)                      NOT NULL,
    C_MODUL                           varchar(80)                      NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ConfigTipus PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANITASIORADIGTAMESZKOZ                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANITASIORADIGTAMESZKOZ (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DIGTAMESZKOZTIPUSID             int                              NOT NULL,
    C_TANITASIORAID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanitasiOraDigTamEszkoz PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DIGTAMESZKOZTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DIGTAMESZKOZTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DigTamEszkozTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DIGPLATFORMTIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DIGPLATFORMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DigPlatformTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DIGESZKOZTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DIGESZKOZTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DigEszkozTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZAKKEPESITESNKTTIPUS                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKKEPESITESNKTTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakkepesitesNktTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULMANYITERULETNKTTIPUS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULMANYITERULETNKTTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanulmanyiTeruletNktTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TULAJDONTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TULAJDONTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TulajdonTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZAKIRANYNKTTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKIRANYNKTTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakiranyNktTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_PROFILKEPFILE                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_PROFILKEPFILE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_GONDVISELOID                    int                              NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_FILEID                          int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ProfilkepFile PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ZARADEK                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ZARADEK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISBIZONYITVANYBANMEGJELENIK     char(1)                          DEFAULT 'T' NOT NULL,
    C_ISKIVAGYATSOROLASIZARADEK       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOSZTALYNAPLOBANMEGJELENIK     char(1)                          DEFAULT 'T' NOT NULL,
    C_ISTORZSLAPONMEGJELENIK          char(1)                          DEFAULT 'T' NOT NULL,
    C_KELTEZESDATUMA                  datetime                         DEFAULT GETDATE() NOT NULL,
    C_KELTEZESHELYE                   nvarchar(255)                    NOT NULL,
    C_ROGZITESDATUMA                  datetime                         DEFAULT GETDATE() NOT NULL,
    C_SZOVEG                          nvarchar(max)                    NOT NULL,
    C_UTOLSOMODOSITASDATUMA           datetime                         DEFAULT GETDATE() NOT NULL,
    C_ROGZITONEV                      nvarchar(255)                    NULL,
    C_UTOLSOMODOSITONEV               nvarchar(255)                    NULL,
    C_ROGZITOID                       int                              NULL,
    C_UTOLSOMODOSITOID                int                              NULL,
    C_TANULOCSOPORTID                 int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Zaradek PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORAFILETIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORAFILETIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OraFileTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ZARADEKNYELV                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ZARADEKNYELV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NYELVID                         int                              NOT NULL,
    C_SZOVEG                          nvarchar(max)                    NOT NULL,
    C_ZARADEKID                       int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ZaradekNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORAFILE                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORAFILE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISTANULOLATHATO                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ORADATUM                        datetime                         NOT NULL,
    C_ORAFILETIPUSID                  int                              NOT NULL,
    C_ORAIDOPONT                      datetime                         NULL,
    C_ORASZAM                         int                              NULL,
    C_MEGJEGYZES                      nvarchar(1000)                   NULL,
    C_ORARENDIORAID                   int                              NULL,
    C_TANITASIORAID                   int                              NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_DKT_FILEID                      int                              NOT NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OraFile PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZIRSTATTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZIRSTATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzirStatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KIRSZIRFELADATELLATASIHELY                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KIRSZIRFELADATELLATASIHELY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_FELADATELLATASIHELYID           int                              NOT NULL,
    C_MUKODESIHELYNEV                 nvarchar(255)                    NOT NULL,
    C_OKTATASINEVELESIFELADATNEV      nvarchar(500)                    NOT NULL,
    C_DATUM                           datetime                         NOT NULL,
    C_FELADATKATEGORIAID              int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KirSzirFeladatellatasiHely PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FILE                                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FILE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EXTENSION                       nvarchar(50)                     NULL,
    C_FELTOLTESDATUM                  datetime                         DEFAULT GETDATE() NOT NULL,
    C_FILEGUID                        uniqueidentifier                 NULL,
    C_FILENEV                         nvarchar(1000)                   NULL,
    C_FILESIZEBYTE                    int                              NULL,
    C_INTEZMENYGUID                   uniqueidentifier                 NOT NULL,
    C_UTVONAL                         nvarchar(2000)                   NULL,
    C_VEGLEGESITESDATUM               datetime                         NULL,
    C_MEGJEGYZES                      nvarchar(1000)                   NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_File PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_JOGVISZONYSZUNETELTETES                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JOGVISZONYSZUNETELTETES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KEZDETE                         datetime                         NOT NULL,
    C_VEGE                            datetime                         NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_TANULOTANUGYIADATOKID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_JogviszonySzuneteltetes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZIRSTATFILE                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZIRSTATFILE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_SZIRSTATTIPUSID                 int                              NOT NULL,
    C_FILEID                          int                              NOT NULL,
    C_KIRSZIRFELADATELLATASIHELYID    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzirStatFile PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_EGYHAZTARTASBANELOK                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_EGYHAZTARTASBANELOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ANYJANEVE                       nvarchar(255)                    NOT NULL,
    C_EMAIL                           nvarchar(255)                    NULL,
    C_ISCOVIDFERTOZOTT                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISFELHASZNALOTOROLT             char(1)                          DEFAULT 'F' NOT NULL,
    C_ISGONDVISELOTOROLT              char(1)                          DEFAULT 'F' NOT NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_ROKONSAGIFOKID                  int                              NOT NULL,
    C_SZULETESIHELY                   nvarchar(255)                    NOT NULL,
    C_SZULETESIIDO                    datetime                         NOT NULL,
    C_TAJSZAM                         nvarchar(255)                    NOT NULL,
    C_TELEFON                         nvarchar(255)                    NULL,
    C_ROGZITOGONDVISELOID             int                              NULL,
    C_ROGZITOFELHASZNALOID            int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EgyHaztartasbanElok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ALKALMAZOTTMUNKAKORTIPUS                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ALKALMAZOTTMUNKAKORTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AlkalmazottMunkaKorTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DKT_FILE                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DKT_FILE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISAKTIV                         char(1)                          DEFAULT 'T' NOT NULL,
    C_ISMODOSITHATO                   char(1)                          DEFAULT 'T' NOT NULL,
    C_ISTOROLHETO                     char(1)                          DEFAULT 'T' NOT NULL,
    C_ISLATHATO                       char(1)                          DEFAULT 'T' NOT NULL,
    C_CIM                             nvarchar(1000)                   NULL,
    C_EVFOLYAMID                      int                              NULL,
    C_EXTENSION                       nvarchar(50)                     NULL,
    C_FELTOLTESDATUM                  datetime                         DEFAULT GETDATE() NOT NULL,
    C_FILEGUID                        uniqueidentifier                 NULL,
    C_FILENEV                         nvarchar(1000)                   NULL,
    C_FILESIZEBYTE                    int                              NULL,
    C_HIBAUZENET                      nvarchar(2000)                   NULL,
    C_INTEZMENYGUID                   uniqueidentifier                 NOT NULL,
    C_ISIDEIGLENES                    char(1)                          DEFAULT 'F' NOT NULL,
    C_OSZTALYCSOPORTID                int                              NULL,
    C_TANTARGYID                      int                              NULL,
    C_TANTARGYKATEGORIAID             int                              NULL,
    C_UTVONAL                         nvarchar(2000)                   NULL,
    C_VEGLEGESITESDATUM               datetime                         NULL,
    C_FELTOLTOTANULOID                int                              NULL,
    C_FELTOLTOALKALMAZOTTID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    DELETER                           int                              NULL,
    DELETED                           datetime                         NULL,
    STATUSID                          int                              DEFAULT 0 NOT NULL,
    UNIQUEID                          uniqueidentifier                 DEFAULT NEWID() NOT NULL,
    ACLCODE                           NVARCHAR(1000) NULL,
    CONSTRAINT PK_DKT_File PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DKT_FELADATFILE                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DKT_FELADATFILE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISAKTIV                         char(1)                          DEFAULT 'T' NOT NULL,
    C_ISMODOSITHATO                   char(1)                          DEFAULT 'T' NOT NULL,
    C_ISTOROLHETO                     char(1)                          DEFAULT 'T' NOT NULL,
    C_ISLATHATO                       char(1)                          DEFAULT 'T' NOT NULL,
    C_INTEZMENYGUID                   uniqueidentifier                 NOT NULL,
    C_FELADATID                       int                              NOT NULL,
    C_FILEID                          int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    DELETER                           int                              NULL,
    DELETED                           datetime                         NULL,
    STATUSID                          int                              DEFAULT 0 NOT NULL,
    UNIQUEID                          uniqueidentifier                 DEFAULT NEWID() NOT NULL,
    ACLCODE                           NVARCHAR(1000) NULL,
    CONSTRAINT PK_DKT_FeladatFile PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DKT_FELADAT                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DKT_FELADAT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISAKTIV                         char(1)                          DEFAULT 'T' NOT NULL,
    C_ISMODOSITHATO                   char(1)                          DEFAULT 'T' NOT NULL,
    C_ISTOROLHETO                     char(1)                          DEFAULT 'T' NOT NULL,
    C_ISLATHATO                       char(1)                          DEFAULT 'T' NOT NULL,
    C_NEV                             nvarchar(1000)                   NULL,
    C_ROVIDNEV                        nvarchar(255)                    NULL,
    C_ALIASNEV                        nvarchar(1000)                   NULL,
    C_LEIRAS                          nvarchar(1000)                   NULL,
    C_MEGJEGYZES                      nvarchar(1000)                   NULL,
    C_BEADASHATARIDO                  datetime                         NULL,
    C_CIM                             nvarchar(255)                    NULL,
    C_DATUM                           datetime                         NULL,
    C_FELADATERTEKELESTIPUSID         int                              NULL,
    C_FELADATTIPUSID                  int                              NULL,
    C_IDOPONT                         datetime                         NULL,
    C_INTEZMENYGUID                   uniqueidentifier                 NOT NULL,
    C_ISKRETAFELADAT                  char(1)                          DEFAULT 'F' NOT NULL,
    C_LATHATOSAGIDOPONT               datetime                         NULL,
    C_ORARENDIORAGROUPID              int                              NULL,
    C_ORASZAM                         int                              NULL,
    C_ROGZITESIDOPONT                 datetime                         DEFAULT GETDATE() NOT NULL,
    C_SZOVEG                          nvarchar(max)                    NOT NULL,
    C_HFBEADANDOTIPUSID               int                              NULL,
    C_HFCSATOLASENGEDELYEZESTIPUSI    int                              NULL,
    C_HFELOREBEIRTFELADATMEGJELENI    int                              NULL,
    C_OFBEADANDOTIPUSID               int                              NULL,
    C_OFCSATOLASENGEDELYEZESTIPUSI    int                              NULL,
    C_OFELOREBEIRTFELADATMEGJELENI    int                              NULL,
    C_TANITASIORAID                   int                              NULL,
    C_ISERTESITESKIKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_GROUPID                         uniqueidentifier                 NULL,
    C_IDOTARTAMPERC                   int                              NULL,
    C_KESZ                            char(1)                          DEFAULT 'F' NOT NULL,
    C_EGYEDIERTEKELESTIPUSID          int                              NULL,
    C_PONTSZAM                        numeric(10,2)                    NULL,
    C_KURZUSID                        uniqueidentifier                 NULL,
    C_KURZUSOBJECTID                  uniqueidentifier                 NULL,
    C_NYELVID                         nvarchar(2)                      NULL,
    C_PARENTID                        int                              NULL,
    C_ROGZITORENDSZERID               int                              NULL,
    C_XEROPANASSIGNMENTID             int                              NULL,
    C_XEROPANBUNDLEID                 int                              NULL,
    C_XEROPANLESSONID                 int                              NULL,
    C_XEROPANTOROLT                   char(1)                          DEFAULT 'F' NOT NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_HELYETTESITOALKALMAZOTTID       int                              NULL,
    C_ROGZITOALKALMAZOTTID            int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    DELETER                           int                              NULL,
    DELETED                           datetime                         NULL,
    STATUSID                          int                              DEFAULT 0 NOT NULL,
    UNIQUEID                          uniqueidentifier                 DEFAULT NEWID() NOT NULL,
    ACLCODE                           NVARCHAR(1000) NULL,
    CONSTRAINT PK_DKT_Feladat PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MUNKAUGYTORVENYIHATALYTIPUS                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUNKAUGYTORVENYIHATALYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MunkaugyTorvenyiHatalyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_EGYEBTEVEKENYSEGEKTIPUS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_EGYEBTEVEKENYSEGEKTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EgyebTevekenysegekTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TOVABBKEPZES                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TOVABBKEPZES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATUM                           datetime                         NULL,
    C_ENGEDELYSZAMA                   nvarchar(50)                     NULL,
    C_HELYSZIN                        nvarchar(255)                    NULL,
    C_ORASZAM                         int                              NULL,
    C_TANUSITVANYSORSZAMA             nvarchar(50)                     NULL,
    C_TOVABBKEPZESMEGNEVEZESE         nvarchar(255)                    NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Tovabbkepzes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_AGAZATUJSZKTTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AGAZATUJSZKTTIPUS (
    ID                                int                              NOT NULL,
    C_AGAZATIBESOROLAS                int                              NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AgazatUjSzktTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZAKMATIPUS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKMATIPUS (
    ID                                int                              NOT NULL,
    C_AGAZATID                        int                              NULL,
    C_ALAPFOKUOKTATASIIDOTARTAM       int                              NULL,
    C_DITIGTALISKOMPETENCIAKERETSZ    int                              NULL,
    C_ERETTSEGIOKTATASIIDOTARTAM      int                              NULL,
    C_SZAKKEPESITESAZONOSITOSZAM      nvarchar(20)                     NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakmaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULOSNI                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOSNI (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_FELULVIZSGALATTANEVE            nvarchar(50)                     NULL,
    C_KIALLITASDATUMA                 datetime                         NULL,
    C_KIALLITOSZAKBIZOTTSAGCIME       nvarchar(500)                    NULL,
    C_KIALLITOSZAKBIZOTTSAGNEVE       nvarchar(500)                    NULL,
    C_SZAKVELEMENYSZAMA               nvarchar(500)                    NULL,
    C_FOGYATEKOSSAGTIPUSID            int                              NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloSni PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZAKMAIRANYTIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKMAIRANYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakmairanyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULOTANTARGYATLAG                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOTANTARGYATLAG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ATLAG                           AS (CAST(IIF(C_OSZTALYZATSZAMA = 0, 0.0, 1.0 * C_OSZTALYZATOSSZEGE / C_OSZTALYZATSZAMA) AS NUMERIC(10,2))),
    C_OSZTALYZATOSSZEGE               int                              NOT NULL,
    C_OSZTALYZATSZAMA                 int                              NOT NULL,
    C_SULYOZOTTATLAG                  AS (CAST(IIF(C_OSZTALYZATSZAMA = 0, 0.0, 1.0 * C_SULYOZOTTOSZTALYZATOSSZEGE / C_SULYOZOTTOSZTALYZATSZAMA) AS NUMERIC(10,2))) PERSISTED,
    C_SULYOZOTTOSZTALYZATOSSZEGE      int                              NOT NULL,
    C_SULYOZOTTOSZTALYZATSZAMA        int                              NOT NULL,
    C_OKTATASNEVELESIFELADATID        int                              NOT NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloTantargyAtlag PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_JUTTATAS                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JUTTATAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELUTASITASOKA                   int                              NULL,
    C_ISAKTIV                         char(1)                          DEFAULT 'F' NOT NULL,
    C_ISJOGOSULT                      char(1)                          DEFAULT 'F' NOT NULL,
    C_JUTTATASTIPUSID                 int                              NULL,
    C_OSSZEG                          int                              NULL,
    C_ISKIFIZETVE                     char(1)                          DEFAULT 'F' NOT NULL,
    C_KIFIZETESDATUMA                 datetime                         NULL,
    C_ISAZONOSITOTTDUPLIKATUM         char(1)                          DEFAULT 'F' NOT NULL,
    C_GENERALTHONAP                   int                              NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Juttatas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_JUTTATASTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JUTTATASTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_JuttatasTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_JOGVISZONYTIPUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JOGVISZONYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_JogviszonyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_BANKSZAMLATULAJDONOSTIPUS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BANKSZAMLATULAJDONOSTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BankszamlaTulajdonosTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_AMIJELLEMZOTIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AMIJELLEMZOTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AmiJellemzoTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_HAZIFELADATCSATOLMANY                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HAZIFELADATCSATOLMANY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_HAZIFELADATOKID                 int                              NOT NULL,
    C_CSATOLMANYID                    int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HaziFeladatCsatolmany PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANTERVIJELLEMZOTIPUS                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANTERVIJELLEMZOTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanterviJellemzoTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_CSATOLMANY                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CSATOLMANY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ADMINTORLESIDOPONT              datetime                         NULL,
    C_FELTOLTESIDOPONT                datetime                         NOT NULL,
    C_FILESERVICEGUID                 uniqueidentifier                 NOT NULL,
    C_ISADMINTOROLT                   char(1)                          DEFAULT 'F' NOT NULL,
    C_MERET                           numeric(10,2)                    NOT NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_UTVONAL                         nvarchar(500)                    NOT NULL,
    C_ISFILESERVICETOROLT             char(1)                          DEFAULT 'F' NOT NULL,
    C_ADMINFELHASZNALOID              int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Csatolmany PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOHAZIFELADATSTATUSZ                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOHAZIFELADATSTATUSZ (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISMEGOLDVA                      char(1)                          DEFAULT 'F' NOT NULL,
    C_MEGOLDASIDEJE                   datetime                         NULL,
    C_TANULOID                        int                              NOT NULL,
    C_HAZIFELADATOKID                 int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloHaziFeladatStatusz PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DASHBOARDUZENETINTEZMENY                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DASHBOARDUZENETINTEZMENY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISALKALMAZOTTNAK                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISGONDVISELONEK                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTAULONAK                      char(1)                          DEFAULT 'F' NOT NULL,
    C_TARTALOM                        nvarchar(20)                     NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_DASHBOARDUZENETID               int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DashboardUzenetIntezmeny PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_IKTATOTTDOKUMENTUMTAVOLLET                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IKTATOTTDOKUMENTUMTAVOLLET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KOZPONTITAVOLLETID              int                              NOT NULL,
    C_SZINKRONIZALVA                  datetime                         NULL,
    C_IKTATOTTDOKUMENTUMID            int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IktatottDokumentumTavollet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOKOZOSSEGISZOLGALATNYEL                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOKOZOSSEGISZOLGALATNYEL (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MEGJEGYZES                      nvarchar(4000)                   NULL,
    C_NYELVID                         int                              NOT NULL,
    C_TELJESITESIHELYE                nvarchar(255)                    NULL,
    C_TANULOKOZOSSEGISZOLGALATID      int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloKozossegiSzolgalatNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOERTEKELESNYELV                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOERTEKELESNYELV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERTEKELESTEMA                   nvarchar(2000)                   NULL,
    C_ERTEKELESSZOVEG                 nvarchar(max)                    NULL,
    C_ERTEKELESSZOVEGFORMAZOTT        nvarchar(max)                    NULL,
    C_ERTEKELESSZOVEGROVIDNEV         nvarchar(3)                      NULL,
    C_MAGATARTASSZOVEG                nvarchar(max)                    NULL,
    C_MAGATARTASSZOVEGFORMAZOTT       nvarchar(max)                    NULL,
    C_MAGATARTASSZOVEGROVIDNEV        nvarchar(3)                      NULL,
    C_NYELVID                         int                              NOT NULL,
    C_SZORGALOMSZOVEG                 nvarchar(max)                    NULL,
    C_SZORGALOMSZOVEGFORMAZOTT        nvarchar(max)                    NULL,
    C_SZORGALOMSZOVEGROVIDNEV         nvarchar(3)                      NULL,
    C_TANULOERTEKELESID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloErtekelesNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTEKELESMONDATBANKNYELV                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTEKELESMONDATBANKNYELV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NYELVID                         int                              NOT NULL,
    C_ROVIDNEV                        nvarchar(3)                      NULL,
    C_SZOVEG                          nvarchar(max)                    NOT NULL,
    C_ERTEKELESMONDATBANKID           int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtekelesMondatbankNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DICTIONARYITEMBASENYELV                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DICTIONARYITEMBASENYELV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NAME                            nvarchar(255)                    NOT NULL,
    C_NAME_1                          nvarchar(255)                    NULL,
    C_NAME_2                          nvarchar(255)                    NULL,
    C_NAME_3                          nvarchar(255)                    NULL,
    C_NAME_4                          nvarchar(255)                    NULL,
    C_NYELVID                         int                              NOT NULL,
    C_SHORTNAME                       nvarchar(30)                     NULL,
    C_DICTIONARYITEMBASEID            int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DictionaryItemBaseNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOESEMENYNYELV                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOESEMENYNYELV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_NYELVID                         int                              NOT NULL,
    C_TARGY                           nvarchar(255)                    NOT NULL,
    C_TARTALOM                        nvarchar(max)                    NOT NULL,
    C_TANULOESEMENYID                 int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloEsemenyNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORASORSZAMOZASHALMAZ                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORASORSZAMOZASHALMAZ (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KEZDOERTEK                      int                              NULL,
    C_KOZOSORASORSZAMOZASELTEROTAN    char(1)                          DEFAULT 'F' NOT NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_TIPUS                           int                              NOT NULL,
    C_ORASORSZAMOZASHALMAZOSSZEREN    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OraSorszamozasHalmaz PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORASORSZAMOZASHALMAZOSSZEREN                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORASORSZAMOZASHALMAZOSSZEREN (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_TANTARGYID                      int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_ORASORSZAMOZASHALMAZID          int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OraSorszamozasHalmazOsszerendeles PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANTARGYNYELV                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANTARGYNYELV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NEV                             nvarchar(50)                     NOT NULL,
    C_NYELVID                         int                              NOT NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TantargyNyelv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_LEPELOADAS                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_LEPELOADAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELOADASID                       int                              NOT NULL,
    C_KISEROLETSZAM                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_LepEloadas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ARANYJANOSPROGRAMTIPUS                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ARANYJANOSPROGRAMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AranyJanosProgramTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ADATTISZTITASSTATISZTIKA                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ADATTISZTITASSTATISZTIKA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ADATKOR                         nvarchar(12)                     NULL,
    C_ADATKORELEMSZAM                 int                              NULL,
    C_HIBAKSZAMA                      int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AdattisztitasStatisztika PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ADATTISZTITASINDIKATOR                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ADATTISZTITASINDIKATOR (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ADATKOR                         nvarchar(12)                     NOT NULL,
    C_KOD                             nvarchar(6)                      NOT NULL,
    C_LEIRAS                          nvarchar(512)                    NOT NULL,
    C_MEZO                            nvarchar(50)                     NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AdattisztitasIndikator PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_AMITANTARGYSABLON                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AMITANTARGYSABLON (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISHANGSZER                      char(1)                          DEFAULT 'F' NOT NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AMITantargySablon PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_AMITTFSABLON                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AMITTFSABLON (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AMIFOTARGYID                    int                              NULL,
    C_AMITAGOZATID                    int                              NULL,
    C_AMITANTARGYKOTELEZOSEGID        int                              NULL,
    C_EVFOLYAMTIPUSID                 int                              NULL,
    C_IDOTARTAM                       int                              NULL,
    C_ISCSOPORTOS                     char(1)                          DEFAULT 'F' NOT NULL,
    C_OKTATASINEVELESIFELADATID       int                              NULL,
    C_TANEVSORSZAM                    int                              NULL,
    C_AMITANTARGYSABLONID             int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AMITTFSablon PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_LEPELOADASJEGYZEK                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_LEPELOADASJEGYZEK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELOADASID                       int                              NOT NULL,
    C_MEGJELENT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_GONDVISELOALTALENGEDELYEZVE     char(1)                          NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_LepEloadasJegyzek PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SNITANULONEVELESIFORMATIPUS                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SNITANULONEVELESIFORMATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SniTanuloNevelesiFormaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_HETES                                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HETES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_HETSORSZAMA                     int                              NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Hetes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_BESZERZESIIGENYMEGJEGYZES                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESZERZESIIGENYMEGJEGYZES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MEGJEGYZES                      nvarchar(max)                    NOT NULL,
    C_ROGZITESDATUM                   datetime                         NOT NULL,
    C_ROGZITOID                       int                              NOT NULL,
    C_BESZERZESIIGENYID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BeszerzesiIgenyMegjegyzes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_BESZERZESIIGENY                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESZERZESIIGENY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BVOP                            char(1)                          DEFAULT 'F' NOT NULL,
    C_ISPALYAZAT                      char(1)                          DEFAULT 'F' NOT NULL,
    C_KEF                             char(1)                          DEFAULT 'F' NOT NULL,
    C_PALYAZATAZONOSITO               nvarchar(50)                     NULL,
    C_STATUSZID                       int                              NOT NULL,
    C_NKOH                            char(1)                          DEFAULT 'F' NOT NULL,
    C_ROGZITESDATUM                   datetime                         NOT NULL,
    C_ROGZITOID                       int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BeszerzesiIgeny PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_BESZERZESISZALLITOTORZS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESZERZESISZALLITOTORZS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ADOSZAM                         nvarchar(50)                     NULL,
    C_AJTO                            nvarchar(50)                     NULL,
    C_EMAILCIM                        nvarchar(255)                    NULL,
    C_EMELET                          nvarchar(50)                     NULL,
    C_HAZSZAM                         nvarchar(50)                     NULL,
    C_HELYSEGNEV                      nvarchar(255)                    NULL,
    C_IRSZAM                          nvarchar(50)                     NULL,
    C_KEPVISELONEV                    nvarchar(255)                    NULL,
    C_KOZTERULETJELLEGID              int                              NULL,
    C_KOZTERULETNEV                   nvarchar(255)                    NULL,
    C_NEV                             nvarchar(500)                    NULL,
    C_SAPKOD                          nvarchar(50)                     NULL,
    C_TELEFONSZAM                     nvarchar(255)                    NULL,
    C_FIZETESIMOD                     nvarchar(50)                     NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BeszerzesiSzallitotorzs PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_BESZERZESIANYAG                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESZERZESIANYAG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EGYSEGAR                        int                              NULL,
    C_LEIRAS                          nvarchar(1000)                   NULL,
    C_MENNYISEGIEGYSEGID              int                              NULL,
    C_NEV                             nvarchar(255)                    NULL,
    C_SAPKOD                          nvarchar(50)                     NULL,
    C_TETELNEV                        nvarchar(50)                     NULL,
    C_ERAAZONOSITO                    nvarchar(255)                    NULL,
    C_MENNYISEG                       int                              NULL,
    C_BESZERZESIIGENYID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BeszerzesiAnyag PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_BESZERZESIIGENYDOKUMENTUM                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESZERZESIIGENYDOKUMENTUM (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_IKTATOTTDOKUMENTUMID            int                              NOT NULL,
    C_BESZERZESIIGENYID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BeszerzesiIgenyDokumentum PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_BESZERZESIANYAGTORZS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESZERZESIANYAGTORZS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EGYSEGAR                        int                              NULL,
    C_LEIRAS                          nvarchar(1000)                   NULL,
    C_MENNYISEGIEGYSEGID              int                              NULL,
    C_NEV                             nvarchar(255)                    NULL,
    C_SAPKOD                          nvarchar(50)                     NULL,
    C_TETELNEV                        nvarchar(50)                     NULL,
    C_ERAAZONOSITO                    nvarchar(255)                    NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BeszerzesiAnyagtorzs PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_BESZERZESISZALLITO                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESZERZESISZALLITO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ADOSZAM                         nvarchar(50)                     NULL,
    C_AJTO                            nvarchar(50)                     NULL,
    C_EMAILCIM                        nvarchar(255)                    NULL,
    C_EMELET                          nvarchar(50)                     NULL,
    C_HAZSZAM                         nvarchar(50)                     NULL,
    C_HELYSEGNEV                      nvarchar(255)                    NULL,
    C_IRSZAM                          nvarchar(50)                     NULL,
    C_KEPVISELONEV                    nvarchar(255)                    NULL,
    C_KOZTERULETJELLEGID              int                              NULL,
    C_KOZTERULETNEV                   nvarchar(255)                    NULL,
    C_NEV                             nvarchar(500)                    NULL,
    C_SAPKOD                          nvarchar(50)                     NULL,
    C_TELEFONSZAM                     nvarchar(255)                    NULL,
    C_FIZETESIMOD                     nvarchar(50)                     NULL,
    C_BESZERZESIIGENYID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BeszerzesiSzallito PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_BESZERZESIIGENYSATUSZ                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESZERZESIIGENYSATUSZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BeszerzesiIgenySatusz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MENNYISEGIEGYSEG                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MENNYISEGIEGYSEG (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MennyisegiEgyseg PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DASHBOARDUZENETFELHASZNALO                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DASHBOARDUZENETFELHASZNALO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MEGJELENITESEKSZAMA             int                              DEFAULT 0 NOT NULL,
    C_UTOLSOMEGTEKINTESIDEJE          datetime                         NULL,
    C_EGYEDIMUVELET                   nvarchar(255)                    NULL,
    C_DASHBOARDUZENETID               int                              NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DashboardUzenetFelhasznalo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TEREM_FELTOLTOTTFAJL                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TEREM_FELTOLTOTTFAJL (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISDOKUMENTUM                    char(1)                          DEFAULT 'F' NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    C_FELTOLTOTTFAJLID                int                              NOT NULL,
    C_TEREMID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Terem_FeltoltottFajl PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ELEARNINGFELHASZNALO                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ELEARNINGFELHASZNALO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_GONDVISELOID                    int                              NULL,
    C_ELEARNINGELERHETOSEGID          int                              NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ElearningFelhasznalo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FOGLALKOZASAMITANULO                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGLALKOZASAMITANULO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AMIFOTARGYID                    int                              NOT NULL,
    C_AMITAGOZATID                    int                              NOT NULL,
    C_AMITANTARGYKOTELEZOSEGID        int                              NOT NULL,
    C_EVFOLYAMTIPUSID                 int                              NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_FOGLALKOZASID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FoglalkozasAmiTanulo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_AMIFOTARGY                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AMIFOTARGY (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AMIFotargy PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_AMITANTARGYKOTELEZOSEG                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AMITANTARGYKOTELEZOSEG (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AMITantargyKotelezoseg PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_AMITAGOZAT                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AMITAGOZAT (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AMITagozat PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DASHBOARDUZENETKATEGORIA                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DASHBOARDUZENETKATEGORIA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NEV                             nvarchar(50)                     NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DashboardUzenetKategoria PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DASHBOARDUZENET                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DASHBOARDUZENET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_CIM                             nvarchar(255)                    NOT NULL,
    C_EGYEDIAZONOSITO                 nvarchar(50)                     NOT NULL,
    C_ERVENYESSEGKEZDETE              datetime                         NULL,
    C_ERVENYESSEGVEGE                 datetime                         NULL,
    C_KIEMELTIDOSZAKVEGE              datetime                         NULL,
    C_SORREND                         int                              NOT NULL,
    C_TARTALOM                        nvarchar(max)                    NULL,
    C_ISPOPUP                         char(1)                          DEFAULT 'F' NOT NULL,
    C_POPUPGYAKORISAGAPERCBEN         int                              NULL,
    C_ISADMIN                         char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTANAR                         char(1)                          DEFAULT 'F' NOT NULL,
    C_ISINTEZMENYI                    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISFELHASZNALOI                  char(1)                          DEFAULT 'F' NOT NULL,
    C_DASHBOARDUZENETKATEGORIAID      int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DashboardUzenet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_EUGYINTEZESLOG                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_EUGYINTEZESLOG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EUGYJSON                        nvarchar(max)                    NULL,
    C_EUGYTIPUS                       int                              NOT NULL,
    C_EUGYUGYIRATSZAM                 nvarchar(50)                     NULL,
    C_HIBAUZENET                      nvarchar(max)                    NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EugyintezesLog PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZAMONKERESELOREJELZES                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAMONKERESELOREJELZES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ORARENDIORAGROUPID              int                              NOT NULL,
    C_ROGZITESDATUMA                  datetime                         NOT NULL,
    C_SZAMONKERESDATUMA               datetime                         NOT NULL,
    C_SZAMONKERESMODID                int                              NOT NULL,
    C_SZAMONKERESMEGNEVEZES           nvarchar(300)                    NULL,
    C_ISERTESITESELKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_ROGZITOID                       int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzamonkeresElorejelzes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SAPTAVOLLET                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SAPTAVOLLET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_SAPAZONOSITO                    nvarchar(50)                     NULL,
    C_TAVOLLETKEZDETE                 datetime                         NOT NULL,
    C_TAVOLLETTIPUSID                 int                              NOT NULL,
    C_TAVOLLETVEGE                    datetime                         NOT NULL,
    C_TAVOLLETIDOTARTAMANAP           int                              NULL,
    C_TAVOLLETIDOTARTAMAORA           int                              NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SAPTavollet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MUVESZETIAG                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUVESZETIAG (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MuveszetiAg PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ZENEMUVESZETIAGTIPUS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ZENEMUVESZETIAGTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ZenemuveszetiAgTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FELTOLTOTTFAJL                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FELTOLTOTTFAJL (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_UTVONAL                         nvarchar(500)                    NOT NULL,
    C_FELTOLTESDATUMA                 datetime                         NOT NULL,
    C_NEV                             nvarchar(200)                    NOT NULL,
    C_MEGJEGYZES                      nvarchar(1000)                   NULL,
    C_KITERJESZTES                    nvarchar(10)                     NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FeltoltottFajl PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TAVOLLETJELENTO                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TAVOLLETJELENTO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_HIANYPOTLASSZOVEGE              nvarchar(1000)                   NULL,
    C_MEGJEGYZES                      nvarchar(1000)                   NULL,
    C_ROGZITESIDOPONTJA               datetime                         NOT NULL,
    C_STATUSZID                       int                              NOT NULL,
    C_TAVOLLETIDOTARTAMA              int                              NOT NULL,
    C_TAVOLLETKEZDETE                 datetime                         NOT NULL,
    C_TAVOLLETTIPUSID                 int                              NOT NULL,
    C_TAVOLLETVEGE                    datetime                         NOT NULL,
    C_FENNTARTOFELHASZNALOID          int                              NULL,
    C_STATUSZVALTOZASIDOPONTJA        datetime                         NOT NULL,
    C_KRHIANYPOTLASSZOVEGE            nvarchar(1000)                   NULL,
    C_ROGZITOID                       int                              NOT NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TavolletJelento PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ESLTANTARGYKATEGORIA                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESLTANTARGYKATEGORIA (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ESLTantargykategoria PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TAVOLLETTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TAVOLLETTIPUS (
    ID                                int                              NOT NULL,
    C_SAPKOD                          nvarchar(50)                     NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TavolletTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TAVOLLETSTATUSZ                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TAVOLLETSTATUSZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TavolletStatusz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TEREMELERHETOSEG                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TEREMELERHETOSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_HETNAPJA                        int                              NOT NULL,
    C_KEZDETE                         datetime                         NOT NULL,
    C_VEGE                            datetime                         NOT NULL,
    C_TEREMID                         int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TeremElerhetoseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOTANUGYIADATOK                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOTANUGYIADATOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BEIRASINAPLOSORSZAM             nvarchar(50)                     NULL,
    C_BEJARO                          char(1)                          DEFAULT 'F' NOT NULL,
    C_DIAKSPORTKOROS                  char(1)                          DEFAULT 'F' NOT NULL,
    C_EGYEBORSZAGOSDONTO              char(1)                          DEFAULT 'F' NOT NULL,
    C_EGYUTTMUKODESES                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ELOZOINTEZMENY                  nvarchar(255)                    NULL,
    C_EVISMETLO                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKOLAIKERETEKKOZOTT            char(1)                          DEFAULT 'F' NOT NULL,
    C_JOGVISZONYATSZUNETELTETO        char(1)                          DEFAULT 'F' NOT NULL,
    C_JOGVISZONYVARHATOBEFEJEZESE     datetime                         NULL,
    C_MAGANTANULO                     char(1)                          DEFAULT 'F' NOT NULL,
    C_MAGANTANULOSAGANAKOKAID         int                              NULL,
    C_MAGANTANULOSAGKEZDETE           datetime                         NULL,
    C_NYILVANTARTASKEZDETE            datetime                         NOT NULL,
    C_OSZTV                           char(1)                          DEFAULT 'F' NOT NULL,
    C_POLGARISZERZODESES              char(1)                          DEFAULT 'F' NOT NULL,
    C_SZAKMAIGYAKORLATON              char(1)                          DEFAULT 'F' NOT NULL,
    C_SZETVAGAZAT                     char(1)                          DEFAULT 'F' NOT NULL,
    C_SZINTVIZSGA                     numeric(10,2)                    NULL,
    C_SZKTV                           char(1)                          DEFAULT 'F' NOT NULL,
    C_TANDIJATFIZETO                  char(1)                          DEFAULT 'F' NOT NULL,
    C_TANKOTELEZETT                   char(1)                          DEFAULT 'F' NOT NULL,
    C_TANKOTELEZETTSEGVEGE            datetime                         NULL,
    C_TANULOEVFOLYAMTIPUSID           int                              NULL,
    C_TANULOSZERZODESES               char(1)                          DEFAULT 'F' NOT NULL,
    C_TECHNIKUSIEVFOLYAM              char(1)                          DEFAULT 'F' NOT NULL,
    C_TERITESIDIJATFIZETO             char(1)                          DEFAULT 'F' NOT NULL,
    C_VENDEG                          char(1)                          DEFAULT 'F' NOT NULL,
    C_NAPLOSORSZAM                    int                              NULL,
    C_TORZSLAPSZAM                    nvarchar(500)                    NULL,
    C_HOZOTTIGAZOLATLANHIANYZAS       int                              DEFAULT 0 NOT NULL,
    C_HOZOTTIGAZOLATLANKESESPERCBE    int                              DEFAULT 0 NOT NULL,
    C_HOZOTTIGAZOLTHIANYZAS           int                              DEFAULT 0 NOT NULL,
    C_HOZOTTIGAZOLTKESESPERCBEN       int                              DEFAULT 0 NOT NULL,
    C_ISESL16EVESUTANBELEPETT         char(1)                          DEFAULT 'F' NOT NULL,
    C_BIZONYITVANYSZAMA               nvarchar(50)                     NULL,
    C_TANTERVIJELLEMZOID              int                              NULL,
    C_ISDUALISKEPZESBEN               char(1)                          DEFAULT 'F' NOT NULL,
    C_ISMASODIKTOBBSZAKMA             char(1)                          DEFAULT 'F' NOT NULL,
    C_AGAZATUJSZKTTIPUSID             int                              NULL,
    C_SZAKMAIRANYTIPUSID              int                              NULL,
    C_SZAKMATIPUSID                   int                              NULL,
    C_AGAZATIALAPVIZSGAEREDMENYE      numeric(10,2)                    NULL,
    C_DUALISKEPZOHELYADOSZAMA         nvarchar(20)                     NULL,
    C_DUALISKEPZOHELYNEVE             nvarchar(255)                    NULL,
    C_ISOKLEVELESTECHNIKUSKIMENET     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAKKEPZESIMUNKASZERZODESS    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISBESZAMITASOS                  char(1)                          DEFAULT 'F' NOT NULL,
    C_SZAKIRANYNKTTIPUSID             int                              NULL,
    C_SZAKKEPESITESNKTTIPUSID         int                              NULL,
    C_TANULMANYITERULETNKTTIPUSID     int                              NULL,
    C_AGAZATID                        int                              NULL,
    C_RESZSZAKKEPESITESID             int                              NULL,
    C_SZAKKEPESITESID                 int                              NULL,
    C_SZAKMACSOPORTID                 int                              NULL,
    C_ISBESZAMITASOSFIXSZAZALEK       char(1)                          DEFAULT 'T' NOT NULL,
    C_MAGANTANULOSAGVEGE              datetime                         NULL,
    C_AGAZATIALAPVIZSGAEREDMENYESZ    int                              NULL,
    C_MUFAJTIPUSID                    int                              NULL,
    C_MUVESZETIAGID                   int                              NULL,
    C_TANSZAKTIPUSID                  int                              NULL,
    C_IS9KOZUL8ELOZOTANEVBENVEGEZT    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISEGESZNAPOSISKOKTRESZESUL      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKIEMELTENTEHETSEGES           char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZABOKYADOLFSZAKKEPODRESZE    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAMITOGEPETOKTCELRAHASZNA    char(1)                          DEFAULT 'T' NOT NULL,
    C_TANTERVIJELLEGID                int                              NULL,
    C_AGAZATRESZSZAKMATIPUSID         int                              NULL,
    C_RESZSZAKMATIPUSID               int                              NULL,
    C_SZAKMARESZSZAKMATIPUSID         int                              NULL,
    C_ISSZAKKEPZESENKIVULROLJOTT      char(1)                          DEFAULT 'F' NOT NULL,
    C_AGAZATALAPOKTMEGNEVTIPUSID      int                              NULL,
    C_AGAZATALAPVIZSGAEREDTIPUSID     int                              NULL,
    C_AGAZATIALAPVIZSGATELJESITES     datetime                         NULL,
    C_ISATLAGNELKULI                  char(1)                          DEFAULT 'F' NOT NULL,
    C_TANTERVID                       int                              NOT NULL,
    C_FELVETELTANEVEID                int                              NOT NULL,
    C_TANULOCSOPORTID                 int                              NOT NULL,
    C_SZERVEZETID                     int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloTanugyiAdatok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ELVEGZETTKURZUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ELVEGZETTKURZUS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_GONDVISELOID                    int                              NULL,
    C_KURZUSID                        int                              NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ElvegzettKurzus PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KURZUS                                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KURZUS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KURZUSAZONOSITO                 nvarchar(1000)                   NOT NULL,
    C_LEIRAS                          nvarchar(1000)                   NOT NULL,
    C_OKLEVELSZAMA                    nvarchar(1000)                   NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Kurzus PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DOKUMENTUMELEMISZINT                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DOKUMENTUMELEMISZINT (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DokumentumElemiSzint PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FOGADOORAIDOPONT_GONDVISELO                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGADOORAIDOPONT_GONDVISELO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_FOGADOORAIDOPONTID              int                              NOT NULL,
    C_GONDVISELOID                    int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FogadooraIdopont_Gondviselo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FOGADOORA_OSZTALYCSOPORT                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGADOORA_OSZTALYCSOPORT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_FOGADOORAID                     int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Fogadoora_OsztalyCsoport PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FOGADOORAIDOPONT                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGADOORAIDOPONT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KEZDETE                         datetime                         NOT NULL,
    C_VEGE                            datetime                         NOT NULL,
    C_FOGADOORAID                     int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FogadooraIdopont PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FOGADOORA                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGADOORA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EGYSEG                          int                              NULL,
    C_FOGADOORAKEZDETE                datetime                         NOT NULL,
    C_FOGADOORATIPUSID                int                              NOT NULL,
    C_FOGADOORAVEGE                   datetime                         NOT NULL,
    C_GROUPID                         int                              NOT NULL,
    C_RENDSZERESSEG                   int                              NOT NULL,
    C_JELENTKEZESHATARIDO             datetime                         NULL,
    C_NEMKOTOTTMUNKAIDOID             int                              NULL,
    C_TANARID                         int                              NOT NULL,
    C_TEREMID                         int                              NOT NULL,
    C_TANULOESEMENYID                 int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Fogadoora PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ELEARNINGELERHETOSEG                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ELEARNINGELERHETOSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELEARNINGAZONOSITO              nvarchar(36)                     NOT NULL,
    C_KEZDODATUM                      datetime                         NULL,
    C_SZEREPKORTIPUSID                int                              NULL,
    C_VEGDATUM                        datetime                         NULL,
    C_ISGONDVISELONELMEGJELENIK       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTANULONALMEGJELENIK           char(1)                          DEFAULT 'F' NOT NULL,
    C_ROLEPACKAGE                     nvarchar(50)                     DEFAULT 'unauthorized' NULL,
    C_KURZUSNEVE                      nvarchar(200)                    NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ElearningElerhetoseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_OKTNEVELESIKATEGORIA                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OKTNEVELESIKATEGORIA (
    ID                                int                              NOT NULL,
    C_FELADATCSOPORTTANULOOSZTALYK    int                              DEFAULT 1 NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OktNevelesiKategoria PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DOKUMENTUM                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DOKUMENTUM (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_TARTALOM                        varbinary(max)                   NOT NULL,
    C_IKTATOTTDOKUMENTUMID            int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Dokumentum PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DOKUMENTUMKULCSSZOERTEK                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DOKUMENTUMKULCSSZOERTEK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERTEK                           nvarchar(200)                    NOT NULL,
    C_ENTITYID                        int                              NULL,
    C_ENTITYNAME                      nvarchar(50)                     NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DokumentumKulcsszoErtek PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_IKTATOTTDOKUMENTUM                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IKTATOTTDOKUMENTUM (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DOKUMENTUMNEVE                  nvarchar(512)                    NOT NULL,
    C_IKTATOSZAM                      nvarchar(128)                    NULL,
    C_GENERALASDATUMA                 datetime                         NOT NULL,
    C_IKTATASDATUMA                   datetime                         NULL,
    C_ELEKTRONIKUSPELDANYFELTOLTES    datetime                         NULL,
    C_ELEKTRONIKUSPELDANYID           int                              NULL,
    C_GENERALTDOKUMENTUMID            int                              NULL,
    C_VONALKOD                        nvarchar(64)                     NOT NULL,
    C_MAPPA                           nvarchar(256)                    NOT NULL,
    C_DOKUMENTUMKATEGORIA             int                              NOT NULL,
    C_DOKUMENTUMTIPUS                 int                              NOT NULL,
    C_DOKUMENTUMSTATUSZ               int                              NOT NULL,
    C_DOKUMENTUMELEMISZINT            int                              NOT NULL,
    C_FAJLNEV                         nvarchar(512)                    NOT NULL,
    C_FAILEDJOBID                     int                              NULL,
    C_ENQUEUEDJOBID                   int                              NULL,
    C_ISFOSZAMOS                      char(1)                          DEFAULT 'F' NOT NULL,
    C_IRATID                          nvarchar(100)                    NULL,
    C_UGYIRATID                       nvarchar(100)                    NULL,
    C_IKTATOSZEMELYNEV                nvarchar(255)                    NULL,
    C_FELADATELLATASIHELYID           int                              NULL,
    C_IKTATOSZEMELYID                 int                              NULL,
    C_FOSZAMOSIKTATOTTDOKUMENTUMID    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IktatottDokumentum PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DOKUMENTUMKULCSSZO                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DOKUMENTUMKULCSSZO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DOKUMENTUMKULCSSZOTIPUS         int                              NOT NULL,
    C_IKTATOTTDOKUMENTUMID            int                              NOT NULL,
    C_DOKUMENTUMKULCSSZOERTEKID       int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DokumentumKulcsszo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DOKUMENTUMTIPUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DOKUMENTUMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DokumentumTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DOKUMENTUMSTATUSZ                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DOKUMENTUMSTATUSZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DokumentumStatusz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DOKUMENTUMKULCSSZOTIPUS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DOKUMENTUMKULCSSZOTIPUS (
    ID                                int                              NOT NULL,
    C_POSZEIDONKULCSSZOTIPUS          nvarchar(64)                     NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DokumentumKulcsszoTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DOKUMENTUMKATEGORIA                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DOKUMENTUMKATEGORIA (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DokumentumKategoria PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_JELSZOMODOSITASLINK                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JELSZOMODOSITASLINK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AZONOSITO                       nvarchar(36)                     NOT NULL,
    C_LETREHOZASDATUMA                datetime                         NOT NULL,
    C_PROBALKOZASOKSZAMA              int                              DEFAULT 0 NOT NULL,
    C_ISSZULETESIDATUMVALIDACIO       char(1)                          NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_JelszoModositasLink PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DIAKOLIMPIA                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DIAKOLIMPIA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATUM                           datetime                         NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_TANARID                         int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Diakolimpia PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTMONDATBANKTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTMONDATBANKTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtMondatbankTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKTANTARGYKATEGORIA                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKTANTARGYKATEGORIA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KKSZAKTIPUSID                   int                              NULL,
    C_KKTANARVEGZETTSEGID             int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKTantargyKategoria PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKKEPESITESJELLTIPUS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKKEPESITESJELLTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKKepesitesJellTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKJAZZZENE                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKJAZZZENE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_JAZZZENETIPUSID                 int                              NULL,
    C_KKAMIVEGZETTSEGID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKJazzZene PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKKLASSZIKUSZENE                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKKLASSZIKUSZENE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KLASSZUKUSZENETIPUSID           int                              NULL,
    C_KKAMIVEGZETTSEGID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKKlasszikusZene PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKAMIVEGZETTSEG                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKAMIVEGZETTSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KKAMIVEGZETTSEGTIPUSID          int                              NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKAMIVegzettseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKGYOGYPEDVEGZETTSEG                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKGYOGYPEDVEGZETTSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KKGYOGYPEDTERTIPUSID            int                              NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKGyogypedVegzettseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKNEPZENE                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKNEPZENE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NEPZENETIPUSID                  int                              NULL,
    C_KKAMIVEGZETTSEGID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKNepzene PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKELEKTROAKUZENE                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKELEKTROAKUZENE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELEKTRAKUTIPUSID                int                              NULL,
    C_KKAMIVEGZETTSEGID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKElektroakuZene PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKTERULET                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKTERULET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AMITERULETTIPUSID               int                              NULL,
    C_KKAMIVEGZETTSEGID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKTerulet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKTANARVEGZETTSEG                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKTANARVEGZETTSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EGYEB                           nvarchar(max)                    NULL,
    C_KKTANARVEGZETTSEGID             int                              NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKTanarVegzettseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKTANITOVEZGETTSEG                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKTANITOVEZGETTSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KKTANIOTOMUVTERTIPUSID          int                              NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKTanitoVezgettseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KKVEGZETTSEGTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKVEGZETTSEGTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKVegzettsegTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKAMINEPZENETIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKAMINEPZENETIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKAMINepzeneTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKAMIELEKTROAKUTIPUS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKAMIELEKTROAKUTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKAMIElektroakuTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKAMIVEGZETTSEGTIPUS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKAMIVEGZETTSEGTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKAMIVegzettsegTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKAMITERULETTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKAMITERULETTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKAMITeruletTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKAMIJAZZZENETIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKAMIJAZZZENETIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKAMIJazzZeneTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKTANITOMUVTERTIPUS                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKTANITOMUVTERTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKTanitoMuvTerTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKAMIKLASSZIKUSTIPUS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKAMIKLASSZIKUSTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKAMIKlasszikusTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKGYOGYPEDTERTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKGYOGYPEDTERTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKGyogypedTerTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKKEPESITESTIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKKEPESITESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKKepesitesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKSZAKTIPUS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKSZAKTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKSzakTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KKAMIZENEMUVKATTIPUS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KKAMIZENEMUVKATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KKAMIZenemuvKatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_OSSZEFUGGOSZAKGYAK                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OSSZEFUGGOSZAKGYAK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MEGJEGYZES                      nvarchar(max)                    NULL,
    C_TELJESITETT                     char(1)                          NULL,
    C_TELJESITESDATUM                 datetime                         NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_CSOPORTID                       int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OsszefuggoSzakGyak PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KIRKONTENERELEMSTATUSZ                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KIRKONTENERELEMSTATUSZ (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ATMENETIDOPONT                  datetime                         NULL,
    C_KOD                             nvarchar(max)                    NULL,
    C_LEIRAS                          nvarchar(max)                    NULL,
    C_UZENET                          nvarchar(max)                    NULL,
    C_KIRKONTENERELEMID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KIRKontenerElemStatusz PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KIRKONTENER                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KIRKONTENER (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_CELSZOLGALTATAS                 nvarchar(20)                     NOT NULL,
    C_IARAZONOSITO                    nvarchar(100)                    NOT NULL,
    C_KONTENERID                      nvarchar(25)                     NOT NULL,
    C_INTEZMENYAZONOSITO              nvarchar(30)                     NOT NULL,
    C_VALASZKOD                       nvarchar(30)                     NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KIRKontener PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KIRKONTENERSTATUSZ                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KIRKONTENERSTATUSZ (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MESSAGECODE                     nvarchar(max)                    NULL,
    C_MESSAGESOURCE                   nvarchar(max)                    NULL,
    C_MESSAGETEXT                     nvarchar(max)                    NULL,
    C_KOD                             int                              NULL,
    C_LEIRAS                          nvarchar(max)                    NULL,
    C_KIRKONTENERID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KIRKontenerStatusz PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KIRKONTENERELEM                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KIRKONTENERELEM (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KONTENERELEMID                  int                              NULL,
    C_KIRKONTENERID                   int                              NOT NULL,
    C_NEBULOID                        int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KIRKontenerElem PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KIRSZOLGALTATASTIPUS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KIRSZOLGALTATASTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KirSzolgaltatasTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZAKTIPUS                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_GIMNAZIUMIEVFOLYAMTIPUS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_GIMNAZIUMIEVFOLYAMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_GimnaziumiEvfolyamTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KEPESITES                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KEPESITES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KEPESITESTIPUSID                int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Kepesites PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_VEGZETTSEG                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_VEGZETTSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EGYEB                           nvarchar(255)                    NULL,
    C_VEGZETTSEGTIPUSID               int                              NULL,
    C_TANARID                         int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Vegzettseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOHAZIFELADAT                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOHAZIFELADAT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BEJELENTESDATUMA                datetime                         NOT NULL,
    C_FELADATSZOVEGE                  nvarchar(max)                    NOT NULL,
    C_TANULOALTALTOROLT               char(1)                          DEFAULT 'F' NOT NULL,
    C_ISERTESITESELKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_HAZIFELADATID                   int                              NOT NULL,
    C_ROGZITOID                       int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloHaziFeladat PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERETTSEGIVALASZ                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERETTSEGIVALASZ (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATUM                           datetime                         NOT NULL,
    C_HELYES                          char(1)                          NOT NULL,
    C_VALASZ                          nvarchar(4000)                   NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_ERETTSEGIKERDESID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErettsegiValasz PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERETTSEGIKERDES                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERETTSEGIKERDES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_CIM                             nvarchar(4000)                   NULL,
    C_ERETTSEGISZINTID                int                              NULL,
    C_ERETTSEGITANTARGYID             int                              NULL,
    C_HELYESVALASZ                    nvarchar(4000)                   NULL,
    C_KATEGORIA                       nvarchar(10)                     NOT NULL,
    C_KEP                             nvarchar(max)                    NULL,
    C_KERDES                          nvarchar(4000)                   NOT NULL,
    C_SZOVEG                          nvarchar(4000)                   NULL,
    C_TEMA                            nvarchar(4000)                   NOT NULL,
    C_VALASZB                         nvarchar(4000)                   NULL,
    C_VALASZC                         nvarchar(4000)                   NULL,
    C_VALASZD                         nvarchar(4000)                   NULL,
    C_VALASZE                         nvarchar(4000)                   NULL,
    C_VALASZF                         nvarchar(4000)                   NULL,
    C_VALASZSZOVEGES                  nvarchar(4000)                   NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErettsegiKerdes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_LICENCEFUNKCIOKTIPUS                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_LICENCEFUNKCIOKTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_LicenceFunkciokTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_LICENCE                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_LICENCE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATE                            datetime                         NULL,
    C_FULL                            char(1)                          DEFAULT 'T' NOT NULL,
    C_FUNCTION                        int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Licence PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_PENZNEMTIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_PENZNEMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_PenznemTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MEROALLAS                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MEROALLAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERTEK                           numeric(10,2)                    NULL,
    C_LEOLVASASDATUMA                 datetime                         NULL,
    C_MEROHELYID                      int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Meroallas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MEROHELYTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MEROHELYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MerohelyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KOZMUSZAMLA                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KOZMUSZAMLA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BEFIZETESDATUMA                 datetime                         NULL,
    C_FIZETESIHATARIDO                datetime                         NULL,
    C_FIZETVE                         char(1)                          DEFAULT 'F' NOT NULL,
    C_INVALIDITASOKA                  nvarchar(max)                    NULL,
    C_KELTE                           datetime                         NULL,
    C_KIBOCSATO                       nvarchar(max)                    NULL,
    C_KOZMUSZAMLATIPUSID              int                              NULL,
    C_OSSZEG                          numeric(10,2)                    NULL,
    C_PENZNEMID                       int                              NULL,
    C_VALID                           char(1)                          DEFAULT 'F' NOT NULL,
    C_VALIDALASALATT                  char(1)                          DEFAULT 'F' NOT NULL,
    C_MEROHELYID                      int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KozmuSzamla PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MEROHELY                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MEROHELY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MEROALLASFRISSITESESZUKSEGES    char(1)                          DEFAULT 'F' NOT NULL,
    C_MEROHELYTIPUSID                 int                              NOT NULL,
    C_NEV                             nvarchar(max)                    NULL,
    C_MEROORAAZONOSITO                nvarchar(100)                    NULL,
    C_EGYEDIAZONOSITO                 uniqueidentifier                 DEFAULT NEWID() NOT NULL,
    C_MUKODESIHELYID                  int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Merohely PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KOZMUSZAMLATIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KOZMUSZAMLATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KozmuSzamlaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FENNTARTO                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FENNTARTO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NEV                             nvarchar(1000)                   NOT NULL,
    C_AZONOSITO                       nvarchar(16)                     NOT NULL,
    C_GUID                            uniqueidentifier                 NOT NULL,
    C_LEGMAGASABBSZINTUFENNTARTOID    int                              NULL,
    C_ISTESZTFENNTARTO                char(1)                          DEFAULT 'F' NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Fenntarto PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_JELSZOVISSZAALLITAS                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JELSZOVISSZAALLITAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_VISSZAALLITASHASH               nvarchar(36)                     NOT NULL,
    C_VISSZAALLITASHATARIDO           datetime                         NOT NULL,
    C_FELHASZNALOBELEPESID            int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_JelszoVisszaallitas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_HITTANADATSZOLGALTATAS                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HITTANADATSZOLGALTATAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EDDIGIORASZAM                   numeric(10,2)                    NULL,
    C_HITTANTIPUSID                   int                              NULL,
    C_CSOPORTLETSZAM                  int                              DEFAULT 0 NOT NULL,
    C_SORSZAM                         int                              NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HittanAdatszolgaltatas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_HITTANTIPUS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HITTANTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HittanTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_HAZIFELADATOK                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HAZIFELADATOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_FELADASDATUMA                   datetime                         NOT NULL,
    C_HATARIDO                        datetime                         NOT NULL,
    C_FELADATSZOVEGE                  nvarchar(max)                    NOT NULL,
    C_ORASZAM                         int                              NULL,
    C_ISTANARROGZITETTE               char(1)                          NOT NULL,
    C_ISERTESITESELKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_ROGZITOID                       int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_TANITASIORAID                   int                              NULL,
    C_HELYETTESITOID                  int                              NULL,
    C_ORARENDIORAID                   int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HaziFeladatok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_VEGZETTSEGTIPUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_VEGZETTSEGTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_VegzettsegTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ELEARNING                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ELEARNING (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BEFEJEZETT                      char(1)                          DEFAULT 'F' NOT NULL,
    C_ELEARNINGAZONOSITO              nvarchar(500)                    NOT NULL,
    C_ELEARNINGFELHASZNALONEV         nvarchar(500)                    NOT NULL,
    C_SIKERES                         char(1)                          DEFAULT 'F' NOT NULL,
    C_SZERZODESES                     char(1)                          DEFAULT 'F' NOT NULL,
    C_TANANYAGKOD                     nvarchar(500)                    NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_eLearning PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DICTIONARYTYPE                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DICTIONARYTYPE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_CODENAME                        nvarchar(30)                     NOT NULL,
    C_DESCRIPTION                     nvarchar(255)                    NULL,
    C_ISCOLOREDITABLE                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ISCUSTOMITEMALLOWED             char(1)                          DEFAULT 'F' NOT NULL,
    C_NAME                            nvarchar(50)                     NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DictionaryType PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOERTEKELESLATTAMOZAS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOERTEKELESLATTAMOZAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_LATTAMOZASDATUMA                datetime                         NOT NULL,
    C_TANULOERTEKELESID               int                              NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_LATTAMOZOTANULOID               int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloErtekelesLattamozas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOESEMENYLATTAMOZAS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOESEMENYLATTAMOZAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_LATTAMOZASDATUMA                datetime                         NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_TANULOID                        int                              NOT NULL,
    C_TANULOESEMENYID                 int                              NOT NULL,
    C_LATTAMOZOTANULOID               int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloEsemenyLattamozas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOMULASZTASLATTAMOZAS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOMULASZTASLATTAMOZAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_LATTAMOZASDATUMA                datetime                         NOT NULL,
    C_GONDVISELOID                    int                              NOT NULL,
    C_TANULOMULASZTASID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloMulasztasLattamozas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORARENDIORATULAJDONSAG                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORARENDIORATULAJDONSAG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ORATULAJDONSAGID                int                              NOT NULL,
    C_BOOLERTEK                       char(1)                          NOT NULL,
    C_ORARENDIORAID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OrarendiOraTulajdonsag PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORATULAJDONSAGTIPUS                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORATULAJDONSAGTIPUS (
    ID                                int                              NOT NULL,
    C_BOOLDEFAULT                     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISORARENDIORA                   char(1)                          DEFAULT 'T' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OraTulajdonsagTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANITASIORATULAJDONSAG                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANITASIORATULAJDONSAG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ORATULAJDONSAGID                int                              NOT NULL,
    C_BOOLERTEK                       char(1)                          NOT NULL,
    C_TANITASIORAID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanitasiOraTulajdonsag PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_NATKERDOIV                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NATKERDOIV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ISLATTA                         char(1)                          DEFAULT 'F' NOT NULL,
    C_KERDES01                        int                              NULL,
    C_KERDES02                        int                              NULL,
    C_KERDES03                        int                              NULL,
    C_KERDES04                        int                              NULL,
    C_KERDES05                        int                              NULL,
    C_KERDES06                        int                              NULL,
    C_KERDES07                        int                              NULL,
    C_KERDES08                        int                              NULL,
    C_KERDES09                        int                              NULL,
    C_KERDES10                        int                              NULL,
    C_KERDES11                        nvarchar(1000)                   NULL,
    C_KERDES12                        nvarchar(1000)                   NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NATKerdoiv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTEKELESMONDATBANK                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTEKELESMONDATBANK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERTEKELESTIPUSA                 int                              NULL,
    C_EVFOLYAMTIPUSA                  int                              NULL,
    C_ROVIDNEV                        nvarchar(3)                      NULL,
    C_SZOVEG                          nvarchar(max)                    NOT NULL,
    C_TIPUSID                         int                              NOT NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_TANTARGYID                      int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtekelesMondatbank PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KOZOSSEGISZOLGALATTIPUS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KOZOSSEGISZOLGALATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KozossegiSzolgalatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MUKODESIHELYADATSZOLGALTATAS                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUKODESIHELYADATSZOLGALTATAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_INFORMATIKAOKTATAS              char(1)                          NULL,
    C_INTFELTOLTESSAV                 nvarchar(255)                    NULL,
    C_INTHAVIDIJ                      int                              NULL,
    C_INTLETOLTESSAV                  nvarchar(255)                    NULL,
    C_INTSZOLGALTATO                  nvarchar(255)                    NULL,
    C_MUKODESIHELYID                  int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MukodesiHelyAdatszolgaltatas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_INTEZMENYESZKOZADATSZOLGALTA                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_INTEZMENYESZKOZADATSZOLGALTA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ALAPSZINTUAMAKTUALIS            int                              NULL,
    C_ALAPSZINTUAMIGENY               int                              NULL,
    C_BILLENTYUZETAKTUALIS            int                              NULL,
    C_BILLENTYUZETIGENY               int                              NULL,
    C_EGERAKTUALIS                    int                              NULL,
    C_EGERIGENY                       int                              NULL,
    C_EGYEBSZOFTVERAKTUALIS           int                              NULL,
    C_EGYEBSZOFTVERIGENY              int                              NULL,
    C_EGYEBSZOFTVERLEIRAS             nvarchar(max)                    NULL,
    C_FFENAKTUALIS                    int                              NULL,
    C_FFENIGENY                       int                              NULL,
    C_FFTNAKTUALIS                    int                              NULL,
    C_FFTNIGENY                       int                              NULL,
    C_INTERAKTIVTABLAAKTUALIS         int                              NULL,
    C_INTERAKTIVTABLAIGENY            int                              NULL,
    C_IRODAISZOFTVERAKTUALIS          int                              NULL,
    C_IRODAISZOFTVERIGENY             int                              NULL,
    C_NOTEBOOKAKTUALIS                int                              NULL,
    C_NOTEBOOKIGENY                   int                              NULL,
    C_PROFMAKTUALIS                   int                              NULL,
    C_PROFMIGENY                      int                              NULL,
    C_PROJEKTORAKTUALIS               int                              NULL,
    C_PROJEKTORIGENY                  int                              NULL,
    C_SCANNERAKTUALIS                 int                              NULL,
    C_SCANNERIGENY                    int                              NULL,
    C_SZINESENAKTUALIS                int                              NULL,
    C_SZINESENIGENY                   int                              NULL,
    C_SZINESTNAKTUALIS                int                              NULL,
    C_SZINESTNIGENY                   int                              NULL,
    C_TABLETAKTUALIS                  int                              NULL,
    C_TABLETIGENY                     int                              NULL,
    C_TERVEZETT3D                     char(1)                          NULL,
    C_TERVEZETTLEGO                   char(1)                          NULL,
    C_VEKONYKLIENSAKTUALIS            int                              NULL,
    C_VEKONYKLIENSIGENY               int                              NULL,
    C_VIRUSVEDELMIAKTUALIS            int                              NULL,
    C_VIRUSVEDELMIIGENY               int                              NULL,
    C_VIZUALISOMAKTUALIS              int                              NULL,
    C_VIZUALISOMIGENY                 int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IntezmenyEszkozAdatszolgaltatas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_VEZETOIORASZAMOKTIPUS                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_VEZETOIORASZAMOKTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_VezetoiOraszamokTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FOGLALKOZTATASTIPUSA                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGLALKOZTATASTIPUSA (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FoglalkoztatasTipusa PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ERETTSEGISZINT                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERETTSEGISZINT (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErettsegiSzint PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ERETTSEGITIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERETTSEGITIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErettsegiTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ERETTSEGIEREDMENY                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERETTSEGIEREDMENY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERETTSEGISZINT                  int                              NOT NULL,
    C_ERETTSEGITANTARGY               int                              NOT NULL,
    C_ERETTSEGITIPUS                  int                              NOT NULL,
    C_GYAKORLATPONTSZAM               int                              NULL,
    C_IRASBELIPONTSZAM                int                              NULL,
    C_MEGJEGYZES                      nvarchar(1000)                   NULL,
    C_OSSZPONTSZAM                    int                              NULL,
    C_SZOBELIPONTSZAM                 int                              NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErettsegiEredmeny PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERETTSEGITANTARGYADATOK                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERETTSEGITANTARGYADATOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERETTSEGISZINT                  int                              NOT NULL,
    C_ERETTSEGITANTARGY               int                              NOT NULL,
    C_GYAKORLATMAXPONTSZAM            int                              NOT NULL,
    C_IRASBELIMAXPONTSZAM             int                              NOT NULL,
    C_ISGYAKORLAT                     char(1)                          NOT NULL,
    C_ISIRASBELI                      char(1)                          NOT NULL,
    C_ISSZOBELI                       char(1)                          NOT NULL,
    C_OSSZMAXPONTSZAM                 int                              NOT NULL,
    C_SZOBELIMAXPONTSZAM              int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErettsegiTantargyAdatok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERETTSEGITANTARGY                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERETTSEGITANTARGY (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErettsegiTantargy PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TOVABBIMUNKAUGYIADATOK                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TOVABBIMUNKAUGYIADATOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ALKALMAZASKEZDETE               datetime                         NULL,
    C_ALKALMAZASMEGSZUNESE            datetime                         NULL,
    C_BESOROLASIFOKOZAT               int                              NULL,
    C_KOTELEZOORASZAM                 numeric(10,2)                    NOT NULL,
    C_MUNKAIDOKEDVEZMENYOKA           int                              NULL,
    C_MUNKAIDOKEDVEZMENYOKASZOVEG     nvarchar(max)                    NULL,
    C_MUNKAIDOKEDVEZMENYORASZAM       numeric(10,2)                    NULL,
    C_MUNKAKORTIPUSA                  int                              NULL,
    C_MUNKAVISZONYTIPUSA              int                              NULL,
    C_NYUGDIJAS                       char(1)                          DEFAULT 'F' NOT NULL,
    C_FOGLALKOZTATASTIPUS             int                              NULL,
    C_RESZMUNKAIDOSZAZALEK            numeric(10,2)                    DEFAULT 100 NULL,
    C_VEZETOIORASZAMOK                int                              NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_FELADATELLATASIHELYID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TovabbiMunkaugyiAdatok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_RESZSZAKKEPESITESTIPUS                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_RESZSZAKKEPESITESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ReszszakkepesitesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_AGAZATTIPUS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_AGAZATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AgazatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZAKMACSOPORTTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKMACSOPORTTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakmacsoportTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZAKKEPESITESTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZAKKEPESITESTIPUS (
    ID                                int                              NOT NULL,
    C_SZAKKEPESITESSZINT              int                              NULL,
    C_TANULMANYITERULET               int                              NULL,
    C_TERULETSORSZAM                  int                              NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzakkepesitesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MUKODESIHELYTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUKODESIHELYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MukodesiHelyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_IKTESZKOZHASZNALATMOD                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IKTESZKOZHASZNALATMOD (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IKTEszkozhasznalatMod PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ELSODLEGESIKTESZKOZ                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ELSODLEGESIKTESZKOZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ElsodlegesIKTEszkoz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_PEDAGOGUSIKTADATSZOLGALTATAS                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_PEDAGOGUSIKTADATSZOLGALTATAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELSODLEGESIKTESZKOZE            int                              NULL,
    C_IKTESZKOZHASZNALATMODJA         int                              NOT NULL,
    C_IKTKOMPETENCIASZINTJE           int                              NOT NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_PedagogusIKTAdatszolgaltatas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_WIFIELERES                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_WIFIELERES (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_WiFiEleres PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_IKTKOMPETENCIASZINT                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IKTKOMPETENCIASZINT (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IKTKompetenciaSzint PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ENAPLOHASZNALAT                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ENAPLOHASZNALAT (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ENaploHasznalat PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TAGOZATTIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TAGOZATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TagozatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_NEBULO                                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NEBULO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ALLAMPOLGARSAGA                 int                              NULL,
    C_ALLAMPOLGARSAGA2                int                              NULL,
    C_ANYANYELVE                      int                              NULL,
    C_AZISKOLAALAKOHELYETOLEGYKILO    char(1)                          DEFAULT 'F' NULL,
    C_EDESANYJASZULETESICSALADINEV    nvarchar(255)                    NOT NULL,
    C_EDESANYJASZULETESIUTONEVE       nvarchar(255)                    NOT NULL,
    C_ELETVITELSZERUOTTLAKASKORZET    char(1)                          DEFAULT 'T' NULL,
    C_ELOTAG                          nvarchar(20)                     NULL,
    C_ETIKAHITERKOLCSTAN              int                              NULL,
    C_FELVETELSTATUSZA                int                              NULL,
    C_KEPVISELOCIMEAZONOS             char(1)                          DEFAULT 'T' NOT NULL,
    C_MEGJEGYZES                      nvarchar(max)                    NULL,
    C_NEME                            int                              NULL,
    C_OKTATASIAZONOSITOSZAMA          nvarchar(20)                     NULL,
    C_OVODAAZONOSITO                  nvarchar(20)                     NULL,
    C_OVODANEVE                       nvarchar(255)                    NULL,
    C_SZAKERTOIBIZOTTSAGKORMANYHIV    char(1)                          DEFAULT 'F' NULL,
    C_SZULETESICSALADINEVE            nvarchar(255)                    NULL,
    C_SZULETESIHELY                   nvarchar(50)                     NOT NULL,
    C_SZULETESIIDO                    datetime                         NOT NULL,
    C_SZULETESIORSZAG                 int                              NOT NULL,
    C_SZULETESIUTONEVE                nvarchar(255)                    NULL,
    C_SZULOJENEKMUNKAHELYEAZISKOLA    char(1)                          DEFAULT 'F' NULL,
    C_SZULOJETESTVERETARTOSANBETEG    char(1)                          DEFAULT 'F' NULL,
    C_TAGOZAT                         int                              NULL,
    C_TANULOCSALADINEVE               nvarchar(255)                    NOT NULL,
    C_TANULOUTONEVE                   nvarchar(255)                    NOT NULL,
    C_TESTVEREAZINTEZMENYTANULOJA     char(1)                          DEFAULT 'F' NULL,
    C_TKEMAILCIM                      nvarchar(255)                    NULL,
    C_TKNEVE                          nvarchar(200)                    NULL,
    C_TKROKONSAGIFOKA                 int                              NULL,
    C_TKTELEFON                       nvarchar(20)                     NULL,
    C_AJTO                            nvarchar(30)                     NULL,
    C_EMELET                          nvarchar(40)                     NULL,
    C_HAZSZAM                         nvarchar(30)                     NULL,
    C_HELYSEGNEV                      nvarchar(255)                    NULL,
    C_IRANYITOSZAM                    nvarchar(20)                     NULL,
    C_KOZTERULETNEV                   nvarchar(40)                     NULL,
    C_TKAJTO                          nvarchar(30)                     NULL,
    C_TKEMELET                        nvarchar(40)                     NULL,
    C_TKHAZSZAM                       nvarchar(30)                     NULL,
    C_TKHELYSEGNEV                    nvarchar(255)                    NULL,
    C_TKIRANYITOSZAM                  nvarchar(20)                     NULL,
    C_TKKOZTERULETNEV                 nvarchar(40)                     NULL,
    C_BTM                             char(1)                          DEFAULT 'F' NULL,
    C_BTMLETSZAMSULY                  numeric(10,2)                    DEFAULT 1 NULL,
    C_SNI                             char(1)                          DEFAULT 'F' NULL,
    C_SNILETSZAMSULY                  numeric(10,2)                    DEFAULT 1 NULL,
    C_THAJTO                          nvarchar(30)                     NULL,
    C_THHAZSZAM                       nvarchar(30)                     NULL,
    C_THHELYSEGNEV                    nvarchar(255)                    NULL,
    C_THIRANYITOSZAM                  nvarchar(20)                     NULL,
    C_THKOZTERULETNEV                 nvarchar(40)                     NULL,
    C_THEMELET                        nvarchar(40)                     NULL,
    C_TARTOZKODASIHELYAZONOS          char(1)                          DEFAULT 'T' NOT NULL,
    C_KEPVISELO2CIMEAZONOS            char(1)                          DEFAULT 'T' NOT NULL,
    C_TKAJTO2                         nvarchar(30)                     NULL,
    C_TKEMAILCIM2                     nvarchar(255)                    NULL,
    C_TKEMELET2                       nvarchar(40)                     NULL,
    C_TKHAZSZAM2                      nvarchar(30)                     NULL,
    C_TKHELYSEGNEV2                   nvarchar(255)                    NULL,
    C_TKIRANYITOSZAM2                 nvarchar(20)                     NULL,
    C_TKKOZTERULETNEV2                nvarchar(40)                     NULL,
    C_TKNEVE2                         nvarchar(200)                    NULL,
    C_TKROKONSAGIFOKA2                int                              NULL,
    C_TKTELEFON2                      nvarchar(20)                     NULL,
    C_ERTESITESDATUMA                 datetime                         NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_KIRSZOLGALTATASTIPUSID          int                              NULL,
    C_KIRSTATUSZ                      nvarchar(20)                     NULL,
    C_EUGYBAIROGZITETT                char(1)                          DEFAULT 'F' NOT NULL,
    C_EUGYMODOSITOTT                  char(1)                          DEFAULT 'F' NOT NULL,
    C_EUGYSZAM                        nvarchar(50)                     NULL,
    C_HATAROZATDATUMA                 datetime                         NULL,
    C_ISHATAROZATHOZVA                char(1)                          DEFAULT 'F' NOT NULL,
    C_HATAROZATSTATUSZ                int                              NULL,
    C_INDOKLAS                        nvarchar(max)                    NULL,
    C_OSZTALYA                        nvarchar(200)                    NULL,
    C_KOZTERULETJELLEGENEV            nvarchar(50)                     NULL,
    C_ORSZAGTIPUSID                   int                              NULL,
    C_THKOZTERULETJELLEGENEV          nvarchar(50)                     NULL,
    C_THORSZAGTIPUSID                 int                              NULL,
    C_TKKOZTERULETJELLEGENEV          nvarchar(50)                     NULL,
    C_TKKOZTERULETJELLEGENEV2         nvarchar(50)                     NULL,
    C_TKORSZAGTIPUSID                 int                              NULL,
    C_TKORSZAGTIPUSID2                int                              NULL,
    C_ISKOZPONTIMEGJELENT             char(1)                          DEFAULT 'F' NOT NULL,
    C_KORZETESISKOLACIME              nvarchar(500)                    NULL,
    C_KORZETESISKOLANEVE              nvarchar(500)                    NULL,
    C_FELEKEZETTIPUSID                int                              NULL,
    C_HATRANYOSHELYZETTIPUSID         int                              NULL,
    C_ISNEMMAGYAROVODA                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOKTAZONNELKULI                char(1)                          DEFAULT 'F' NOT NULL,
    C_NEMZETISEGTIPUSID               int                              NULL,
    C_OKTAZONINDOKLAS                 nvarchar(max)                    NULL,
    C_OVODAIEVEK                      numeric(10,2)                    NULL,
    C_TAGOZATNEV                      nvarchar(200)                    NULL,
    C_TKJOGALAPTIPUS2ID               int                              NULL,
    C_TKJOGALAPTIPUSID                int                              NULL,
    C_TKSZULETESINEV                  nvarchar(200)                    NULL,
    C_TKSZULETESINEV2                 nvarchar(200)                    NULL,
    C_ISOSSZEVONTOSZTALYBA            char(1)                          DEFAULT 'F' NOT NULL,
    C_FELADATELLATASIHELYID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Nebulo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FELVETELSTATUSZATIPUS                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FELVETELSTATUSZATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FelvetelStatuszaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_IDOKERET                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IDOKERET (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Idokeret PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_OSSZEGTULLEPESTIPUS                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OSSZEGTULLEPESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OsszegTullepesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_HIBAJEGYSTATUSZ                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HIBAJEGYSTATUSZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HibajegyStatusz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_PRIORITAS                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_PRIORITAS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Prioritas PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FORRAS                                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FORRAS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Forras PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZERZODOSZEMELYPOZICIO                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZERZODOSZEMELYPOZICIO (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzerzodoSzemelyPozicio PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ENAPLOTIPUS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ENAPLOTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ENaploTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ENAPLOFORRAS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ENAPLOFORRAS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ENaploForras PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ADATSZOLGALTATASENAPLO                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ADATSZOLGALTATASENAPLO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ENAPLOFORRASA                   int                              NULL,
    C_ENAPLOINFRAJA                   int                              NULL,
    C_ENAPLOTIPUSA                    int                              NULL,
    C_ISELLENORZO                     char(1)                          NULL,
    C_ISENAPLO                        char(1)                          NULL,
    C_ISPAPIRNAPLO                    char(1)                          NULL,
    C_SZERZODES                       varbinary(max)                   NULL,
    C_SZERZODESKEZDETE                datetime                         NULL,
    C_SZERZODESLEJARATA               datetime                         NULL,
    C_SZERZODESOSSZEGE                int                              NULL,
    C_SZERZODOSZEMELYNEVE             nvarchar(300)                    NULL,
    C_SZERZODOSZEMELYPOZICIOJA        int                              NULL,
    C_SZERZODESFILENAME               nvarchar(255)                    NULL,
    C_ENAPLOHASZNALATA                int                              NULL,
    C_PROJEKTOROKSZAMA                int                              NULL,
    C_WIFIELERES                      int                              NULL,
    C_MUKODOPROJEKTOROKSZAMA          int                              NULL,
    C_TERMEKSZAMA                     int                              NULL,
    C_WIFILEFEDETTTERMEKSZAMA         int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_AdatszolgaltatasENaplo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ENAPLOINFRA                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ENAPLOINFRA (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ENaploInfra PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_NEMKOTOTTMUNKAIDO                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NEMKOTOTTMUNKAIDO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_GROUPID                         nvarchar(36)                     NULL,
    C_KEZDETE                         datetime                         NOT NULL,
    C_MEGJEGYZES                      nvarchar(max)                    NULL,
    C_MEGTARTOTT                      char(1)                          NULL,
    C_TEVEKENYSEGTIPUSA               int                              NOT NULL,
    C_VEGE                            datetime                         NOT NULL,
    C_HETIREND                        int                              NOT NULL,
    C_ADMINALTALTOROLT                char(1)                          NULL,
    C_NAPLOZOTTMEGJEGYZES             nvarchar(max)                    NULL,
    C_ROGZITESDATUMA                  datetime                         DEFAULT GETDATE() NOT NULL,
    C_ISTANARALTALTOROLT              char(1)                          DEFAULT 'F' NOT NULL,
    C_TANARID                         int                              NOT NULL,
    C_TULAJDONOSID                    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NemKotottMunkaido PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ESLADAT                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESLADAT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATUM                           datetime                         NOT NULL,
    C_ERTEK                           nvarchar(1000)                   NOT NULL,
    C_TIPUS                           int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ESLAdat PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOESLADATOK                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOESLADATOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ALACSONYMAGATARTASERTEKELESU    char(1)                          NULL,
    C_ALACSONYSZORGALOMERTEKELESU     char(1)                          NULL,
    C_ALAPFOKUOKTATASBANRESZTVEVOT    char(1)                          NULL,
    C_AUTOMATIKUSJELZOGYAKORIIGAZO    int                              NULL,
    C_AUTOMATIKUSJELZOGYAKORIMULAS    int                              NULL,
    C_AUTOMATIKUSJELZOROMLOATLAG      int                              NULL,
    C_AUTOMATIKUSJELZOROMLOATLAGTA    int                              NULL,
    C_BEILLESZKEDESINEHEZSEGEKKELR    char(1)                          NULL,
    C_DATUM                           datetime                         NOT NULL,
    C_EVISMETLO                       char(1)                          NULL,
    C_EVISMETLOTANTARGYAK             nvarchar(1000)                   NULL,
    C_EVVEGIJEGYEKMIATTVESZELYEZTE    char(1)                          NULL,
    C_FELEVIJEGYEKMIATTVESZELYEZTE    char(1)                          NULL,
    C_FELEVIVESZELYEZTETETTTANTARG    nvarchar(1000)                   NULL,
    C_HALMOZOTTANHATRANYOSHELYZETU    char(1)                          NULL,
    C_HATRANYOSHELYZETU               char(1)                          NULL,
    C_IGAZOLATLANMULASZTASOKMIATTE    char(1)                          NULL,
    C_IGAZOLATLANMULASZTASOKMIATTV    char(1)                          NULL,
    C_INTEZETIALLAMINEVELT            char(1)                          NULL,
    C_JOGVISZONYTSZUNETELTETO         char(1)                          NULL,
    C_KOZEPFOKUOKTATASBATIZENHATOD    char(1)                          NULL,
    C_LIMITALTBOLLEGALABBKETTO        char(1)                          NULL,
    C_MAGANTANULO                     char(1)                          NULL,
    C_MAGANTANULOSAJATDONTESALAPJA    char(1)                          NULL,
    C_MAGANTANULOVAVALT               char(1)                          NULL,
    C_MAGANTANULOVAVALTSAJATDONTES    char(1)                          NULL,
    C_MAGATARTASIPROBLEMAVALKUZDO     char(1)                          NULL,
    C_MENEDEKJOGGALRENDELKEZO         char(1)                          NULL,
    C_MERESIAZONOSITO                 nvarchar(32)                     NOT NULL,
    C_MULASZTASOKMIATTVESZELYEZTET    char(1)                          NULL,
    C_RENDSZERESGYERMEKVEDELMIKEDV    char(1)                          NULL,
    C_SAJATOSNEVELESIIGENYU           char(1)                          NULL,
    C_TANEVKEZDETEOTATAVOZOTT         char(1)                          NULL,
    C_TANTARGYIATLAGMIATTVESZELYEZ    char(1)                          NULL,
    C_TANTARGYIMULASZTASOKMIATTELO    char(1)                          NULL,
    C_TANTARGYIMULASZTASOKMIATTVES    char(1)                          NULL,
    C_TANULASIPROBLEMAVALKUZDO        char(1)                          NULL,
    C_VESZELYEZTETETT                 char(1)                          NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloESLAdatok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ESLADATTIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESLADATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ESLAdatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FOGLALKOZASARCHIV                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGLALKOZASARCHIV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ALKALMAZOTTID                   int                              NULL,
    C_ELFOGADASDATUMA                 datetime                         NULL,
    C_FELADATELLATASIHELYID           int                              NULL,
    C_FELADATELLATASIHELYNEVE         nvarchar(255)                    NULL,
    C_ORASZAM                         numeric(10,2)                    NULL,
    C_OSZTALYCSOPORTID                int                              NULL,
    C_OSZTALYCSOPORTNEVE              nvarchar(255)                    NULL,
    C_TANARKOTELEZOORASZAMA           numeric(10,2)                    NULL,
    C_TANARMUNKAIDOKEDVEZMENYE        int                              NULL,
    C_TANARMUNKAIDOKEDVEZMENYOKA      nvarchar(255)                    NULL,
    C_TANARMUNKAIDOKEDVEZMENYOKAID    int                              NULL,
    C_TANARMUNKAKORE                  nvarchar(255)                    NULL,
    C_TANARMUNKAKOREID                int                              NULL,
    C_TANARNEVE                       nvarchar(255)                    NULL,
    C_TANARPEDAGOGIAIKEPESITESE       nvarchar(255)                    NULL,
    C_TANARPEDAGOGIAIKEPESITESEID     int                              NULL,
    C_TANEVNEVE                       nvarchar(255)                    NULL,
    C_TANTARGYID                      int                              NULL,
    C_TANTARGYNEVE                    nvarchar(255)                    NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FoglalkozasArchiv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SOROLASOKATIPUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SOROLASOKATIPUS (
    ID                                int                              NOT NULL,
    C_ISBIZONYITVANYBANMEGJELENIK     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISNAPLOBANMEGJELENIK            char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTORZSLAPONMEGJELENIK          char(1)                          DEFAULT 'F' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SorolasOkaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_CSOPORTTIPUS_FOGLALKOZASTIPU                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CSOPORTTIPUS_FOGLALKOZASTIPU (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_CSOPORTBONTOTT                  char(1)                          NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    C_CSOPORTTIPUSID                  int                              NOT NULL,
    C_FOGLALKOZASTIPUSID              int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_CsoportTipus_FoglalkozasTipus PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KIRTELEPHELY                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KIRTELEPHELY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KOD                             nvarchar(20)                     NOT NULL,
    C_KRETAKOD                        nvarchar(20)                     NOT NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_INTEZMENYADATOKID               int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KirTelephely PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MUNKAIDOKEDVEZMENYOKA                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUNKAIDOKEDVEZMENYOKA (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MunkaidoKedvezmenyOka PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_BESOROLASIFOKOZATTIPUS                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_BESOROLASIFOKOZATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_BesorolasiFokozatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_INTEZMENYADATSZOLGALTATAS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_INTEZMENYADATSZOLGALTATAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELFOGADOTTESL                   char(1)                          NULL,
    C_ELFOGADOTTTTF                   char(1)                          NULL,
    C_VEGLEGESESL                     char(1)                          NULL,
    C_VEGLEGESTTF                     char(1)                          NULL,
    C_FENNTARTOTTFELUTASITASOKA       nvarchar(max)                    NULL,
    C_ELFOGADOTTESLDATUMA             datetime                         NULL,
    C_ELFOGADOTTLETSZAM               char(1)                          NULL,
    C_ELFOGADOTTLETSZAMDATUMA         datetime                         NULL,
    C_ELFOGADOTTTTFDATUMA             datetime                         NULL,
    C_FENNTARTOESLELUTASITASOKA       nvarchar(max)                    NULL,
    C_VEGLEGESESLDATUMA               datetime                         NULL,
    C_VEGLEGESLETSZAM                 char(1)                          NULL,
    C_VEGLEGESLETSZAMDATUMA           datetime                         NULL,
    C_VEGLEGESTTFDATUMA               datetime                         NULL,
    C_BEIRATKOZASELUTASITASOKA        nvarchar(max)                    NULL,
    C_ELFOGADOTTBEIRATKOZAS           char(1)                          NULL,
    C_VEGLEGESBEIRATKOZAS             char(1)                          DEFAULT 'F' NULL,
    C_SZAKBEIRATKFELVETT              int                              NULL,
    C_SZAKBEIRATKJELENTKEZETT         int                              NULL,
    C_VEGLEGESETTF                    char(1)                          DEFAULT 'F' NOT NULL,
    C_VEGLEGESSZIRSTATDATUMA          datetime                         NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    C_SZIRSTATVEGLEGESITOID           int                              NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IntezmenyAdatszolgaltatas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_PEDAGOGUSSTATUSZ                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_PEDAGOGUSSTATUSZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_PedagogusStatusz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KRETATIPUS                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KRETATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KretaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANTARGYNEVHEZKATEGORIA                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANTARGYNEVHEZKATEGORIA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_SORSZAM                         int                              NOT NULL,
    C_TARGYKATEGORIA                  int                              NOT NULL,
    C_TARGYNEVVARIANS                 nvarchar(255)                    NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TantargyNevhezKategoria PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_NAPTARIHET                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NAPTARIHET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_HETIREND                        int                              NULL,
    C_HETKEZDONAPJA                   datetime                         NOT NULL,
    C_HETSORSZAMA                     int                              NOT NULL,
    C_HETUTOLSONAPJA                  datetime                         NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NaptariHet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_HELYETTESITESIIDOSZAK                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HELYETTESITESIIDOSZAK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_HETSORSZAMA                     int                              NOT NULL,
    C_HELYETTESITESNAPJA              datetime                         NOT NULL,
    C_HELYETTESITESOKA                nvarchar(500)                    NULL,
    C_HELYETTESITESTIPUS              int                              NOT NULL,
    C_GROUPID                         int                              NULL,
    C_ISTULORA                        char(1)                          DEFAULT 'F' NOT NULL,
    C_ROGZITOID                       int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    C_HELYETTESITETTORARENDID         int                              NOT NULL,
    C_HELYETTESTANAROKID              int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HelyettesitesiIdoszak PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TELEPULES                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TELEPULES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_IRANYITOSZAM                    nvarchar(20)                     NOT NULL,
    C_MEGYE                           nvarchar(100)                    NULL,
    C_ORSZAG                          nvarchar(255)                    NOT NULL,
    C_TELEPULESNEV                    nvarchar(255)                    NOT NULL,
    C_TELEPULESNEV_1                  nvarchar(255)                    NULL,
    C_TELEPULESNEV_2                  nvarchar(255)                    NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Telepules PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_INTEZMENY                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_INTEZMENY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AZONOSITO                       nvarchar(30)                     NOT NULL,
    C_FENNTARTOAZONOSITO              nvarchar(20)                     NULL,
    C_NEPTUNNAPLOLINK                 nvarchar(255)                    NULL,
    C_POSZEIDONBEJELENTKEZESINEV      nvarchar(255)                    NULL,
    C_ALTERNATIVAZONOSITO             nvarchar(30)                     NULL,
    C_FENNTARTOEMAILCIM               nvarchar(255)                    NULL,
    C_IKTATOSZERVEZETAZONOSITO        nvarchar(255)                    NULL,
    C_NEXIUSID                        nvarchar(50)                     NULL,
    C_GUID                            uniqueidentifier                 NULL,
    C_ISARCHIV                        char(1)                          DEFAULT 'F' NOT NULL,
    C_FENNTARTOID                     int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Intezmeny PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_IKTATOTTDOKUMENTUMOK                                                 */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IKTATOTTDOKUMENTUMOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AZONOSITO                       nvarchar(255)                    NOT NULL,
    C_IKTATOSZAM                      nvarchar(255)                    NOT NULL,
    C_DOKPARTNERGONDVISELOID          int                              NULL,
    C_FELTOLTOGONDVISELOID            int                              NULL,
    C_DOKUMENTUMPARTNEREID            int                              NOT NULL,
    C_FELTOLTOFELHASZNALOID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IktatottDokumentumok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_JOGOSULTSAG                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_JOGOSULTSAG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_JOG                             nvarchar(50)                     NOT NULL,
    C_SZEREPKORTIPUS                  int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Jogosultsag PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZEREPKORTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZEREPKORTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzerepkorTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULOKOZOSSEGISZOLGALAT                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOKOZOSSEGISZOLGALAT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_INTERVALLUMKEZDETE              datetime                         NOT NULL,
    C_MEGJEGYZES                      nvarchar(1000)                   NULL,
    C_ORASZAM                         numeric(10,2)                    NULL,
    C_TELJESITESIHELYE                nvarchar(255)                    NULL,
    C_KOZOSSEGISZOLGALATTIPUSA        int                              NOT NULL,
    C_INTERVALLUMVEGE                 datetime                         NOT NULL,
    C_UGYIRATSZAM                     nvarchar(50)                     NULL,
    C_ROGZITESDATUM                   datetime                         NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_FELJEGYZOID                     int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloKozossegiSzolgalat PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_RENDSZERERTESITESEK                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_RENDSZERERTESITESEK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BEALLITASOKELLENORZESE          char(1)                          NULL,
    C_FRISSITESIDEJE                  datetime                         NULL,
    C_INTEZMENYHIANYOSADATOK          char(1)                          NULL,
    C_KELLFRISSITES                   char(1)                          NULL,
    C_ORARENDTANARUTKOZES             int                              NULL,
    C_ORARENDTANULOUTKOZESEK          int                              NULL,
    C_ORARENDTEREMUTKOZES             int                              NULL,
    C_TANAROKHIANYOSOKTATASIAZONOS    int                              NULL,
    C_TANTARGYFELOSZTASOSZTALYOKNI    int                              NULL,
    C_TANTARGYFELOSZTASTANARNINCSE    int                              NULL,
    C_TANTARGYFELOSZTASTANTARGYNIN    int                              NULL,
    C_TANULOHIANYOSOKTATASIAZONOSI    int                              NULL,
    C_TANULOKOSZTALYBASOROLASA        int                              NULL,
    C_TANTERVNELKULITANULOK           int                              NULL,
    C_AKTIVCSENGETESIREND             char(1)                          NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_RendszerErtesitesek PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MUNKAUGYIADATOK                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUNKAUGYIADATOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ALKALMAZASKEZDETE               datetime                         NULL,
    C_ALKALMAZASMEGSZUNESE            datetime                         NULL,
    C_KOTELEZOORASZAM                 numeric(10,2)                    NULL,
    C_MUNKAIDOKEDVEZMENYORASZAM       numeric(10,2)                    NULL,
    C_MUNKAKORTIPUSA                  int                              NULL,
    C_MUNKAVISZONYTIPUSA              int                              NULL,
    C_BETOLTETLENALLASHELY            char(1)                          DEFAULT 'F' NOT NULL,
    C_MUNKAIDOKEDVEZMENYOKASZOVEG     nvarchar(max)                    NULL,
    C_TARTOSHELYETTESITES             char(1)                          DEFAULT 'F' NOT NULL,
    C_PEDAGOGUSSTATUSZA               int                              NULL,
    C_BESOROLASIFOKOZAT               int                              NULL,
    C_MUNKAIDOKEDVEZMENYOKA           int                              NULL,
    C_NYUGDIJAS                       char(1)                          DEFAULT 'F' NOT NULL,
    C_RESZMUNKAIDOSZAZALEK            numeric(10,2)                    DEFAULT 100 NULL,
    C_FOGLALKOZTATASTIPUS             int                              NULL,
    C_VEZETOIORASZAMOK                int                              NULL,
    C_UTAZOGYOGYPEDAGOGUS             char(1)                          DEFAULT 'F' NOT NULL,
    C_CSOKKENTETTMUNKAIDOS            char(1)                          DEFAULT 'F' NOT NULL,
    C_SZAKERTOMESTERPEDAGOGUS         char(1)                          DEFAULT 'F' NOT NULL,
    C_SZABADALLASHELY                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ATTANITO                        char(1)                          DEFAULT 'F' NOT NULL,
    C_ATTANITOMASINTEZMENYNEL         char(1)                          DEFAULT 'F' NOT NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_EFOP324PROJEKT                  char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKULSOALKALMAZOTT              char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAKERTOKUTATOTANAR           char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTAVOLLETFOINTEZMENYE          char(1)                          DEFAULT 'T' NOT NULL,
    C_EGYEBTEVEKENYSEGEKTIPUSID       int                              NULL,
    C_ISATTANITOSZCNBELUL             char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOKTATOIFELADATOK              char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOSZTALYFONOK                  char(1)                          DEFAULT 'F' NOT NULL,
    C_MUNKAUGYTORVENYIHATALYTIPUSI    int                              NULL,
    C_DUALISKEPZOHELYADOSZAMA         nvarchar(20)                     NULL,
    C_DUALISKEPZOHELYNEVE             nvarchar(255)                    NULL,
    C_ISVEZETOPEDAGOGUS               char(1)                          DEFAULT 'F' NOT NULL,
    C_ISIKTESZKOZOKETLGALABB40HASZ    char(1)                          DEFAULT 'T' NOT NULL,
    C_ISINFORMATKEPISMRENDELKEZIK     char(1)                          DEFAULT 'T' NOT NULL,
    C_ISINTERNETETOKTCELRAHASZNAL     char(1)                          DEFAULT 'T' NOT NULL,
    C_KEPESITESTIPUSID                int                              NULL,
    C_ISAPACZAIMENTOR                 char(1)                          DEFAULT 'F' NOT NULL,
    C_SZERZODESSZAM                   nvarchar(20)                     NULL,
    C_ISNYUGDIJAS                     char(1)                          DEFAULT 'F' NOT NULL,
    C_NYUGDIJKEZDET                   datetime                         NULL,
    C_NYUGDIJTIPUS                    int                              NULL,
    C_FELADATELLATASIHELYID           int                              NULL,
    C_ALKALMAZOTTID                   int                              NOT NULL,
    C_SZERVEZETID                     int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MunkaugyiAdatok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SYSTEMSETTINGSCONTROLTYPE                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SYSTEMSETTINGSCONTROLTYPE (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SystemSettingsControlType PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MULASZTASSTATISZTIKATIPUS                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MULASZTASSTATISZTIKATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MulasztasStatisztikaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_OLDALLATOGATOTTSAG                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OLDALLATOGATOTTSAG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_LATOGATASIDEJE                  datetime                         NOT NULL,
    C_MENUPONT                        nvarchar(255)                    NULL,
    C_URL                             nvarchar(1000)                   NULL,
    C_GONDVISELOID                    int                              NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OldalLatogatottsag PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FELADATELLATASIHELY                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FELADATELLATASIHELY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_OKTATASINEVELESIFELADATTIPUS    int                              NOT NULL,
    C_ENGEDELYEZETTOSSZLETSZAM        int                              NULL,
    C_ENGEDELYEZETTOSZTALY            int                              NULL,
    C_FELADATELLATASIHELYKOD          nvarchar(3)                      NULL,
    C_MUKODESIHELYID                  int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FeladatEllatasiHely PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_RENDSZERBEALLITASTIPUS                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_RENDSZERBEALLITASTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_RendszerBeallitasTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ORATERVTARGY                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORATERVTARGY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EVESORASZAM                     numeric(10,2)                    NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    C_ORATERVID                       int                              NOT NULL,
    C_TANTARGYID                      int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OraTervTargy PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_RENDSZERBEALLITAS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_RENDSZERBEALLITAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ALAPERTEK                       nvarchar(max)                    NULL,
    C_BEALLITASTIPUS                  int                              NOT NULL,
    C_ERTEK                           nvarchar(max)                    NOT NULL,
    C_ERTEKTIPUS                      int                              NOT NULL,
    C_ISDISABLED                      char(1)                          DEFAULT 'F' NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_RendszerBeallitas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORATERV                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORATERV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EVFOLYAM                        int                              NOT NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_TANTERVID                       int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OraTerv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_KIZAROCSOPORTTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KIZAROCSOPORTTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KizaroCsoportTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANARIATLAGSULY                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANARIATLAGSULY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_SULY                            int                              NOT NULL,
    C_ERTEKELESMODID                  int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanariAtlagSuly PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTESITESGENERALASTORTENET                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTESITESGENERALASTORTENET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ENTITASID                       int                              NOT NULL,
    C_ENTITASNEV                      nvarchar(50)                     NOT NULL,
    C_ERTESITESTIPUSA                 int                              NOT NULL,
    C_KIEGESZITOADATOK                nvarchar(1000)                   NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtesitesGeneralasTortenet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTESITES                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTESITES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERVENYESSEGKEZDETE              datetime                         NOT NULL,
    C_LETREHOZASDATUM                 datetime                         NOT NULL,
    C_NAVIGALASPARAMETER              nvarchar(255)                    NULL,
    C_SZINTIPUS                       int                              NOT NULL,
    C_TIPUS                           int                              NOT NULL,
    C_TOROLHETO                       char(1)                          DEFAULT 'F' NULL,
    C_UZENET                          nvarchar(max)                    NOT NULL,
    C_GLOBALIS                        char(1)                          DEFAULT 'F' NULL,
    C_GLOBALISERVENYESSEGVEGE         datetime                         NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Ertesites PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTESITESTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTESITESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtesitesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ERTESITESSZINTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTESITESSZINTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtesitesSzinTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TEVEKENYSEGTIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TEVEKENYSEGTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TevekenysegTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_PEDAGOGUSELETPALYAMODELL                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_PEDAGOGUSELETPALYAMODELL (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_FOKOZAT                         int                              NOT NULL,
    C_MINOSITESDATUM                  datetime                         NOT NULL,
    C_PORTFOLIOSTATUSZ                int                              NULL,
    C_TANARID                         int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_PedagogusEletpalyamodell PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ELETPALYAMODELLFOKOZATTIPUS                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ELETPALYAMODELLFOKOZATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EletpalyamodellFokozatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ELETPALYAMODELLSTATUSZOK                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ELETPALYAMODELLSTATUSZOK (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EletpalyamodellStatuszok PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULOMENTESSEG                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOMENTESSEG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ERTEKELESMENTESITES             char(1)                          NULL,
    C_KEZDETE                         datetime                         NULL,
    C_MENTESSEGOKA                    nvarchar(max)                    NULL,
    C_ORAMENTESITES                   char(1)                          NULL,
    C_VEGE                            datetime                         NULL,
    C_SZOVEGESENERTEKELHETO           char(1)                          NULL,
    C_FELMENTESROGZITESIDOPONTJA      datetime                         NULL,
    C_UTOLSOMODOSITASIDOPONTJA        datetime                         NULL,
    C_FELMENTESROGZITOTANARNEV        nvarchar(255)                    NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_FELMENTESROGZITOTANARID         int                              NULL,
    C_UTOLSOMODOSITOTANARID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloMentesseg PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_NAPLOELLENORZES                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NAPLOELLENORZES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_ELLENORZESDATUMA                datetime                         NOT NULL,
    C_ESZREVETEL                      nvarchar(max)                    NULL,
    C_HETSORSZAMA                     int                              NOT NULL,
    C_OSZTALYID                       int                              NOT NULL,
    C_ELLENORZOSZEMELYID              int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NaploEllenorzes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_IGAZOLAS                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IGAZOLAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_IGAZOLASTIPUSA                  int                              NOT NULL,
    C_KEZDETE                         datetime                         NOT NULL,
    C_MEGJEGYZES                      nvarchar(max)                    NULL,
    C_ROGZITESDATUMA                  datetime                         NOT NULL,
    C_VEGE                            datetime                         NOT NULL,
    C_UGYIRATSZAM                     nvarchar(50)                     NULL,
    C_TANULOID                        int                              NOT NULL,
    C_ROGZITOID                       int                              NOT NULL,
    C_SZERVEZETID                     int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Igazolas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORALATOGATAS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORALATOGATAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATUM                           datetime                         NOT NULL,
    C_MEGJEGYZES                      nvarchar(max)                    NOT NULL,
    C_ORALATOGATOBEOSZTASA            nvarchar(255)                    NULL,
    C_ERTEKELOID                      int                              NOT NULL,
    C_MEGTARTOTTORAID                 int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Oralatogatas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MAGATARTASERTEKELESTIPUS                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MAGATARTASERTEKELESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MagatartasErtekelesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_SZORGALOMERTEKELESTIPUS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZORGALOMERTEKELESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_SzorgalomErtekelesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULOESEMENY                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOESEMENY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KEZDETE                         datetime                         NULL,
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_TARTALOM                        nvarchar(max)                    NOT NULL,
    C_TIPUS                           int                              NOT NULL,
    C_TARGY                           nvarchar(255)                    NOT NULL,
    C_FALIUJSAGMEGJELENES             char(1)                          NULL,
    C_MINDENKINEK                     char(1)                          NULL,
    C_VEGE                            datetime                         NULL,
    C_ESEMENYDATUMA                   datetime                         NOT NULL,
    C_ISERTESITESELKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_TARTALOMWEB                     nvarchar(max)                    NULL,
    C_ROGZITESDATUMA                  datetime                         DEFAULT GETDATE() NOT NULL,
    C_TANTARGYID                      int                              NULL,
    C_TANITASIORAID                   int                              NULL,
    C_FELJEGYZOID                     int                              NOT NULL,
    C_ROGZITESKORIOSZTALYID           int                              NULL,
    C_BEIRASTANULOID                  int                              NULL,
    C_BEIRASOSZTALYCSOPORTID          int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloEsemeny PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ESEMENYTIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESEMENYTIPUS (
    ID                                int                              NOT NULL,
    C_ISELLENORZOBENMEGJELENIK        char(1)                          DEFAULT 'F' NOT NULL,
    C_ISNAPLOBANMEGJELENIK            char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTORZSLAPONMEGJELENIK          char(1)                          DEFAULT 'F' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EsemenyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_IGAZOLASTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IGAZOLASTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IgazolasTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_CSENGETESIRENDORA                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CSENGETESIRENDORA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KEZDETE                         datetime                         NOT NULL,
    C_ORASZAM                         int                              NOT NULL,
    C_VEGE                            datetime                         NOT NULL,
    C_CSENGETESIRENDID                int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_CsengetesiRendOra PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MULASZTASTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MULASZTASTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MulasztasTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULOMULASZTAS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOMULASZTAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_IGAZOLT                         char(1)                          NULL,
    C_KESESPERCBEN                    int                              NULL,
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_TIPUS                           int                              NOT NULL,
    C_IGAZOLASTIPUSA                  int                              NULL,
    C_ISERTESITESELKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    C_ORATANULOIID                    int                              NOT NULL,
    C_TANITASIORAKID                  int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloMulasztas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ERTEKELESMOD                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTEKELESMOD (
    ID                                int                              NOT NULL,
    C_ISSZAMONKERESKORLATOZOTT        char(1)                          DEFAULT 'F' NOT NULL,
    C_ISBOLD                          char(1)                          DEFAULT 'F' NOT NULL,
    C_SULY                            int                              DEFAULT 100 NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtekelesMod PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_OSZTALYZATTIPUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OSZTALYZATTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OsztalyzatTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ERTEKELESTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTEKELESTIPUS (
    ID                                int                              NOT NULL,
    C_ISEGYSZERADHATO                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtekelesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULOERTEKELES                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOERTEKELES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DATUM                           datetime                         NOT NULL,
    C_TIPUSID                         int                              NOT NULL,
    C_ERTEKELESSZOVEG                 nvarchar(max)                    NULL,
    C_ROGZITESDATUM                   datetime                         NOT NULL,
    C_ERTEKELESOSZTALYZATID           int                              NULL,
    C_ERTEKELESSZOVEGROVIDNEV         nvarchar(3)                      NULL,
    C_ERTEKELESMODID                  int                              NULL,
    C_ERTEKELESTEMA                   nvarchar(2000)                   NULL,
    C_ERTEKELESSZAZALEK               int                              NULL,
    C_ISMAGATARTASSZORGALOM           char(1)                          NOT NULL,
    C_MAGATARTASERTEKID               int                              NULL,
    C_MAGATARTASOSZTALYZATID          int                              NULL,
    C_MAGATARTASSZOVEG                nvarchar(max)                    NULL,
    C_MAGATARTASSZOVEGROVIDNEV        nvarchar(3)                      NULL,
    C_SZORGALOMERTEKID                int                              NULL,
    C_SZORGALOMOSZTALYZATID           int                              NULL,
    C_SZORGALOMSZOVEG                 nvarchar(max)                    NULL,
    C_SZORGALOMSZOVEGROVIDNEV         nvarchar(3)                      NULL,
    C_ISFROMMOBIL                     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISERTESITESELKULDVE             char(1)                          DEFAULT 'F' NOT NULL,
    C_ERTEKELESSZOVEGFORMAZOTT        nvarchar(max)                    NULL,
    C_MAGATARTASSZOVEGFORMAZOTT       nvarchar(max)                    NULL,
    C_SZORGALOMSZOVEGFORMAZOTT        nvarchar(max)                    NULL,
    C_ISMAGATARTAS                    AS (CAST(IIF(C_MAGATARTASERTEKID IS NULL AND C_MAGATARTASOSZTALYZATID IS NULL AND C_MAGATARTASSZOVEG IS NULL AND C_MAGATARTASSZOVEGFORMAZOTT IS NULL, 'F', 'T') AS CHAR(1))) PERSISTED,
    C_ISSZORGALOM                     AS (CAST(IIF(C_SZORGALOMERTEKID IS NULL AND C_SZORGALOMOSZTALYZATID IS NULL AND C_SZORGALOMSZOVEG IS NULL AND C_SZORGALOMSZOVEGFORMAZOTT IS NULL, 'F', 'T') AS CHAR(1))) PERSISTED,
    C_ERTEKELESMAGSZORID              int                              NULL,
    C_ERTEKELESTANTARGYIID            int                              NULL,
    C_TANTARGYID                      int                              NULL,
    C_TANULOID                        int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NULL,
    C_ERTEKELOID                      int                              NOT NULL,
    C_TANORAID                        int                              NULL,
    C_OSSZEFUGGOSZAKGYAKID            int                              NULL,
    C_ROGZITESKORITANULOOSZTALYID     int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloErtekeles PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANITASIORA                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANITASIORA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BEJEGYZESIDEJE                  datetime                         NOT NULL,
    C_BONTOTT                         char(1)                          DEFAULT 'F' NOT NULL,
    C_DATUM                           datetime                         NOT NULL,
    C_HELYETTESITESOKA                nvarchar(500)                    NULL,
    C_HELYETTESITESTIPUSA             int                              NULL,
    C_HETNAPJA                        int                              NOT NULL,
    C_HETSORSZAMA                     int                              NOT NULL,
    C_IKTTANORA                       char(1)                          DEFAULT 'F' NOT NULL,
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_MEGTARTOTT                      char(1)                          DEFAULT 'T' NOT NULL,
    C_NAPSORSZAMA                     int                              NOT NULL,
    C_NEMSZAKRENDSZERUORA             char(1)                          DEFAULT 'F' NOT NULL,
    C_ORAKEZDETE                      datetime                         NOT NULL,
    C_ORASZAM                         int                              NULL,
    C_ORAVEGE                         datetime                         NOT NULL,
    C_SORSZAMOZANDO                   char(1)                          DEFAULT 'T' NOT NULL,
    C_TAMOPORA                        char(1)                          DEFAULT 'F' NOT NULL,
    C_TEMA                            nvarchar(1000)                   NULL,
    C_TULORA                          char(1)                          DEFAULT 'F' NOT NULL,
    C_OSZTALYFONOKI                   char(1)                          DEFAULT 'F' NOT NULL,
    C_HAZIFELADAT                     nvarchar(max)                    NULL,
    C_DIFFERENCIALT                   char(1)                          DEFAULT 'F' NOT NULL,
    C_DRAMA                           char(1)                          DEFAULT 'F' NOT NULL,
    C_IPRTANORA                       char(1)                          DEFAULT 'F' NOT NULL,
    C_KOOPERATIV                      char(1)                          DEFAULT 'F' NOT NULL,
    C_MERES                           char(1)                          DEFAULT 'F' NOT NULL,
    C_MINDENNAPOSTESTNEVELES          char(1)                          DEFAULT 'F' NOT NULL,
    C_NEMZETISEGIORA                  char(1)                          DEFAULT 'F' NOT NULL,
    C_PARHUZAMOSORA                   char(1)                          DEFAULT 'F' NOT NULL,
    C_TIOP12                          char(1)                          DEFAULT 'F' NOT NULL,
    C_ADMINALTALKIIRT                 char(1)                          DEFAULT 'F' NOT NULL,
    C_CSENGETESIRENDID                int                              NULL,
    C_CSENGETESIRENDORAID             int                              NULL,
    C_ORARENDIORAGROUPID              int                              NULL,
    C_MOBILNAPLOZOTT                  char(1)                          DEFAULT 'F' NOT NULL,
    C_EFOP32317                       char(1)                          DEFAULT 'F' NOT NULL,
    C_MULTIKULTURALISORA              char(1)                          DEFAULT 'F' NOT NULL,
    C_KOMPLEXORA                      char(1)                          DEFAULT 'F' NOT NULL,
    C_KIPORA                          char(1)                          DEFAULT 'F' NOT NULL,
    C_VEKOP73317                      char(1)                          DEFAULT 'F' NOT NULL,
    C_KAPORA                          char(1)                          DEFAULT 'F' NOT NULL,
    C_GINOP623                        char(1)                          DEFAULT 'F' NOT NULL,
    C_EFOP31716                       char(1)                          DEFAULT 'F' NOT NULL,
    C_EFOP33717                       char(1)                          DEFAULT 'F' NOT NULL,
    C_TIOP1111212012001               char(1)                          DEFAULT 'F' NOT NULL,
    C_EGYEDINAP                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDFHTKIPORA                    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDFHTORA                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDIGITALISALAPUALPROGRAM       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISELETGYAKORLATALAPUALPROGRA    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISLOGIKAALAPUALPROGRAM          char(1)                          DEFAULT 'F' NOT NULL,
    C_ISMUVESZETALAPUALPROGRAM        char(1)                          DEFAULT 'F' NOT NULL,
    C_ISRAHANGOLODAS                  char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTEORAD                        char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTESTMOZGASALAPUALPROGRAM      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISFELNOTTOKTATASISZERZODES      char(1)                          DEFAULT 'F' NOT NULL,
    C_EFOP23517                       char(1)                          DEFAULT 'F' NOT NULL,
    C_DIGESZKOZTIPUSID                int                              NULL,
    C_DIGPLATFORMTIPUSID              int                              NULL,
    C_ORAEVESSORSZAMA                 int                              NULL,
    C_TANMENETID                      int                              NULL,
    C_TANTARGYID                      int                              NULL,
    C_NAPTARINAPID                    int                              NULL,
    C_ORARENDIORAID                   int                              NULL,
    C_FOGLALKOZASID                   int                              NULL,
    C_HELYETTESITOTANARID             int                              NULL,
    C_TANARID                         int                              NOT NULL,
    C_TEREMID                         int                              NULL,
    C_OSZTALYCSOPORTID                int                              NULL,
    C_ORATULAJDONOSID                 int                              NOT NULL,
    C_TANULASIEGYSEGID                int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanitasiOra PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_HELYETTESITESTIPUS                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HELYETTESITESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HelyettesitesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_NAPTARINAP                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NAPTARINAP (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_HETIREND                        int                              NOT NULL,
    C_HETNAPJA                        int                              NOT NULL,
    C_HETSORSZAMA                     int                              NOT NULL,
    C_NAPDATUMA                       datetime                         NOT NULL,
    C_NAPTIPUSA                       int                              NULL,
    C_ORARENDINAP                     char(1)                          DEFAULT 'T' NULL,
    C_ALAPHETIREND                    int                              NULL,
    C_ALAPHETNAPJA                    int                              NULL,
    C_ALAPNAPTIPUSA                   int                              NULL,
    C_ALAPORARENDINAP                 char(1)                          DEFAULT 'T' NULL,
    C_ALAPCSENGETESIRENDID            int                              NULL,
    C_AKTIVCSENGETESIRENDID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NaptariNap PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANMENET                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANMENET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BEJEGYZESIDEJE                  datetime                         NOT NULL,
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_NEV                             nvarchar(1000)                   NOT NULL,
    C_ROVIDNEV                        nvarchar(255)                    NULL,
    C_TEMA                            nvarchar(max)                    NOT NULL,
    C_ORASZAM                         int                              NOT NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_TANTARGYID                      int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_FELTOLTOID                      int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Tanmenet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ORARENDIORA                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORARENDIORA (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DIFFERENCIALT                   char(1)                          DEFAULT 'F' NOT NULL,
    C_DRAMA                           char(1)                          DEFAULT 'F' NOT NULL,
    C_HETIREND                        int                              NOT NULL,
    C_HETNAPJA                        int                              NOT NULL,
    C_IKTTANORA                       char(1)                          DEFAULT 'F' NOT NULL,
    C_IPRTANORA                       char(1)                          DEFAULT 'F' NOT NULL,
    C_KOOPERATIV                      char(1)                          DEFAULT 'F' NOT NULL,
    C_MERES                           char(1)                          DEFAULT 'F' NOT NULL,
    C_MINDENNAPOSTESTNEVELES          char(1)                          DEFAULT 'F' NOT NULL,
    C_NEMSZAKRENDSZERUORA             char(1)                          DEFAULT 'F' NOT NULL,
    C_NEMZETISEGIORA                  char(1)                          DEFAULT 'F' NOT NULL,
    C_ORASZAM                         int                              NULL,
    C_SORSZAMOZANDO                   char(1)                          DEFAULT 'T' NOT NULL,
    C_TAMOPORA                        char(1)                          DEFAULT 'F' NOT NULL,
    C_TULORA                          char(1)                          DEFAULT 'F' NOT NULL,
    C_BONTOTT                         char(1)                          DEFAULT 'F' NOT NULL,
    C_ORAERVENYESSEGKEZDETE           datetime                         NOT NULL,
    C_ORAERVENYESSEGVEGE              datetime                         NULL,
    C_PARHUZAMOSORA                   char(1)                          DEFAULT 'F' NOT NULL,
    C_TIOP12                          char(1)                          DEFAULT 'F' NOT NULL,
    C_ORAKEZDETE                      datetime                         NULL,
    C_ORAVEGE                         datetime                         NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_CSENGETESIRENDID                int                              NULL,
    C_CSENGETESIRENDORAID             int                              NULL,
    C_ORARENDIORAGROUPID              int                              NULL,
    C_EFOP32317                       char(1)                          DEFAULT 'F' NOT NULL,
    C_MULTIKULTURALISORA              char(1)                          DEFAULT 'F' NOT NULL,
    C_KOMPLEXORA                      char(1)                          DEFAULT 'F' NOT NULL,
    C_KIPORA                          char(1)                          DEFAULT 'F' NOT NULL,
    C_VEKOP73317                      char(1)                          DEFAULT 'F' NOT NULL,
    C_KAPORA                          char(1)                          DEFAULT 'F' NOT NULL,
    C_GINOP623                        char(1)                          DEFAULT 'F' NOT NULL,
    C_EGYEDINAP                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKEZZELFELVETTEGYEDINAP        char(1)                          DEFAULT 'F' NOT NULL,
    C_EFOP31716                       char(1)                          DEFAULT 'F' NOT NULL,
    C_EFOP33717                       char(1)                          DEFAULT 'F' NOT NULL,
    C_TIOP1111212012001               char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDFHTKIPORA                    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDFHTORA                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDIGITALISALAPUALPROGRAM       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISELETGYAKORLATALAPUALPROGRA    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISLOGIKAALAPUALPROGRAM          char(1)                          DEFAULT 'F' NOT NULL,
    C_ISMUVESZETALAPUALPROGRAM        char(1)                          DEFAULT 'F' NOT NULL,
    C_ISRAHANGOLODAS                  char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTEORAD                        char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTESTMOZGASALAPUALPROGRAM      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISFELNOTTOKTATASISZERZODES      char(1)                          DEFAULT 'F' NOT NULL,
    C_KOZPONTILAGTOROLTORAGROUPID     uniqueidentifier                 NULL,
    C_KOZPONTIORAGROUPID              uniqueidentifier                 NULL,
    C_EFOP23517                       char(1)                          DEFAULT 'F' NOT NULL,
    C_TEREMID                         int                              NULL,
    C_FOGLALKOZASID                   int                              NULL,
    C_TANTARGYID                      int                              NULL,
    C_OSZTALYCSOPORTID                int                              NULL,
    C_TANARID                         int                              NULL,
    C_TANEVRENDJEID                   int                              NULL,
    C_OGORARENDID                     int                              NULL,
    C_ORATULAJDONOSID                 int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OrarendiOra PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANULOCSOPORT                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULOCSOPORT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BEJEGYZESIDOPONTJA              datetime                         NOT NULL,
    C_BELEPESDATUM                    datetime                         NULL,
    C_KILEPESDATUM                    datetime                         NULL,
    C_BEFOGADOINTEZMENY               nvarchar(255)                    NULL,
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_KILEPESROGZITESDATUM            datetime                         NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_JOGVISZONYTIPUSID               int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanuloCsoport PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_CSENGETESIREND                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CSENGETESIREND (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AKTIV                           char(1)                          DEFAULT 'T' NULL,
    C_NEV                             nvarchar(50)                     NOT NULL,
    C_MUKODESIHELYID                  int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_CsengetesiRend PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_HETNAPJATIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HETNAPJATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HetNapjaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANEVRENDJE                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANEVRENDJE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AKTIV                           char(1)                          DEFAULT 'T' NULL,
    C_DATUM                           datetime                         NOT NULL,
    C_HETIREND                        int                              NOT NULL,
    C_HETNAPJA                        int                              NULL,
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_NAPTIPUSA                       int                              NOT NULL,
    C_ORARENDINAP                     char(1)                          DEFAULT 'T' NULL,
    C_OSSZESCSOPORTRAVONATKOZIK       char(1)                          DEFAULT 'F' NULL,
    C_EGYEDINAP                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ELTERONAPDATUMA                 datetime                         NULL,
    C_ISURESORAREND                   char(1)                          DEFAULT 'F' NOT NULL,
    C_CSENGETESIRENDID                int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanevRendje PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_HETIRENDTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HETIRENDTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HetiRendTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_NAPTIPUS                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NAPTIPUS (
    ID                                int                              NOT NULL,
    C_ISSORSZAMOZANDO                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTANITASINAP                   char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTANORAI                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTANORANKIVULI                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ISLENEMKOTOTTMUNKAIDO           char(1)                          DEFAULT 'F' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_NapTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FOGLALKOZASTIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGLALKOZASTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FoglalkozasTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FOGLALKOZAS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FOGLALKOZAS (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_FOGLALKOZASTIPUSA               int                              NOT NULL,
    C_ORASZAM                         numeric(10,2)                    DEFAULT 0 NOT NULL,
    C_NEV                             nvarchar(771)                    NULL,
    C_ERTEKELESKELL                   char(1)                          DEFAULT 'F' NULL,
    C_MULASZTASKELL                   char(1)                          DEFAULT 'F' NULL,
    C_TANARFELVEHETI                  char(1)                          DEFAULT 'T' NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOSSZEVONTORA                  char(1)                          DEFAULT 'F' NOT NULL,
    C_ISNEMZETISEGI                   char(1)                          DEFAULT 'F' NOT NULL,
    C_TULORASZAM                      numeric(10,2)                    DEFAULT 0 NOT NULL,
    C_MEGBIZASIORASZAM                numeric(10,2)                    DEFAULT 0 NOT NULL,
    C_TANTARGYID                      int                              NULL,
    C_OSZTALYCSOPORTID                int                              NULL,
    C_TANARID                         int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Foglalkozas PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TARGYKATEGORIATIPUS                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TARGYKATEGORIATIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TargyKategoriaTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_EVFOLYAMTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_EVFOLYAMTIPUS (
    ID                                int                              NOT NULL,
    C_ALAPORASZAM                     numeric(10,2)                    DEFAULT 0 NOT NULL,
    C_MINIMUMORASZAM                  numeric(10,2)                    DEFAULT 0 NOT NULL,
    C_VISZONYITASILETSZAM             numeric(10,2)                    DEFAULT 0 NOT NULL,
    C_KOVETKEZOEVFOLYAMTIPUSID        int                              NULL,
    C_ISOSSZEVONT                     char(1)                          DEFAULT 'F' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EvfolyamTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANTARGY                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANTARGY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_GYAKORLATI                      char(1)                          DEFAULT 'F' NOT NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_ROVIDNEV                        nvarchar(20)                     NULL,
    C_TARGYKATEGORIA                  int                              NOT NULL,
    C_ALTANTARGYKENTNYOMTATVANYBAN    char(1)                          DEFAULT 'F' NOT NULL,
    C_NEVNYOMTATVANYBAN               nvarchar(255)                    NULL,
    C_TANORANKIVULI                   char(1)                          DEFAULT 'F' NOT NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_FOTARGYE                        char(1)                          DEFAULT 'T' NOT NULL,
    C_ANGOLNEV                        nvarchar(255)                    NULL,
    C_NEMETNEV                        nvarchar(255)                    NULL,
    C_FONTOSSAG                       numeric(10,2)                    NULL,
    C_ESLTANTARGYKATEGORIAID          int                              DEFAULT 7598 NOT NULL,
    C_MEGJEGYZES                      nvarchar(500)                    NULL,
    C_MUFAJTIPUSID                    int                              NULL,
    C_SORSZAM                         int                              DEFAULT 1000 NOT NULL,
    C_GYAKORLATIGENYESSEG             int                              NULL,
    C_ISAMITARGY                      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISEGYMITARGY                    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISFELNOTTOKTATASTARGY           char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKOLLEGIUMTARGY                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISNINCSBELOLEORA                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOSZTALYNAPLOBANEMLATSZIK      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOSZTALYORARENDBENEMLATSZIK    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOSZTALYZATTALERTEKELHETO      char(1)                          DEFAULT 'T' NOT NULL,
    C_ISTANULMANYIATLAGBANEMSZAMIT    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAZALEKOSANERTEKELHETO       char(1)                          DEFAULT 'T' NOT NULL,
    C_ISSZOVEGESENERTEKELHETO         char(1)                          DEFAULT 'T' NOT NULL,
    C_TANSZAKTIPUSID                  int                              NULL,
    C_ISMSZGTARGY                     char(1)                          DEFAULT 'F' NOT NULL,
    C_MUVESZETIAGID                   int                              NULL,
    C_DUALISKEPZOHELYADOSZAMA         nvarchar(20)                     NULL,
    C_DUALISKEPZOHELYNEVE             nvarchar(255)                    NULL,
    C_FOTARGYID                       int                              NULL,
    C_AMITANTARGYSABLONID             int                              NULL,
    C_SZERVEZETID                     int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Tantargy PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANTERV                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANTERV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_CSOPORTTIPUSA                   int                              NOT NULL,
    C_EVFOLYAMIG                      int                              NOT NULL,
    C_EVFOLYAMTOL                     int                              NOT NULL,
    C_KERETTANTERVREEPULO             char(1)                          DEFAULT 'T' NULL,
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_VEDETT                          char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKERETTANTERV                  char(1)                          DEFAULT 'F' NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Tanterv PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_OKTATASINEVELESIFELADAT                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OKTATASINEVELESIFELADAT (
    ID                                int                              NOT NULL,
    C_FELADATKATEGORIAID              int                              NOT NULL,
    C_ESLKOZEPESATLAG                 numeric(10,2)                    DEFAULT 3 NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OktatasiNevelesiFeladat PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ERTELMIFOGYATEKOSTIPUS                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ERTELMIFOGYATEKOSTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_ErtelmiFogyatekosTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_HALLASSERULTTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HALLASSERULTTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HallasserultTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_LATASSERULTTIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_LATASSERULTTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_LatasserultTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ETKEZESIKEDVEZMENYTIPUS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ETKEZESIKEDVEZMENYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EtkezesiKedvezmenyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_HATRANYOSHELYZETTIPUS                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HATRANYOSHELYZETTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_HatranyosHelyzetTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_VALLAS                                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_VALLAS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Vallas PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANEV                                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANEV (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AKTIV                           char(1)                          DEFAULT 'F' NULL,
    C_ELSOTANITASINAP                 datetime                         NULL,
    C_KEZDONAP                        datetime                         NULL,
    C_KOVETKEZO                       char(1)                          DEFAULT 'F' NULL,
    C_NEV                             nvarchar(20)                     NULL,
    C_SORSZAM                         int                              NULL,
    C_UTOLSONAP                       datetime                         NULL,
    C_UTOLSOTANITASINAP               datetime                         NULL,
    C_AKTIVALVA                       datetime                         NULL,
    C_ISKIVALASZTHATO                 char(1)                          DEFAULT 'T' NOT NULL,
    C_AKTIVALHATOSAGKEZDETE           datetime                         NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Tanev PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_OSZTALYCSOPORT                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OSZTALYCSOPORT (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_MEGJEGYZES                      nvarchar(500)                    NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_VEGZOSEVFOLYAM                  char(1)                          DEFAULT 'F' NOT NULL,
    C_EVFOLYAMTIPUSA                  int                              DEFAULT 1296 NOT NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_TERVEZETTLETSZAM                int                              NULL,
    C_KERESZTFELEVES                  char(1)                          DEFAULT 'F' NOT NULL,
    C_FELADATKATEGORIAID              int                              NULL,
    C_MUVESZETIAGID                   int                              NULL,
    C_ZENEMUVESZETIAGTIPUSID          int                              NULL,
    C_KEPZESIFORMA                    int                              NULL,
    C_ISGYOGYPEDAGOGIAILOGOPEDIAI     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTECHNIKAI                     char(1)                          DEFAULT 'F' NOT NULL,
    C_NAPLOSZAM                       nvarchar(50)                     NULL,
    C_TEREMID                         int                              NULL,
    C_FELADATELLATASIHELYID           int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OsztalyCsoport PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_OSZTALY                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_OSZTALY (
    ID                                int                              NOT NULL,
    C_OSZTALYNAPLOLEIRASA             nvarchar(max)                    NULL,
    C_OSZTALYNAPLOMEGNYITASA          datetime                         NULL,
    C_OSZTALYNAPLOZARASA              datetime                         NULL,
    C_AGAZAT                          int                              DEFAULT 5484 NULL,
    C_RESZSZAKKEPESITES               int                              DEFAULT 6108 NULL,
    C_SZAKKEPESITES                   int                              DEFAULT 5527 NULL,
    C_SZAKMACSOPORT                   int                              DEFAULT 6084 NULL,
    C_GIMNAZIUMIEVFOLYAMTIPUSID       int                              NULL,
    C_KETTANNYELVU                    char(1)                          DEFAULT 'F' NOT NULL,
    C_NEMZETISEGI                     char(1)                          DEFAULT 'F' NOT NULL,
    C_NYELVIELOKESZITO                char(1)                          DEFAULT 'F' NOT NULL,
    C_SPORT                           char(1)                          DEFAULT 'F' NOT NULL,
    C_AJTEHETTSEGGONDOZOPROGRAM       char(1)                          DEFAULT 'F' NOT NULL,
    C_AJPROGRAM                       char(1)                          DEFAULT 'F' NOT NULL,
    C_VEGYESEVFOLYAMU                 char(1)                          DEFAULT 'F' NOT NULL,
    C_VEGYESSZAKKEPZESU               char(1)                          DEFAULT 'F' NOT NULL,
    C_SPECIALISJELLEMZO               nvarchar(4000)                   NULL,
    C_VEGYESEVFOLYAMUTANTERV          nvarchar(1000)                   NULL,
    C_OSZTALYPENZBANKSZAMLASZAMKED    nvarchar(1000)                   NULL,
    C_OSZTALYPENZBANKSZAMLASZAMA      nvarchar(26)                     NULL,
    C_VPOSENGEDELYEZETT               char(1)                          DEFAULT 'F' NOT NULL,
    C_ARANYJANOSPROGRAMTIPUSID        int                              NULL,
    C_JOGVISZONYTIPUSID               int                              NULL,
    C_AGAZATUJSZKTTIPUSID             int                              DEFAULT 7920 NULL,
    C_SZAKMAIRANYTIPUSID              int                              DEFAULT 8122 NULL,
    C_SZAKMATIPUSID                   int                              DEFAULT 7946 NULL,
    C_SZAKIRANYNKTTIPUSID             int                              DEFAULT 8493 NULL,
    C_SZAKKEPESITESNKTTIPUSID         int                              DEFAULT 8464 NULL,
    C_TANULMANYITERULETNKTTIPUSID     int                              DEFAULT 8459 NULL,
    C_MUFAJTIPUSID                    int                              NULL,
    C_TANSZAKTIPUSID                  int                              NULL,
    C_OSZTALYFONOKID                  int                              NULL,
    C_OFOHELYETTESID                  int                              NULL,
    C_TANTERVID                       int                              NULL,
    C_SZMKKEPVISELOHELYETTESID        int                              NULL,
    C_SZMKKEPVISELOID                 int                              NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Osztaly PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_TANTERVIJELLEG                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANTERVIJELLEG (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TanterviJelleg PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TESTNEVELESTIPUS                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TESTNEVELESTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TestnevelesTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ESZKOZJELLEG                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESZKOZJELLEG (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EszkozJelleg PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_CSOPORT                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CSOPORT (
    ID                                int                              NOT NULL,
    C_TIPUSA                          int                              NULL,
    C_CSOPORTNAPLOLEIRAS              nvarchar(max)                    NULL,
    C_CSOPORTNAPLOMEGNYITASA          datetime                         NULL,
    C_CSOPORTNAPLOZARASA              datetime                         NULL,
    C_ISAUTOEGYENICSOPORT             char(1)                          DEFAULT 'F' NOT NULL,
    C_ISVALTOZOOSSZETETELU            char(1)                          DEFAULT 'F' NOT NULL,
    C_DUALISKEPZOHELYADOSZAMA         nvarchar(20)                     NULL,
    C_DUALISKEPZOHELYNEVE             nvarchar(255)                    NULL,
    C_CSOPORTVEZETOID                 int                              NULL,
    C_OSZTALYBONTASID                 int                              NULL,
    C_SZERVEZETID                     int                              NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Csoport PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ESZKOZCEL                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESZKOZCEL (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EszkozCel PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MERTEKEGYSEGTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MERTEKEGYSEGTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MertekegysegTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_INTEZMENYADATOK                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_INTEZMENYADATOK (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_IGAZGATONEVE                    nvarchar(255)                    NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_OMKOD                           nvarchar(20)                     NOT NULL,
    C_TELEFONSZAM                     nvarchar(20)                     NULL,
    C_EMAILCIM                        nvarchar(255)                    NULL,
    C_IRANYITOSZAM                    nvarchar(20)                     NOT NULL,
    C_VAROS                           nvarchar(255)                    NOT NULL,
    C_ROVIDNEV                        nvarchar(255)                    NULL,
    C_ADMINEMAILCIM                   nvarchar(255)                    NULL,
    C_KRETATIPUS                      int                              NOT NULL,
    C_ENGEDELYEZETTALLASHELYEK        numeric(10,2)                    NULL,
    C_INTEZMENYHONLAPJA               nvarchar(300)                    NULL,
    C_AJTO                            nvarchar(30)                     NULL,
    C_EMELET                          nvarchar(40)                     NULL,
    C_HAZSZAM                         nvarchar(30)                     NULL,
    C_KOZTERULETNEV                   nvarchar(40)                     NULL,
    C_DOKUMENTUMFEJLEC                nvarchar(max)                    NULL,
    C_DOKUMENTUMLABLEC                nvarchar(max)                    NULL,
    C_DOKUMENTUMFEJLECHTML            nvarchar(max)                    NULL,
    C_DOKUMENTUMLABLECHTML            nvarchar(max)                    NULL,
    C_ISDOKUMENTUMFEJLECMEGJELENIT    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDOKUMENTUMLABLECMEGJELENIT    char(1)                          DEFAULT 'F' NOT NULL,
    C_SAPAZONOSITO                    nvarchar(100)                    NULL,
    C_ALAPKRETA                       char(1)                          DEFAULT 'F' NOT NULL,
    C_KRETAESL                        char(1)                          DEFAULT 'F' NOT NULL,
    C_KRETAEUGYINTEZES                char(1)                          DEFAULT 'F' NOT NULL,
    C_SNINEVELESIFORMATIPUSID         int                              NOT NULL,
    C_ISCSAKLEPKEZELO                 char(1)                          DEFAULT 'F' NOT NULL,
    C_SZERZODESESFENNTARTOAZONOSIT    nvarchar(200)                    NULL,
    C_SZERZODESESFENNTARTONEV         nvarchar(200)                    NULL,
    C_KOZTERULETJELLEGENEV            nvarchar(50)                     NULL,
    C_ISBAISTATUSZAKTIV               char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZIRINTEZMENY                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAKKEPZO                     char(1)                          DEFAULT 'F' NOT NULL,
    C_JUTTATASHATARNAP                datetime                         NULL,
    C_DKTTANULOURL                    nvarchar(255)                    NULL,
    C_ISDKTAKTIV                      char(1)                          DEFAULT 'F' NOT NULL,
    C_DKTTANARURL                     nvarchar(255)                    NULL,
    C_ISAKTIVPROJEKTJELENTKEZES       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAKKEPZOJUTTATAS             char(1)                          DEFAULT 'F' NOT NULL,
    C_BANKSZAMLASZAM                  nvarchar(24)                     NULL,
    C_TANEVID                         int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IntezmenyAdatok PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FENNTARTOTIPUS                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FENNTARTOTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FenntartoTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_CSOPORTTIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CSOPORTTIPUS (
    ID                                int                              NOT NULL,
    C_ISTANORAICELU                   char(1)                          DEFAULT 'F' NOT NULL,
    C_ORAPERC                         int                              DEFAULT 45 NULL,
    C_ISMUVESZETI                     char(1)                          DEFAULT 'F' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_CsoportTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ROKONSAGIFOK                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ROKONSAGIFOK (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_RokonsagiFok PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TANULO                                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TANULO (
    ID                                int                              NOT NULL,
    C_ALLAMIGONDOZOTT                 char(1)                          DEFAULT 'F' NOT NULL,
    C_BANKSZAMLASZAM                  nvarchar(24)                     NULL,
    C_BEILLESZKEDESINEHEZSEG          char(1)                          DEFAULT 'F' NOT NULL,
    C_BEIRASINAPLOSORSZAM             nvarchar(50)                     NULL,
    C_BEJARO                          char(1)                          DEFAULT 'F' NOT NULL,
    C_DIAKIGAZOLVANYKELTE             datetime                         NULL,
    C_DIAKIGAZOLVANYSZAM              nvarchar(255)                    NULL,
    C_ELOZOINTEZMENY                  nvarchar(255)                    NULL,
    C_EVISMETLO                       char(1)                          DEFAULT 'F' NOT NULL,
    C_INGYENESTANKONVYELLATASA        int                              NULL,
    C_JOGVISZONYATSZUNETELTETO        char(1)                          DEFAULT 'F' NOT NULL,
    C_MAGANTANULO                     char(1)                          DEFAULT 'F' NOT NULL,
    C_MAGANTANULOSAGANAKOKA           int                              NULL,
    C_MAGANTANULOSAGKEZDETE           datetime                         NULL,
    C_NAPLOSORSZAM                    int                              NULL,
    C_POLGARISZERZODESES              char(1)                          DEFAULT 'F' NOT NULL,
    C_SZAKMAIGYAKORLATON              char(1)                          DEFAULT 'F' NOT NULL,
    C_SZOCIALISTAMOGATAS              char(1)                          DEFAULT 'F' NOT NULL,
    C_TANDIJATFIZETO                  char(1)                          DEFAULT 'F' NOT NULL,
    C_TANKOTELEZETT                   char(1)                          DEFAULT 'T' NOT NULL,
    C_TANKOTELEZETTSEGVEGE            datetime                         NULL,
    C_TANULOSZERZODESES               char(1)                          DEFAULT 'F' NOT NULL,
    C_TERITESIDIJATFIZETO             char(1)                          DEFAULT 'F' NOT NULL,
    C_TESTNEVELESTIPUSA               int                              DEFAULT 1091 NOT NULL,
    C_VENDEG                          char(1)                          DEFAULT 'F' NOT NULL,
    C_BTMPROBLEMAS                    char(1)                          DEFAULT 'F' NOT NULL,
    C_DIAKSPORTKOROS                  char(1)                          DEFAULT 'F' NOT NULL,
    C_EGYHAZKOZOSSEGE                 nvarchar(255)                    NULL,
    C_ETKEZESIKEDVEZMENY              int                              NULL,
    C_HALMOZOTTANFOGYATEKOS           char(1)                          DEFAULT 'F' NOT NULL,
    C_HATRANYOSHELYZETU               int                              DEFAULT 1121 NOT NULL,
    C_KOLLEGIUMIELLATASOS             char(1)                          DEFAULT 'F' NOT NULL,
    C_RENDSZERESGYERMEKVEDELMIKEDV    nvarchar(255)                    NULL,
    C_SAJATOSNEVELESU                 char(1)                          DEFAULT 'F' NOT NULL,
    C_SPORTAG                         nvarchar(255)                    NULL,
    C_SPORTEDZONEVE                   nvarchar(1000)                   NULL,
    C_SPORTKLUB                       nvarchar(100)                    NULL,
    C_SZAKKEPESITESSZAMA              int                              NULL,
    C_TANULOIJOGVISZONYOSELTARTOTT    int                              NULL,
    C_TARTOSGYOGYKEZELESSZAMA         nvarchar(255)                    NULL,
    C_TOBBGYERMEKIGAZOLASSZAMA        nvarchar(255)                    NULL,
    C_VALLASA                         int                              NULL,
    C_VESZELYEZTETETT                 char(1)                          DEFAULT 'F' NOT NULL,
    C_JOGVISZONYVARHATOBEFEJEZESE     datetime                         NULL,
    C_BEILLESZKEDESIPROBLEMAVALKUZ    char(1)                          DEFAULT 'F' NOT NULL,
    C_BESZEDFOGYATEKOSOKMANYSZAM      nvarchar(100)                    NULL,
    C_BNOKOD                          nvarchar(100)                    NULL,
    C_BTMHATAROZATOKMANYSZAM          nvarchar(255)                    NULL,
    C_BTMHATAROZATTARTALMA            nvarchar(1000)                   NULL,
    C_BTMKIALLITOINTEZMENY            nvarchar(255)                    NULL,
    C_BTMKONTROLLIDOPONT              datetime                         NULL,
    C_BTMLETSZAMSULY                  numeric(10,2)                    DEFAULT 1 NOT NULL,
    C_BTMOKMANYERVENYESSEGKEZDETE     datetime                         NULL,
    C_BTMOKMANYERVENYESSEGVEGE        datetime                         NULL,
    C_DISZGRAFIAOKMANYSZAM            nvarchar(100)                    NULL,
    C_DISZKALKULIAOKMANYSZAM          nvarchar(255)                    NULL,
    C_DISZLEXIAOKMANYSZAM             nvarchar(255)                    NULL,
    C_ERTELMIFOGYATEKOS               int                              NULL,
    C_ERTELMIFOGYATEKOSOKMANYSZAM     nvarchar(30)                     NULL,
    C_FEJLESZTESREKIJELOLT            nvarchar(255)                    NULL,
    C_FEJLESZTOFOGLALKOZAS            nvarchar(255)                    NULL,
    C_FEJLESZTOFOGLALKOZASORASZAM     numeric(10,2)                    NULL,
    C_HALLASSERULT                    int                              NULL,
    C_HALLASSERULTOKMANYSZAM          nvarchar(100)                    NULL,
    C_LATASSERULT                     int                              NULL,
    C_LATASSERULTOKMANYSZAM           nvarchar(100)                    NULL,
    C_MAGATARTASIPROBLEMAVALKUZD      char(1)                          DEFAULT 'F' NOT NULL,
    C_MEGISMERONEMORGANIKUSOKMANYS    nvarchar(100)                    NULL,
    C_MEGISMEROORGANIKUSOKMANYSZAM    nvarchar(100)                    NULL,
    C_MOZGASSERULTOKMANYSZAM          nvarchar(255)                    NULL,
    C_SNIKIALLITOINTEZMENY            nvarchar(255)                    NULL,
    C_SNIKONTROLLIDOPONT              datetime                         NULL,
    C_SNILETSZAMSULY                  int                              DEFAULT 1 NOT NULL,
    C_SNIMEGHATAROZAS                 nvarchar(255)                    NULL,
    C_SNIOKMANYERVENYESSEGKEZDETE     datetime                         NULL,
    C_SNIOKMANYERVENYESSEGVEGE        datetime                         NULL,
    C_TANULASIPROBLEMADISZGRAFIA      char(1)                          DEFAULT 'F' NOT NULL,
    C_TANULASIPROBLEMAVALKUZD         char(1)                          DEFAULT 'F' NOT NULL,
    C_TANULASIPROBLEMAVALKUZDDISZK    char(1)                          DEFAULT 'F' NOT NULL,
    C_TANULASIPROBLEMAVALKUZDDISZL    char(1)                          DEFAULT 'F' NOT NULL,
    C_VISELKEDESNEMORGANIKUSOKMANY    nvarchar(100)                    NULL,
    C_VISELKEDESORGANIKUSOKMANYSZA    nvarchar(100)                    NULL,
    C_ELSOINTEZMENYOMKOD              nvarchar(12)                     NULL,
    C_EVISMETLOTANTARGYAK             nvarchar(1000)                   NULL,
    C_KOZEPFOKUOKTATASBATIZENHATOD    char(1)                          DEFAULT 'F' NOT NULL,
    C_MENEDEKJOGGALRENDELKEZO         char(1)                          DEFAULT 'F' NOT NULL,
    C_AGAZAT                          int                              NULL,
    C_RESZSZAKKEPESITES               int                              NULL,
    C_SZAKKEPESITES                   int                              NULL,
    C_SZAKMACSOPORT                   int                              NULL,
    C_EGYEBDONTO                      char(1)                          DEFAULT 'F' NOT NULL,
    C_MEGALLAPODASOS                  char(1)                          DEFAULT 'F' NOT NULL,
    C_OSZTV                           char(1)                          DEFAULT 'F' NOT NULL,
    C_SZETVAGAZAT                     char(1)                          DEFAULT 'F' NOT NULL,
    C_SZINTVIZSGA                     numeric(10,2)                    NULL,
    C_SZKTV                           char(1)                          DEFAULT 'F' NOT NULL,
    C_TECHNIKUSIEVFOLYAM              char(1)                          DEFAULT 'F' NOT NULL,
    C_EGYUTTMUKODESES                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKOLAIKERETEKKOZOTT            char(1)                          DEFAULT 'F' NOT NULL,
    C_TANULOEVFOLYAMTIPUS             int                              NULL,
    C_TORZSLAPSZAM                    nvarchar(500)                    NULL,
    C_ISSZAKMAIGYAKORLATHIANY         char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKIFIRIMPORTALT                char(1)                          DEFAULT 'F' NOT NULL,
    C_TANTERVIJELLEMZOID              int                              NULL,
    C_BANKSZAMLATULAJDONOSTIPUSID     int                              NULL,
    C_BANKSZAMLATULAJNEVE             nvarchar(510)                    NULL,
    C_KEZIATLAG                       numeric(10,2)                    NULL,
    C_SZAMITOTTATLAG                  numeric(10,2)                    NULL,
    C_ISDUALISKEPZESBEN               char(1)                          DEFAULT 'F' NOT NULL,
    C_ISMASODIKTOBBSZAKMA             char(1)                          DEFAULT 'F' NOT NULL,
    C_JOGVISZONYTIPUSID               int                              NULL,
    C_AGAZATUJSZKTTIPUSID             int                              NULL,
    C_SZAKMAIRANYTIPUSID              int                              NULL,
    C_SZAKMATIPUSID                   int                              NULL,
    C_ISERETTSEGIEREDMENYATADHATO     char(1)                          DEFAULT 'F' NOT NULL,
    C_AGAZATIALAPVIZSGAEREDMENYE      numeric(10,2)                    NULL,
    C_DUALISKEPZOHELYADOSZAMA         nvarchar(20)                     NULL,
    C_DUALISKEPZOHELYNEVE             nvarchar(255)                    NULL,
    C_ISKULDHETOERETTSEGISZRNEK       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKULDHETOKOZEPFELVETELISZRN    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKULDHETOMERESISZRNEK          char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOKLEVELESTECHNIKUSKIMENET     char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAKKEPZESIMUNKASZERZODESS    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDIAKIGAZOLVANYATADHATOSZRN    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISBESZAMITASOS                  char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOSZTONDIJBOLKIZARVA           char(1)                          DEFAULT 'F' NOT NULL,
    C_SZAKIRANYNKTTIPUSID             int                              NULL,
    C_SZAKKEPESITESNKTTIPUSID         int                              NULL,
    C_TANULMANYITERULETNKTTIPUSID     int                              NULL,
    C_ISMULASZTASMIATTKIZART          char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSIKERESAGAZATIVIZSGA          char(1)                          DEFAULT 'F' NOT NULL,
    C_ISATLAGSZAKKEPZESI              char(1)                          DEFAULT 'T' NOT NULL,
    C_ISBESZAMITASOSFIXSZAZALEK       char(1)                          DEFAULT 'T' NOT NULL,
    C_MAGANTANULOSAGVEGE              datetime                         NULL,
    C_AGAZATIALAPVIZSGAEREDMENYESZ    int                              NULL,
    C_OKIRATSZAM                      nvarchar(256)                    NULL,
    C_TARTOZKODASJOGCIMTIPUSID        int                              NULL,
    C_ISAPACZAIIGENYLO                char(1)                          DEFAULT 'F' NOT NULL,
    C_MUFAJTIPUSID                    int                              NULL,
    C_MUVESZETIAGID                   int                              NULL,
    C_TANSZAKTIPUSID                  int                              NULL,
    C_NEMZETKOZIBIZTOSITASIOKMSZAM    nvarchar(30)                     NULL,
    C_TARTJOGOKMANYSZAM               nvarchar(21)                     NULL,
    C_TARTJOGOKMANYTIPUSID            int                              NULL,
    C_IS9KOZUL8ELOZOTANEVBENVEGEZT    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISEXTERNATUSIELLATASBAN         char(1)                          DEFAULT 'F' NOT NULL,
    C_ISNAPKOZIOTTHONIELLATASBAN      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISAPACZAISZERZODESES            char(1)                          DEFAULT 'F' NOT NULL,
    C_ISEGESZNAPOSISKOKTRESZESUL      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKIEMELTENTEHETSEGES           char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZABOKYADOLFSZAKKEPODRESZE    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAMITOGEPETOKTCELRAHASZNA    char(1)                          DEFAULT 'T' NOT NULL,
    C_ISINGYENESKEPZES                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISRENDSZERESGYERMEKVEDELMI      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOTTHONIELLATAS                char(1)                          DEFAULT 'F' NOT NULL,
    C_TANTERVID                       int                              NULL,
    C_FELVETELTANEVEID                int                              NOT NULL,
    C_MENTORID                        int                              NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Tanulo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_GONDVISELO                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_GONDVISELO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AKTIV                           char(1)                          DEFAULT 'T' NOT NULL,
    C_GONDVISELESKEZDETE              datetime                         NULL,
    C_GONDVISELESVEGE                 datetime                         NULL,
    C_GYERMEKETEGYEDULNEVELO          char(1)                          DEFAULT 'F' NOT NULL,
    C_NEV                             nvarchar(200)                    NOT NULL,
    C_NYUGDIJAS                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ROKONSAGFOKA                    int                              NOT NULL,
    C_ISEMAILERTESITES                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTORVENYESKEPVISELO            char(1)                          DEFAULT 'F' NOT NULL,
    C_ISCSOKKENTETTGONDVISELO         char(1)                          DEFAULT 'F' NOT NULL,
    C_EGYEDIAZONOSITO                 nvarchar(36)                     DEFAULT '00000000-0000-0000-0000-000000000000' NOT NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_IDPEGYEDIAZONOSITO              uniqueidentifier                 DEFAULT '00000000-0000-0000-0000-000000000000' NOT NULL,
    C_COVIDBEJELENTESDATUMA           datetime                         NULL,
    C_ISCOVIDBEJELENTO                char(1)                          DEFAULT 'F' NOT NULL,
    C_ANYJAUTONEV                     nvarchar(255)                    NULL,
    C_ANYJAVEZETEKNEV                 nvarchar(255)                    NULL,
    C_ELOTAG                          nvarchar(20)                     NULL,
    C_SZULETESIDATUM                  datetime                         NULL,
    C_SZULETESIHELY                   nvarchar(255)                    NULL,
    C_SZULETESIUTONEV                 nvarchar(255)                    NULL,
    C_SZULETESIVEZETEKNEV             nvarchar(255)                    NULL,
    C_UTONEV                          nvarchar(255)                    NULL,
    C_VEZETEKNEV                      nvarchar(255)                    NULL,
    C_FELTARELFOGADASDATUMA           datetime                         NULL,
    C_ISFELTARELFOGADOTT              char(1)                          DEFAULT 'F' NOT NULL,
    C_TANULOID                        int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Gondviselo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MUNKAKORTIPUS                                                        */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUNKAKORTIPUS (
    ID                                int                              NOT NULL,
    C_ALKALMAZOTTMUNKAKORTIPUSID      int                              NULL,
    C_ISSZIRSTATOKTATO                char(1)                          DEFAULT 'F' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MunkakorTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MUKODESIHELY                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUKODESIHELY (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_EMAILCIM                        nvarchar(255)                    NULL,
    C_FAX                             nvarchar(50)                     NULL,
    C_IRANYITOSZAM                    nvarchar(20)                     NULL,
    C_TELEFONSZAM                     nvarchar(50)                     NULL,
    C_VAROS                           nvarchar(255)                    NULL,
    C_VEZETONEVE                      nvarchar(255)                    NULL,
    C_TAGINTEZMENY                    char(1)                          DEFAULT 'F' NULL,
    C_TAGINTEZMENYIKOD                nvarchar(50)                     NULL,
    C_SZEKHELY                        char(1)                          DEFAULT 'F' NULL,
    C_AJTO                            nvarchar(30)                     NULL,
    C_EMELET                          nvarchar(40)                     NULL,
    C_HAZSZAM                         nvarchar(30)                     NULL,
    C_KOZTERULETNEV                   nvarchar(40)                     NULL,
    C_MUKODESIHELYAZONOSITO           nvarchar(50)                     NULL,
    C_MUKODESIHELYTIPUSA              int                              NULL,
    C_FUNKCIOTERULET                  nvarchar(50)                     NULL,
    C_KOZTERULETJELLEGENEV            nvarchar(50)                     NULL,
    C_INTEZMENYADATOKID               int                              NOT NULL,
    C_TELEPHELYANYAINTEZMENYID        int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MukodesiHely PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ALKALMAZOTT                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ALKALMAZOTT (
    ID                                int                              NOT NULL,
    C_ALLANDOHELYETTESITESRE          char(1)                          DEFAULT 'F' NULL,
    C_FOALLAS                         char(1)                          DEFAULT 'T' NOT NULL,
    C_TANARIAUTOMATAMEGAJANLASENGE    char(1)                          NULL,
    C_TANARIERTEKELESHATARERTEK       int                              NULL,
    C_DIAKOLIMPIA                     char(1)                          DEFAULT 'F' NOT NULL,
    C_SZAKERTOIVIZSGAELNOKI           char(1)                          DEFAULT 'F' NOT NULL,
    C_SZAKVIZSGA                      char(1)                          DEFAULT 'F' NOT NULL,
    C_TOVABBKEPZES                    char(1)                          DEFAULT 'F' NOT NULL,
    C_ORAKEGYHUZAMBAN                 char(1)                          NULL,
    C_KOZOSSEGISZOLGALATKEZELO        char(1)                          DEFAULT 'F' NOT NULL,
    C_ELFOGADOTTSZANDEKNYILATKOZAT    char(1)                          DEFAULT 'F' NOT NULL,
    C_KKKEPESITESID                   int                              NULL,
    C_SZTSZKOD                        nvarchar(8)                      NULL,
    C_KOTELEZOEVESSZABADSAGKERET      int                              DEFAULT 0 NOT NULL,
    C_A30KREDITESKURZUSOKLEVELSZAM    nvarchar(30)                     NULL,
    C_LEPKEZELO                       char(1)                          DEFAULT 'F' NOT NULL,
    C_ISHRKEZELO                      char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKULDHETOPEDMINOSITESSZRNEK    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISDUALISKEPZOHELYIOKTATO        char(1)                          DEFAULT 'F' NOT NULL,
    C_ISSZAKOKTATASERTFELELOS         char(1)                          DEFAULT 'F' NOT NULL,
    C_ISKOZPONTILAGSZINKRONIZALT      char(1)                          DEFAULT 'F' NOT NULL,
    C_FELTARELFOGADASDATUMA           datetime                         NULL,
    C_ISFELTARELFOGADOTT              char(1)                          DEFAULT 'F' NOT NULL,
    C_HASEFOPESZKOZ                   char(1)                          DEFAULT 'F' NOT NULL,
    C_SZTSZKOD2                       nvarchar(16)                     NULL,
    C_BANKSZAMLASZAM                  nvarchar(24)                     NULL,
    C_BANKSZAMLATULAJDONOSTIPUS       int                              NULL,
    C_BANKSZAMLATULAJNEVE             nvarchar(510)                    NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Alkalmazott PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ANYANYELV                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ANYANYELV (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Anyanyelv PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_IGAZOLVANYTIPUS                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_IGAZOLVANYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IgazolvanyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MUNKAVISZONYTIPUS                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUNKAVISZONYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MunkaviszonyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TEREM                                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TEREM (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_AKTIV                           char(1)                          DEFAULT 'T' NOT NULL,
    C_JELLEG                          int                              NOT NULL,
    C_KAPACITAS                       int                              NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_TERULET                         int                              NULL,
    C_TOBBORATLEHETTARTANI            char(1)                          DEFAULT 'F' NOT NULL,
    C_VIZSGAKAPACITAS                 int                              NULL,
    C_WIFILEFEDETT                    char(1)                          DEFAULT 'F' NOT NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_AR                              int                              NULL,
    C_BERBEADHATO                     char(1)                          DEFAULT 'F' NOT NULL,
    C_FOGLALHATOIDOSZAKKEZDETE        datetime                         NULL,
    C_FOGLALHATOIDOSZAKVEGE           datetime                         NULL,
    C_LEIRAS                          nvarchar(max)                    NULL,
    C_MEGJEGYZES                      nvarchar(500)                    NULL,
    C_EGYEDIAZONOSITO                 uniqueidentifier                 NULL,
    C_EMELTAR                         int                              NULL,
    C_EMELTARKEZDETEORAPERC           datetime                         NULL,
    C_TULAJDONTIPUSID                 int                              NULL,
    C_ISINTERAKTTABLAVALMUNKAALLOM    char(1)                          DEFAULT 'F' NOT NULL,
    C_ISINTERNETKAPCSOLATELERHETO     char(1)                          DEFAULT 'F' NOT NULL,
    C_OKTCELRAHASZNALTSZAMITOGEPEK    int                              NULL,
    C_PEDAGOGUSHOZZAFERHINTERNETES    int                              NULL,
    C_TANULOKSZAMARAHOZZAFERHINTER    int                              NULL,
    C_DUALISKEPZOHELYADOSZAMA         nvarchar(20)                     NULL,
    C_DUALISKEPZOHELYNEVE             nvarchar(255)                    NULL,
    C_DUALISHELYSZINTIPUSID           int                              NULL,
    C_MUKODESIHELYID                  int                              NULL,
    C_TEREMFELELOSID                  int                              NULL,
    C_SZERVEZETID                     int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Terem PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_ESZKOZTIPUS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESZKOZTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EszkozTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ESZKOZKATEGORIA                                                      */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESZKOZKATEGORIA (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EszkozKategoria PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ESZKOZ                                                               */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESZKOZ (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_BERELT                          char(1)                          NULL,
    C_BESZERZESDATUM                  datetime                         NULL,
    C_BESZERZESIAR                    int                              NULL,
    C_DARABSZAM                       int                              NULL,
    C_FOKONYVISZAM                    nvarchar(255)                    NULL,
    C_GYARISZAM                       nvarchar(255)                    NULL,
    C_GYARTASIEV                      int                              NULL,
    C_HALOZATIKAPCSOLAT               char(1)                          NULL,
    C_HORDOZHATO                      char(1)                          NULL,
    C_INTERNETKAPCSOLAT               char(1)                          NULL,
    C_KATEGORIA                       int                              NULL,
    C_LELTARISZAM                     nvarchar(200)                    NULL,
    C_MEGJEGYZES                      nvarchar(255)                    NULL,
    C_MULTIMEDIAS                     char(1)                          NULL,
    C_NEV                             nvarchar(255)                    NOT NULL,
    C_PEDAGOGUSHOZZAFERHET            char(1)                          NULL,
    C_SZALLITO                        nvarchar(255)                    NULL,
    C_TANULOHOZZAFERHET               char(1)                          NULL,
    C_TARTOZEK                        char(1)                          DEFAULT 'F' NULL,
    C_TARTOZEKHIVATKOZAS              nvarchar(255)                    NULL,
    C_TIPUS                           int                              NULL,
    C_CELJA                           int                              NULL,
    C_JELLEGE                         int                              NULL,
    C_MENNYISEGIEGYSEG                int                              NULL,
    C_VONALKOD                        nvarchar(128)                    NULL,
    C_NEMMUKODIK                      char(1)                          DEFAULT 'F' NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_PROJEKT                         nvarchar(1000)                   NULL,
    C_TEREMID                         int                              NOT NULL,
    C_FELELOSID                       int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Eszkoz PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_INGYENESTANKONYVELLATAS                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_INGYENESTANKONYVELLATAS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_IngyenesTankonyvEllatas PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TEREMTIPUS                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TEREMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TeremTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MAGANTANULOSAGOKA                                                    */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MAGANTANULOSAGOKA (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MagantanulosagOka PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FELHASZNALOBELEPES                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FELHASZNALOBELEPES (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_KOTELEZOVALTOZTATNI             char(1)                          DEFAULT 'T' NULL,
    C_MEGHIUSULTBELEPESEK             int                              NULL,
    C_UTOLSOBELEPES                   datetime                         NULL,
    C_JELSZO                          nvarchar(64)                     NULL,
    C_JELSZOVALTOZTATASIDEJE          datetime                         NULL,
    C_SO                              nvarchar(64)                     NULL,
    C_BEJELENTKEZESINEV               nvarchar(255)                    NOT NULL,
    C_NEPTUNNAPLOJELSZO               nvarchar(64)                     NULL,
    C_ELFOGADOTTGDPRNYILATKOZAT       char(1)                          DEFAULT 'F' NOT NULL,
    C_GDPRELFOGADASDATUMA             datetime                         NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_UTOLSOBELEPESMOBIL              datetime                         NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FelhasznaloBelepes PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_LOGEVENTTYPE                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_LOGEVENTTYPE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DELETABLE                       char(1)                          NULL,
    C_DISPLAYNAME                     nvarchar(200)                    NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_LogEventType PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_LOG                                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_LOG (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DETAILS                         nvarchar(max)                    NULL,
    C_SERVER                          nvarchar(36)                     NULL,
    C_SESSIONID                       nvarchar(36)                     NULL,
    C_TIMESTAMP                       datetime                         NULL,
    C_GENERATEDID                     uniqueidentifier                 NULL,
    C_HTTPREQUEST                     nvarchar(max)                    NULL,
    C_LEVELID                         int                              NOT NULL,
    C_EVENTTYPEID                     int                              NOT NULL,
    C_INTEZMENYID                     int                              NULL,
    C_TANEVID                         int                              NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Log PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_LOGLEVELTYPE                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_LOGLEVELTYPE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_DISPLAYNAME                     nvarchar(200)                    NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_LogLevelType PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_MEGYE                                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MEGYE (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Megye PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_FELHASZNALOBELEPESTORTENET                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FELHASZNALOBELEPESTORTENET (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_SESSIONID                       nvarchar(36)                     NULL,
    C_SERVERNAME                      nvarchar(50)                     NULL,
    C_USERIP                          nvarchar(15)                     NULL,
    C_LOGINDATE                       datetime                         NULL,
    C_LASTACTIVITY                    datetime                         NULL,
    C_GUID                            nvarchar(36)                     NULL,
    C_IDP                             char(1)                          DEFAULT 'F' NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_INTEZMENYID                     int                              NULL,
    C_TANEVID                         int                              NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_FelhasznaloBelepesTortenet PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_HONAPOK                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_HONAPOK (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Honapok PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DIAKIGAZOLVANYIGENYTIPUS                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DIAKIGAZOLVANYIGENYTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DiakigazolvanyIgenyTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_KOZTERULETJELLEG                                                     */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_KOZTERULETJELLEG (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_KozteruletJelleg PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_USERPROFILE                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_USERPROFILE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_PROFILE                         nvarchar(max)                    NULL,
    C_ISPOPUPMEGJELENITES             char(1)                          DEFAULT 'F' NOT NULL,
    C_OSSZFELTOLTHETOFAJLKB           int                              DEFAULT 15360 NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_UserProfile PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_DIAKIGAZOLVANYIGENYSTATUSZ                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DIAKIGAZOLVANYIGENYSTATUSZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DiakigazolvanyIgenyStatusz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_MUNKAVISZONYJELLEGE                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_MUNKAVISZONYJELLEGE (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_MunkaviszonyJellege PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ORSZAGTIPUS                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ORSZAGTIPUS (
    ID                                int                              NOT NULL,
    C_KOD2                            nvarchar(2)                      NULL,
    C_OECDKOD                         int                              NULL,
    C_ISOKOD                          nvarchar(3)                      DEFAULT 'ISO' NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_OrszagTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ESEMENYSTATUSZ                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ESEMENYSTATUSZ (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EsemenyStatusz PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_EMAILTIPUS                                                           */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_EMAILTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_EmailTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_TELEFONTIPUS                                                         */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TELEFONTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_TelefonTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_ALLAMPOLGARSAG                                                       */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_ALLAMPOLGARSAG (
    ID                                int                              NOT NULL,
    C_KOD2                            nvarchar(2)                      NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Allampolgarsag PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_CIMTIPUS                                                             */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CIMTIPUS (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_CimTipus PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_NEM                                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_NEM (
    ID                                int                              NOT NULL,
    C_ALINTEZMENYID                   int                              NOT NULL,
    C_ALTANEVID                       int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Nem PRIMARY KEY (ID, C_ALINTEZMENYID, C_ALTANEVID) 
)
GO
/*============================================================================*/
/* Table : T_DICTIONARYITEMBASE                                                   */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_DICTIONARYITEMBASE (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_VALUE                           int                              NULL,
    C_NAME                            nvarchar(250)                    NOT NULL,
    C_NAME_1                          nvarchar(250)                    NULL,
    C_NAME_2                          nvarchar(250)                    NULL,
    C_NAME_3                          nvarchar(250)                    NULL,
    C_NAME_4                          nvarchar(250)                    NULL,
    C_VISIBLE                         char(1)                          DEFAULT 'T' NOT NULL,
    C_CODE                            nvarchar(20)                     NULL,
    C_TYPE                            nvarchar(32)                     NOT NULL,
    C_PROTECTED                       char(1)                          DEFAULT 'T' NOT NULL,
    C_COLOR                           nvarchar(6)                      NULL,
    C_ORDER                           int                              NULL,
    C_BGCOLOR                         nvarchar(6)                      NULL,
    C_DESCRIPTION                     nvarchar(255)                    NULL,
    C_ISACTIVE                        char(1)                          DEFAULT 'T' NOT NULL,
    C_SHORTNAME                       nvarchar(30)                     NULL,
    C_DICTIONARYTYPEID                int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_DictionaryItemBase PRIMARY KEY (ID, C_INTEZMENYID, C_TANEVID)
)
GO
/*============================================================================*/
/* Table : T_TELEFON                                                              */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_TELEFON (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_TELEFONTIPUSA                   int                              DEFAULT 1019 NOT NULL,
    C_TELEFONSZAM                     nvarchar(100)                    NOT NULL,
    C_LEIRAS                          nvarchar(50)                     NULL,
    C_ALAPERTELMEZETT                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ISPUBLIC                        char(1)                          DEFAULT 'F' NOT NULL,
    C_ISMOBILROGZITETT                char(1)                          DEFAULT 'F' NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Telefon PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_SZEREPKOR                                                            */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_SZEREPKOR (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_SZEREPKORTIPUS                  int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Szerepkor PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_CIM                                                                  */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_CIM (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_CIMTIPUSA                       int                              DEFAULT 906 NOT NULL,
    C_ORSZAG                          int                              NOT NULL,
    C_IRANYITOSZAM                    nvarchar(20)                     NULL,
    C_VAROS                           nvarchar(50)                     NULL,
    C_MEGYE                           nvarchar(40)                     NULL,
    C_KOZTERULET                      nvarchar(40)                     NULL,
    C_HAZSZAM                         nvarchar(30)                     NULL,
    C_EPULET                          nvarchar(6)                      NULL,
    C_LEPCSOHAZ                       nvarchar(6)                      NULL,
    C_EMELET                          nvarchar(40)                     NULL,
    C_AJTO                            nvarchar(30)                     NULL,
    C_OSSZETETTCIM                    nvarchar(512)                    NULL,
    C_ALAPERTELMEZETT                 char(1)                          DEFAULT 'F' NOT NULL,
    C_KOZTERULETJELLEGENEV            nvarchar(50)                     NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Cim PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_EMAIL                                                                */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_EMAIL (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_EMAILTIPUSA                     int                              DEFAULT 1024 NOT NULL,
    C_EMAILCIM                        nvarchar(200)                    NOT NULL,
    C_ALAPERTELMEZETT                 char(1)                          DEFAULT 'T' NOT NULL,
    C_ISPUBLIC                        char(1)                          DEFAULT 'F' NOT NULL,
    C_GUID                            uniqueidentifier                 DEFAULT NEWID() NOT NULL,
    C_ISHIBASANMEGADVA                char(1)                          DEFAULT 'F' NOT NULL,
    C_ISMOBILROGZITETT                char(1)                          DEFAULT 'F' NOT NULL,
    C_GONDVISELOID                    int                              NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Email PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FELHASZNALO                                                          */
/*============================================================================*/
/* Package: Kreta */
  
CREATE TABLE  [dbo].T_FELHASZNALO (
    ID                                int                              NOT NULL IDENTITY(1,1),
    C_NEME                            int                              NOT NULL,
    C_SZULETESIDATUM                  datetime                         NOT NULL,
    C_SZULETESINEV                    nvarchar(64)                     NOT NULL,
    C_ANYJANEVE                       nvarchar(64)                     NOT NULL,
    C_SZULETESIHELY                   nvarchar(50)                     NULL,
    C_TAJSZAM                         nvarchar(9)                      NULL,
    C_ALLAMPOLGARSAGA                 int                              DEFAULT 217 NOT NULL,
    C_KERESESINEV                     nvarchar(61)                     NULL,
    C_SZULETESIORSZAG                 int                              DEFAULT 765 NOT NULL,
    C_SZULETESINEVSORREND             char(1)                          DEFAULT 'T' NOT NULL,
    C_ANYJANEVESORREND                char(1)                          DEFAULT 'T' NOT NULL,
    C_ALAPERTELMEZETTLCID             int                              NULL,
    C_LATASSERULTWEBHASZNALATA        char(1)                          DEFAULT 'F' NOT NULL,
    C_SMSSZAM                         int                              NULL,
    C_SMSSZINKRONIZALT                char(1)                          DEFAULT 'F' NULL,
    C_KELLADSZINKRONIZALAS            char(1)                          DEFAULT 'T' NOT NULL,
    C_SZULETESINEVELVALASZTO          int                              DEFAULT 0 NOT NULL,
    C_ANYJANEVEELVALASZTO             int                              DEFAULT 0 NOT NULL,
    C_DMSTARTTIME                     nvarchar(5)                      NULL,
    C_NYOMTATASINEV                   nvarchar(255)                    NOT NULL,
    C_UTONEV                          nvarchar(255)                    NOT NULL,
    C_VEZETEKNEV                      nvarchar(255)                    NOT NULL,
    C_ADOAZONOSITOJEL                 nvarchar(10)                     NULL,
    C_ELOTAG                          nvarchar(20)                     NULL,
    C_ANYANYELVE                      int                              DEFAULT 509 NOT NULL,
    C_IGAZOLVANYSZAM                  nvarchar(50)                     NULL,
    C_IGAZOLVANYTIPUSA                int                              NULL,
    C_NEVSORREND                      char(1)                          DEFAULT 'T' NOT NULL,
    C_NYILVANTARTASISZAM              nvarchar(50)                     NULL,
    C_NYILVANTARTASKEZDETE            datetime                         NOT NULL,
    C_OKTATASIAZONOSITO               nvarchar(20)                     NULL,
    C_OMKOD                           nvarchar(20)                     NULL,
    C_ALAIRAS                         nvarchar(max)                    NULL,
    C_PROFILKEP                       varbinary(max)                   NULL,
    C_KRETAKOD                        nvarchar(6)                      NULL,
    C_KIRAZONOSITO                    nvarchar(20)                     NULL,
    C_ALLAMPOLGARSAGA2                int                              NULL,
    C_FENNTARTOAZONOSITO              nvarchar(20)                     NULL,
    C_IMPORTALT                       char(1)                          DEFAULT 'F' NOT NULL,
    C_BELUGYALTALAZONOSITOTT          char(1)                          DEFAULT 'F' NOT NULL,
    C_UTOLSOADATFRISSITESIDOPONTJA    datetime                         NULL,
    C_EGYEDIAZONOSITO                 nvarchar(36)                     DEFAULT '00000000-0000-0000-0000-000000000000' NOT NULL,
    C_KRETAKURZUSOKLEVELSZAM          nvarchar(50)                     NULL,
    C_MEGJEGYZES                      nvarchar(2000)                   NULL,
    C_IDPEGYEDIAZONOSITO              uniqueidentifier                 DEFAULT '00000000-0000-0000-0000-000000000000' NOT NULL,
    C_ISCOVIDFERTOZOTT                char(1)                          DEFAULT 'F' NOT NULL,
    C_COVIDFERTOZESKEZDETEDATE        datetime                         NULL,
    C_ANYJAUTONEVE                    nvarchar(255)                    NULL,
    C_ANYJAVEZETEKNEVE                nvarchar(255)                    NULL,
    C_SZULETESIUTONEV                 nvarchar(255)                    NULL,
    C_SZULETESIVEZETEKNEV             nvarchar(255)                    NULL,
    C_ANYJANEVEELOTAG                 nvarchar(20)                     NULL,
    C_SZULETESINEVELOTAG              nvarchar(20)                     NULL,
    C_ISADOAZONOSITONELKUL            char(1)                          DEFAULT 'F' NOT NULL,
    C_ISOKTAZONNELKUL                 char(1)                          DEFAULT 'F' NOT NULL,
    C_ISTAJSZAMNELKUL                 char(1)                          DEFAULT 'F' NOT NULL,
    C_INTEZMENYID                     int                              NOT NULL,
    C_TANEVID                         int                              NOT NULL,
    TOROLT                            char(1)                          NOT NULL DEFAULT 'F',
    SERIAL                            int                              DEFAULT 0 NOT NULL,
    LASTCHANGED                       datetime                         DEFAULT GETDATE() NOT NULL,
    CREATED                           datetime                         DEFAULT GETDATE() NOT NULL,
    MODIFIER                          int                              NULL,
    CREATOR                           int                              NULL,
    CONSTRAINT PK_Felhasznalo PRIMARY KEY (ID)  
)
GO
/*============================================================================*/
/* Table : T_FELTOLTOTTFAJL_MEROALLAS                                         */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_FELTOLTOTTFAJL_MEROALLAS(

    C_FELTOLTOTTFAJLID                int                              NOT NULL,
    C_MEROALLASID                     int                              NOT NULL,
    CONSTRAINT PK_FeltoltottFajl_Meroallas PRIMARY KEY (C_FELTOLTOTTFAJLID,C_MEROALLASID)
)
GO
/*============================================================================*/
/* Table : T_AMIFOTARGY_AMIALTARGY                                            */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_AMIFOTARGY_AMIALTARGY(

    C_AMIFOTARGYID                    int                              NOT NULL,
    C_AMIALTARGYID                    int                              NOT NULL,
    CONSTRAINT PK_AMIFotargy_AMIAltargy PRIMARY KEY (C_AMIFOTARGYID,C_AMIALTARGYID)
)
GO
/*============================================================================*/
/* Table : T_FELTOLTOTTFAJL_TANITASIORA                                       */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_FELTOLTOTTFAJL_TANITASIORA(

    C_FELTOLTOTTFAJLID                int                              NOT NULL,
    C_TANITASIORAID                   int                              NOT NULL,
    CONSTRAINT PK_FeltoltottFajl_TanitasiOra PRIMARY KEY (C_FELTOLTOTTFAJLID,C_TANITASIORAID)
)
GO
/*============================================================================*/
/* Table : T_FELTOLTOTTFAJL_HAZIFELADATOK                                     */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_FELTOLTOTTFAJL_HAZIFELADATOK(

    C_FELTOLTOTTFAJLID                int                              NOT NULL,
    C_HAZIFELADATOKID                 int                              NOT NULL,
    CONSTRAINT PK_FeltoltottFajl_HaziFeladatok PRIMARY KEY (C_FELTOLTOTTFAJLID,C_HAZIFELADATOKID)
)
GO
/*============================================================================*/
/* Table : T_FELTOLTOTTFAJL_ORARENDIORA                                       */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_FELTOLTOTTFAJL_ORARENDIORA(

    C_FELTOLTOTTFAJLID                int                              NOT NULL,
    C_ORARENDIORAID                   int                              NOT NULL,
    CONSTRAINT PK_FeltoltottFajl_OrarendiOra PRIMARY KEY (C_FELTOLTOTTFAJLID,C_ORARENDIORAID)
)
GO
/*============================================================================*/
/* Table : T_TAVOLLETJELENTO_IKTATOTTDOKU                                     */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_TAVOLLETJELENTO_IKTATOTTDOKU(

    C_TAVOLLETJELENTOID               int                              NOT NULL,
    C_IKTATOTTDOKUMENTUMID            int                              NOT NULL,
    CONSTRAINT PK_TavolletJelento_IktatottDokumentum PRIMARY KEY (C_TAVOLLETJELENTOID,C_IKTATOTTDOKUMENTUMID)
)
GO
/*============================================================================*/
/* Table : T_KEPESITES_VEGZETTSEG                                             */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_KEPESITES_VEGZETTSEG(

    C_KEPESITESID                     int                              NOT NULL,
    C_VEGZETTSEGID                    int                              NOT NULL,
    CONSTRAINT PK_Kepesites_Vegzettseg PRIMARY KEY (C_KEPESITESID,C_VEGZETTSEGID)
)
GO
/*============================================================================*/
/* Table : T_OSZTALYCSOPORT_TANULOESEMENY                                     */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_OSZTALYCSOPORT_TANULOESEMENY(

    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_TANULOESEMENYID                 int                              NOT NULL,
    CONSTRAINT PK_OsztalyCsoport_TanuloEsemeny PRIMARY KEY (C_OSZTALYCSOPORTID,C_TANULOESEMENYID)
)
GO
/*============================================================================*/
/* Table : T_JOGOSULTFELHASZNALOK_HOZZARE                                     */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_JOGOSULTFELHASZNALOK_HOZZARE(

    C_JOGOSULTFELHASZNALOKID          int                              NOT NULL,
    C_HOZZARENDELTDOKSIKID            int                              NOT NULL,
    CONSTRAINT PK_JogosultFelhasznalok_HozzarendeltDoksik PRIMARY KEY (C_JOGOSULTFELHASZNALOKID,C_HOZZARENDELTDOKSIKID)
)
GO
/*============================================================================*/
/* Table : T_JOGOSULTSAG_FELHASZNALO                                          */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_JOGOSULTSAG_FELHASZNALO(

    C_JOGOSULTSAGID                   int                              NOT NULL,
    C_FELHASZNALOID                   int                              NOT NULL,
    CONSTRAINT PK_Jogosultsag_Felhasznalo PRIMARY KEY (C_JOGOSULTSAGID,C_FELHASZNALOID)
)
GO
/*============================================================================*/
/* Table : T_EVFOLYAMTIPUS_OKTATASINEVELE                                     */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_EVFOLYAMTIPUS_OKTATASINEVELE(

    C_EVFOLYAMTIPUSID                 int                              NOT NULL,
    C_OKTATASINEVELESIFELADATID       int                              NOT NULL,
    C_INTEZMENYID int                              NOT NULL,
    C_TANEVID int                              NOT NULL,
    CONSTRAINT PK_EvfolyamTipus_OktatasiNevelesiFeladat PRIMARY KEY (C_EVFOLYAMTIPUSID,C_OKTATASINEVELESIFELADATID, C_INTEZMENYID, C_TANEVID)
)
GO
/*============================================================================*/
/* Table : T_TANULO_TANULOESEMENY                                             */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_TANULO_TANULOESEMENY(

    C_TANULOID                        int                              NOT NULL,
    C_TANULOESEMENYID                 int                              NOT NULL,
    CONSTRAINT PK_Tanulo_TanuloEsemeny PRIMARY KEY (C_TANULOID,C_TANULOESEMENYID)
)
GO
/*============================================================================*/
/* Table : T_OSZTALYCSOPORT_TANEVRENDJE                                       */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_OSZTALYCSOPORT_TANEVRENDJE(

    C_OSZTALYCSOPORTID                int                              NOT NULL,
    C_TANEVRENDJEID                   int                              NOT NULL,
    CONSTRAINT PK_OsztalyCsoport_TanevRendje PRIMARY KEY (C_OSZTALYCSOPORTID,C_TANEVRENDJEID)
)
GO
/*============================================================================*/
/* Table : T_FELHASZNALO_SZEREPKOR                                            */
/*============================================================================*/
/* StartPackage: Kreta EndPackage: Kreta */
create table [DBO].T_FELHASZNALO_SZEREPKOR(

    C_FELHASZNALOID                   int                              NOT NULL,
    C_SZEREPKORID                     int                              NOT NULL,
    CONSTRAINT PK_Felhasznalo_Szerepkor PRIMARY KEY (C_FELHASZNALOID,C_SZEREPKORID)
)
GO
